program asset_policy_test

   !testing maximizing asset at all my states points and then constructing the asset policy function from that


use enum_mod
use model_params_mod
use interp_support_mod


use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use csv_file


implicit none


   character(len=30),parameter :: init_params_file = "init_params_july23.txt"
   character(len=30),parameter :: value_init_file = "value_matrix_out.csv"
   character(len=30),parameter :: asset_init_file = "asset_matrix_init.csv"
!   character(len=30),parameter :: interact_file = "interact_mostly_zero.csv"
   character(len=30),parameter :: interact_file = "interact_matrix.csv"

   character(len=30),parameter :: asset_out_file    = "asset_matrix_out.csv"
   character(len=30),parameter :: derivative_file   = "derivative_value_func.csv"

   logical, parameter :: read_ols_matrices = .true. !for whether to init the ols matrices with other files


   type(value_grid_type) :: value_grid
   real*8, dimension(n_grid_points ) :: value_matrix_init
   real*8, dimension(n_grid_points ) :: asset_matrix_init, asset_matrix_out
   real*8, dimension(n_params)  :: params

   integer:: m_job,job
   logical :: file_exists
   integer :: i,j, unit_int
   real*8 :: start,finish

   call mpi_setup

   if (myrank .eq. 0 ) print *, "init params file", init_params_file
   !now read in the parameters
   call init_params(init_params_file, params)

   call gen_labels
   call interp_setup_all( interact_file )
   call value_grid % setup( params )

   if (read_ols_matrices .eqv. .true. ) then
      call init_interp_matrices( value_init_file, asset_init_file, value_matrix_init, asset_matrix_init )

   else
      value_matrix_init = 0
      asset_matrix_init = 0

   end if



   if( myrank .eq. 0) print *, "about to get the utility parameters "
   call update_asset_utility_params( value_grid, params )

   if( myrank .eq. 0) print *, "about to get the policy function"
   call update_asset_policy_function ( value_grid, value_matrix_init, params, asset_matrix_out )


   if( myrank .eq. 0 ) print *, "done with getting the policy funciton"


   if( myrank .eq. 0 ) then

      print *, "writting the interp coefficients"
      open(newunit = unit_int, file=asset_out_file, status='replace' )
      call interp_matrix_write(asset_matrix_out,unit_int )
      close(unit_int)

!      !now gettign derivative
!      print *, "getting derivatives"
!      open( unit=1,file= derivative_file )
!      call value_derivative_write( value_matrix_init, asset_matrix_out, 1 )
!      close(1)

   end if


!   print *, "check the value grid and iterate objects for errors"
!   do m_job = 0,1
!   do job = 0,1
!      print *, "job, m_job", job, m_job
!      call value_grid(job,m_job) % check()
!   end do
!   end do

!   print *, "wrtting output to import into stata"
!   call value_asset_reg_write( value_grid(0,0) , stata_file )

!   print *, "printing the values I get"
!   do m_job = 0,1
!   do job = 0,1
!      print *, "job, m_job", job, m_job

!      do i=1, value_grid(job,m_job) % n_state_points
!         print *, i, value_grid(job,m_job) % y(i)
!      end do

!   end do
!   end do





   call mpi_finalize(err)

end program
