

program gen_param_est_table


use enum_mod
use model_params_mod
use latex_tables_mod

   integer, parameter :: arg_no_params_file = 1
   character(len=30)   :: mcmc_output_file
   character(len=30), parameter   :: results_latex_file =    "params_est_latex.tex"

   real*8, dimension(n_main_params) :: coef, sd
   integer :: i, unit_int
   character(len=30) :: char_ignore

   real*8 :: prob_base, prob_ur, prob_length
   real*8 :: asset_real, asset_error_sd

   call get_command_argument(arg_no_params_file, mcmc_output_file  )

   open(newunit = unit_int, file = mcmc_output_file, status = "old" )
   read(unit_int, *)
   read(unit_int, *)


   do i = 1 , n_main_params
      read(unit_int, * ) char_ignore, coef(i), sd(i)
   end do

   call gen_param_est_table_latex( coef, sd, results_latex_file )

   !now print a marginal effect I display in my paper
   print *, "  "
   print *, " "
   print *, "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
   print *, "   "
   print *, "   "

   prob_base = logit_prob( coef(param_joboffer_cons) + &
                           coef(param_joboffer_ur)*9 + &
                           coef(param_joboffer_unemp_length)*6 )

   prob_ur = logit_prob( coef(param_joboffer_cons) + &
                           coef(param_joboffer_ur)*10 + &
                           coef(param_joboffer_unemp_length)*6 )

   prob_length = logit_prob( coef(param_joboffer_cons) + &
                           coef(param_joboffer_ur)*9 + &
                           coef(param_joboffer_unemp_length)*7 )

   print *, "base probability (in %)", prob_base*100
   print *, "effect from 1% point increase in ur", (prob_ur - prob_base)*100
   print *, "effect from 1 month increase in unemployment length", (prob_length - prob_base)*100


   asset_real = 30000
   asset_error_sd = exp(   coef( param_asset_error_cons ) + &
               coef( param_asset_error_linear )* abs(asset_real) )


   print *, "asset_error_sd when real assets are ", asset_real, "=", asset_error_sd



   print *, "   "
   print *, "    "
   print *, "!!!!!!!!!!!!!!!!!!!!!!!!!!!"

end program

