program ind_accept_test
!test the accept/reject for the individual parameters

use enum_mod
use model_params_mod
use interp_support_mod

use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use likelihood_mod
use bayesian_mod

use csv_file
use random_gen_mod
use mpi_mod


   character(len=30),parameter :: init_params_file = "init_params_simple5.txt"
   character(len=30),parameter :: sipp_data_file= "sipp_fortran_small.csv"
   character(len=30), parameter :: interact_file_in  = "interact_matrix.csv"
   character(len=30), parameter :: seed_file = "seed_save5.txt"


   character(len=30),parameter :: value_init_file   = "value_matrix_out.csv"
   character(len=30),parameter :: asset_init_file   = "asset_matrix_out.csv"

   type(bayes_obj_type) :: bayes_obj
   type(like_type), dimension(:), allocatable :: like_object
   type(like_target_type), dimension(:), allocatable :: like_target
   type(data_i_type), dimension(:), allocatable ::  hh_data

   real*8, dimension(iter_m_job_offer: iter_hours,N_t,N_obs_total) :: joboffer_random
   real*8, dimension(N_obs_total) ::  mh_random
   real*8, dimension(n_main_params) :: params_old, params_new
   integer :: i, t,j,block_in,n_params_block_in
   integer, dimension(:), allocatable :: block_in_list


   integer, parameter :: i_print = 11
   integer, parameter :: t_print = 11


   call mpi_setup()


   !first setup based on block of interest
   block_in = block_joboffers_ind

   if ( myrank .eq. 0 ) then

      print *, "i_print ", i_print
      print *, "t_print ", t_print
      print *, " "

   end if

   !initialize random numbers
   call init_random_seed_mpi(same = .false. )
   call export_random_seed_mpi( seed_file )
 !  call read_random_seed_mpi( same = .false., filename_opt = seed_file)

   call gen_labels()
   call interp_setup_all(interact_file_in)

   call read_sipp_data(sipp_data_file, hh_data)
   call bayes_obj % setup(init_params_file)

   bayes_obj % iter = 1

   !read in other ols vecs if I want
   if (read_interp_matrices .eqv. .true. ) then
      call init_interp_matrices( value_init_file, asset_init_file, &
         bayes_obj % value_matrix_current, bayes_obj % asset_matrix_current )

   else
      bayes_obj % value_matrix_current = 0
      bayes_obj % asset_matrix_current = 0
      bayes_obj % asset_matrix_current(1) = 2.9957322735539909

   end if


   if ( myrank .eq. 0 ) print *, "about to setup like object"

   call like_setup_all( hh_data, &
                        bayes_obj % params_current, &
                        est_savings, &
                        bayes_obj % value_matrix_current, &
                        bayes_obj % asset_matrix_current, &
                        like_object, &
                        like_target )


   if ( myrank .eq. 0 ) print *, "done with setup"

   if ( myrank .eq. 0 ) print *, "   "


 !  do i=1,100
   call random_number(joboffer_random)
   call random_number(mh_random)


 !  joboffer_random(iter_m_job_offer,t_print,i_print) = 0
 !  joboffer_random(iter_job_offer,t_print,i_print) = 0


 !  joboffer_random = 0


  ! call get_new_joboffers_ind(like_object(i_print), bayes_obj % params_current, &
  !    joboffer_random(:,:,i_print) )




   call mh_step_ind( bayes_obj, block_in, hh_data, like_object, like_target, &
                     joboffer_random(:,:,min_obs:max_obs), mh_random(min_obs:max_obs) )

   if ( myrank .eq. 0 ) then
      print *, "iter?", bayes_obj % iter
      print *, "percent accepted", dble(bayes_obj % accept_history_ind(1))/N_obs_total
   end if



 !  end do

!   !now print out the parameters that are drawn

!   if ( ( i_print .ge. min_obs) .and. ( i_print .le. max_obs ) ) then

!      print *, "   "
!      print *, "-----------------------------------------"
!      print *, "   "


!!      print *, "now printing the likelihood object"
!!      call like_object(i_print) % print(t_print)

!     print *, "now print like targets"
!      call like_target(i_print) % print(like_object(i_print), t_print)

!   !   print *, "   "
!   !   print *, "-----------------------------------------"
!   !   print *, "   "

!   !   print *, "now print associations between the like targets"
!   !   call like_object(i_print) % print_which_like_target(like_target(i_print))


!   end if

!!   print *, "key ui data", hh_data(i_print) % data_t(1) % m_ui_ever

   if( myrank .eq. 0 ) print *, "hunting for errors"

   do i=min_obs,max_obs
      call like_object(i) % like_error_hunt(i)
   end do

   call mpi_finalize(err)


end program
