program iterate_one_point_test

   !test to see if iterating the value function for one point works

use enum_mod
use model_params_mod
use interp_support_mod


use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use csv_file

implicit none


   character(len=30), parameter :: seed_file = "seed_save6.txt"
   character(len=30), parameter :: interact_file = "interact_matrix.csv"

   character(len=30), parameter :: grid_point_file = "grid_points.csv"

   integer :: i, j, unit_int
   real*8, dimension(n_interp_vars, n_grid_points) :: grid_points
   type(mygrid_type) :: mygrid_temp
   type(mygrid_type), dimension(n_grid_points) :: mygrid_vec
   real*8, dimension(n_grid_points) :: values, values_predict
   real*8, dimension(n_grid_points) :: interp_coef



   call mpi_setup()

 !  call init_random_seed_mpi(same = .false. )
 !  call export_random_seed_mpi( seed_file )
   call read_random_seed_mpi( same = .false., filename_opt = seed_file)

   call interp_setup_all( interact_file )



   !get grid points and convert then to the mygrid object
   call gen_grid_points( grid_points ) !all these points are on the -1,1 hypercube
   do i = 1, n_grid_points
      call interp_to_mygrid( grid_points(:,i), .true. , mygrid_vec(i) )
   end do

   !now generate random values that I'll try to repredict
   call random_number( values )
   values = values * 10


   !now get the interpolation coefficients
   call gen_interp_coef( values, interp_coef )
   print *, "got interpolation coefficients"




   !now repredict
   do i = 1, n_grid_points
      values_predict(i) = interp_func( grid_points(:,i), interp_coef )

   end do

   print *, "got predicted values"


   !now print differences that are large
!   print *, "now printing sizable differences"

!   do i = 1, n_grid_points
!      if ( abs( values(i) - values_predict(i) ) > zero_tol ) then
!         print *, grid_labels(i), values(i), values(i) - values_predict(i)

!      end if

!   end do



!   do i = n_grid_points -1, n_grid_points


!      do j =1 , n_interp_vars
!         print *, interp_var_labels(j), grid_points(j, i )
!      end do

!      values_predict(i) = interp_func( grid_points(:,i), interp_coef )

!      print *, grid_labels(i), values(i), values_predict(i), values(i) - values_predict(i)


!   end do



   print *, " label        actual values     predicted values     error    "
  do i = 1, n_grid_points

      print *, grid_labels(i), values(i), values_predict(i), values(i) - values_predict(i)

   end do

   print *, " "
   print *, "sum of differences",  sum( abs( values(:) - values_predict(:) ) )


!   read(*,*)

!   print *, "   "
!   print *, "   "

!   do i = 1, n_grid_points

!      print *, grid_labels(i), interp_coef(i)

!   end do








end program

