program iterate_one_point_test

   !test to see if iterating the value function for one point works

use enum_mod
use model_params_mod
use interp_support_mod


use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use csv_file

implicit none


   character(len=30), parameter :: seed_file = "seed_save6.txt"
   character(len=30), parameter :: interact_file = "interact_matrix.csv"

   character(len=30), parameter :: grid_point_file = "grid_points.csv"

   integer :: i, unit_int
   real*8, dimension(n_interp_vars, n_grid_points) :: grid_points
   type(mygrid_type) :: mygrid_temp



   call mpi_setup()

   call init_random_seed_mpi(same = .false. )
   call export_random_seed_mpi( seed_file )
  ! call read_random_seed_mpi( same = .false., filename_opt = seed_file)

   call interp_setup_all( interact_file )
   call gen_grid_points( grid_points ) !all these points are on the -1,1 hypercube


   open( newunit = unit_int, file = grid_point_file, status = "replace" )
   call csv_write( unit_int, "point #", .false. )
   call csv_write( unit_int, interp_var_labels, .true. )

   do i=1, n_grid_points
      call csv_write( unit_int, i, .false. )
      call csv_write( unit_int, grid_points(:,i), .true. )

   end do

   close(unit_int)


   print *, "wrote to file"


   do i =1 , n_grid_points
      call interp_to_mygrid( grid_points(:,i), .true. , mygrid_temp )
      call mygrid_temp % mygrid_error_hunt( .true., .true., i, 1, 1 )

   end do

   call mygrid_temp % print( .true. , .true. )


   print *, "checked all the points for errors"


end program

