program ols_kernel_test

!tests the ols kernel weighting stuff

use enum_mod
use model_params_mod
use interp_support_mod

use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use likelihood_mod
use bayesian_mod

use csv_file
use random_gen_mod

   type(bayesian_object_type) :: bayesian_object
   type(mcmc_output_type):: mcmc_output
   
   character(len=30),parameter :: init_params_file = "init_params_new.txt"
   real*8, dimension(n_main_params) :: params_init
 
   integer :: i,b
 !  allocate(mcmc_output)
 !  print *, "allocated mcmc_output"
 !  read(*,*)
   
   
   
   
   !initialize random numbers
   call init_random_seed()
   call export_random_seed()
  ! call read_random_seed()

   print *, "about to setup objects"
  
 !  call read_sipp_data( hh_data )
   call bayesian_object % setup( init_params_file )
   params_init(:n_main_params) = bayesian_object % params_current(:n_main_params)
   
   call gen_labels()
   bayesian_object % iter = max_iter_saved
   bayesian_object % iter_saved = max_iter_saved
  
          
   call random_number(bayesian_object % past_ols_matrix)      
                        
   !now gets ols vectors for random nearby parameters
   do i= 2, max_iter_saved 
   
      do b=1, n_blocks_params
         call draw_new_params(b, bayesian_object % params_current, bayesian_object % params_proposal)
      end do
      
      !draw random heterogeneity params
      bayesian_object % params_proposal( param_hetero_m_wage_var ) = &
         bayesian_object % params_proposal( param_hetero_m_wage_var ) + .001*rnorm()
      bayesian_object % params_proposal( param_hetero_wage_var ) = &
         bayesian_object % params_proposal( param_hetero_wage_var ) + .001*rnorm()
      bayesian_object % params_proposal( param_hetero_wage_covar ) = & 
         bayesian_object % params_proposal( param_hetero_wage_covar ) + .001*rnorm()
      
      
      bayesian_object % past_params_proposal(:,i) = bayesian_object % params_proposal
      bayesian_object % params_history(:,i) = bayesian_object % params_proposal
      
   end do 
   
   call mcmc_output % create(bayesian_object)
   call mcmc_output % write(params_init)
   call mcmc_output % read()
   call mcmc_output % write(params_init)
   
   

end program 









