
program model_fit_test1

!tests the likelihood evaluated for the whole sample

!code uses like_test_onepoint as a template

use enum_mod
use model_params_mod
use interp_support_mod

use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use likelihood_mod
use sipp_data_mod

use normal_mod
use stat_estimates_mod

use bayesian_mod
use model_fit_mod

use csv_file

!use statespace_trans_params_mod


implicit none

   integer, parameter :: i_test_index = 249 !household of interest
   integer, parameter :: t_test_index = 27 !time index of interest

   character(len=30),parameter :: init_params_file       = "output_params.txt"
   character(len=30),parameter :: sipp_data_file         = "sipp_fortran_small.csv"
   character(len=30),parameter :: interact_file      = "interact_matrix.csv"
   character(len=30), parameter  :: seed_file = "seed_save_sim1.txt"

   character(len=30),parameter :: value_matrix_init_file = "value_matrix_out.csv"
   character(len=30),parameter :: asset_matrix_init_file = "asset_matrix_out.csv"


   type(data_i_type), dimension(:), allocatable   :: hh_data
   type(like_type)   :: like_object
   type(like_target_type),target :: like_target
   real*8, dimension(n_params) :: params
   real*8, dimension( n_grid_points ) :: value_matrix_init
   real*8, dimension( n_grid_points ) :: asset_matrix_init
   integer :: i,t

   type(mygrid_type) :: mygrid_temp

   real*8, dimension(4,2:N_t) :: prob_matrix

   call mpi_setup()

  ! call init_random_seed_mpi(same = .false. )
  ! call export_random_seed_mpi( seed_file )
   call read_random_seed_mpi( same = .false., filename_opt = seed_file)

   if (nprocs .ne. 1 ) then
      print *, "should only be one process for this program, stopping"
   end if

   call read_sipp_data(sipp_data_file, hh_data)
   print *, "read in data"


  ! hh_data(i_test_index) % data_t(t_test_index) % seam = 1

   print *, "seam", hh_data(i_test_index) % data_t(t_test_index) % seam

  ! hh_data(i_test_index) % data_t(1) % m_wage = 30
  ! hh_data(i_test_index)  % liquid_net1 = 1000
  ! hh_data(i_test_index) % ui_ben_init = 300
  ! hh_data(i_test_index) % data_t(1) % ui_ever = 1
  ! hh_data(i_test_index) % min_unemp_length = 0
  ! hh_data(i_test_index) % max_unemp_length = 0
  ! hh_data(i_test_index) % max_unemp_length = 0

  ! hh_data(i_test_index) % data_t(t_test_index) %  ur_state = 12

   !now read in the parameters
   call init_params(init_params_file, params)
   !change the discount factor for initial testing
 !  params(param_discount_factor) = .1

   call interp_setup_all( interact_file )

   call init_interp_matrices( value_matrix_init_file, asset_matrix_init_file, value_matrix_init, asset_matrix_init )






 ! print *, "read in parameters complete"

   !now for calling all the likelihood subroutines



   i = i_test_index
   t = t_test_index

   call like_target % allocate( hh_data(i) )
   call like_object % like_init_pointer( like_target, hh_data(i) )

   !call like_object % print(t)

  call like_object % like_main_setup( hh_data(i) )


   !changing some more things here
 !  like_object % mygrid_t_var(t) % rv( var_m_unemp_length ) = 10
 !  like_object % mygrid_wife_accept(t) % rv( var_m_unemp_length ) = 10

  ! like_object % mygrid_t_var(t) % rv( var_unemp_length ) = 10
  ! like_object % mygrid_husband_accept(t) % rv( var_unemp_length ) = 10

  ! like_object % mygrid_t_var(t) % rv( var_ur_state ) = 10
  ! like_object % mygrid_husband_accept(t) % rv( var_ur_state ) = 10
  ! like_object % mygrid_wife_accept(t) % rv( var_ur_state ) = 10
  ! like_object % mygrid_both_accept(t) % rv( var_ur_state ) = 10


   !!!!!!!!!!!!!1
   !!!!!!!!!!!!!!
   !!!!!!!!!!!!!!!

   !making some changes here
  ! like_object % hetero(1) = -5
  ! like_object % hetero(2) = -5


   !!!!!!!!!!!!!!
   !!!!!!!!!!!!!!



   !   print *, hh_data(i) % data_t(t) % m_job_no
   !   read(*,*)

 !  call like_object % get_birth_ui_means( hh_data(i), params)
   call like_target % copy_targets_init()

!   !now initialize the other parts
   call like_object % joboffer_like_update( hh_data(i), params )
   call like_object % job_probs_like_update( hh_data(i), params )
   call like_object % utility_params_like_update( hh_data(i), params )

! commenting out the followig likes because of the  "like_max_value" subroutine
!   call like_object % asset_choice_like_update( asset_matrix_init, params  )
!   call like_object % utility_like_update( params )
!  ! call like_object % jobloss_like_update( hh_data(i), params )
!   call like_object % choice_prob_like_update( value_matrix_init )




   call like_object % like_max_value( params, value_matrix_init )



   call like_object % asset_error_prob_like_update( hh_data(i), params )




   !now print the object
  ! call like_object % print(t,value_matrix_init)




   !hunt for errors
  ! call like_error_hunt(like_object ,i)


   !now print the likelihood object
   call like_object % print(t)


   !now get the simulated probabilities

   call gen_predicted_probs( hh_data(i), params, value_matrix_init,  &
      like_object, like_target, prob_matrix )

   print *, "simulated choice probs"
   print "(A15,F9.4)", " both reject", prob_matrix(1,t)
   print "(A15,F9.4)", "husband accept", prob_matrix(2,t)
   print "(A15,F9.4)", "wife accept", prob_matrix(3,t)
   print "(A15,F9.4)", "both accept", prob_matrix(4,t)


   call mpi_finalize(err)


end program
