
module enum_mod !contains enumeration declarations

   enum, bind(c) !names the possible combination of discete variables, broken up by stage of my model
      enumerator :: both_job=1, husband_job=2, wife_job=3, both_nojob=4
   end enum

   enum, bind(c) !for the accept and reject choices
      enumerator :: index_both_reject=1, index_husband_accept=2, index_wife_accept=3, index_both_accept=4
   end enum

   enum, bind(c) !names of blocks to draw
      enumerator :: &

         block_joboffer_params1        = 1, &
         block_joboffer_params2        = 2, &
         block_wage_params1            = 3, &
         block_wage_params2            = 4, &
         block_wage_params3            = 5, &
         block_leisure_params1         = 6, &
         block_leisure_params2         = 7, &
         block_leisure_params3         = 8, &
         block_leisure_params4         = 9, &
         block_asset_error_params1     = 10, &
         block_asset_error_params2     = 11, &
         block_joboffers_ind           = 12, &
         block_unemp_length            = 13, &
         block_get_like_all            = 14 !last one used to construct the likelihood contributions using all the components
   end enum

   enum, bind(c) !name for main parameters
      enumerator :: &

         param_joboffer_cons =            1, &
         param_joboffer_ur =              2, &
         param_joboffer_work =            3, &
         param_joboffer_job_length =      4, &
         param_joboffer_unemp_length =    5, &
         param_joboffer_gender =          6, &
         param_joboffer_seam =            7, &

         param_wage_cons =                8, &
         param_wage_pt =                  9, &
         param_wage_ur =                  10, &
         param_wage_age =                 11, &
         param_wage_age2 =                12, &
         param_wage_race =                13, &
         param_wage_hs =                  14, &
         param_wage_some_college =        15, &
         param_wage_college =             16, &
         param_wage_gender =              17, &

         param_m_leisure_cons =           18, &

         param_leisure_cons =             19, &
         param_leisure_kids =             20, &
         param_leisure_youngest =         21, &
         param_gender_reverse =           22, &

         param_hetero_m_wage_var =        23, &
         param_hetero_wage_var =          24, &
         param_hetero_wage_covar =        25, &

         param_sd_wage =                  26, &
         param_prob_pt =                  27, &

         param_sd_non_pec =               28, &
         param_weight_utility =           29, &
         param_rra =                      30, &    !rra=relative risk adversion

         param_asset_error_cons =         31, &
         param_asset_error_linear =       32

   end enum

   enum, bind(c) !name for parameters that don't change
      enumerator :: &
         !stopped here for a sec


         param_jobloss_cons =             33, &
         param_jobloss_ur =               34, &
         param_jobloss_job_length =       35, &
         param_jobloss_gender =           36, &
         param_jobloss_seam_future =      37, & !want the seam dummy for the next time period


         param_ui_cons =               38, &
         param_ui_ur =                 39, &
         param_ui_gender =             40, &

         param_birth_cons =            41, &
         param_birth_kids =            42, &
         param_birth_youngest =        43, &

         param_state_ur_cons =         44, &
         param_state_ur_on_state_ur =  45, &
         param_state_ur_sd =           46, &

         param_sd_m_wage_error =       47, & !get these values from krueger and bound
         param_sd_wage_error =         48, &

         param_asset_lb =              49, &
         param_min_cons_val =          50, &
         param_bankruptcy_prob =       51, &
         param_interest_rate  =        52, &

         param_discount_factor =       53

       !future parameter to add
      !   param_nat_ur_cons = 68,
      !   param_nat_ur_on_nat_ur = 69,
      !   param_nat_ur_on_state_ur = 70,
      !   param_nat_ur_sd = 71,

   end enum

   !enumerators for state variables
   enum, bind(c)
      enumerator :: &

         !time-invariante vars
         var_m_wage_mean =        1, &
         var_wage_mean =          2, &

         !ones that vary
         var_ur_state =           3, &
         var_uimax =              4, &  !maximum amount of ui benefits that can be received
         var_uilength =           5, &   !max length of time ui benefits can be received
         var_kids =               6, &
         var_youngest =           7, &
         var_assets =             8, &

         !job related variables
         var_m_wage =             9, &
         var_wage =               10, &
         var_m_non_pec_norm =     11, & !this is the non-pecuniary benefit divided by the variance
         var_non_pec_norm =       12, &
         var_m_ui_ben =           13, &
         var_ui_ben =             14, &

         var_m_job_length =       15,  &
         var_job_length =         16,  &
         var_m_unemp_length =     17,  &
         var_unemp_length =       18



   end enum

   !used for constructing derivatives of choice probabilities
   enum, bind(c)
      enumerator :: &

         var_m_wage_new =             19, &
         var_wage_new =               20, &
         var_m_non_pec_norm_new =     21, & !this is the non-pecuniary benefit divided by the variance
         var_non_pec_norm_new =       22

   end enum

   !state variables that are integers
   enum, bind(c)
      enumerator :: &

         var_m_job =    1, &
         var_job =      2, &
         var_m_hours =  3, &
         var_hours =    4

   end enum

   !ennumerators used for interpolation
   enum, bind(c)
      enumerator :: &

         !doing discrete variables first
         interp_m_job =              1, &
         interp_job =                2, &
         interp_m_pt =               3, &
         interp_pt =                 4, &
         interp_m_no_ui =            5, &
         interp_no_ui =              6, &

         !time-invariante vars
         interp_m_wage_mean =        7, &
         interp_wage_mean =          8, &

         !ones that vary
         interp_ur_state =           9, &
         interp_kids =               10, &
         interp_youngest =           11, &
         interp_assets =             12, &

         !job related variables
         interp_m_wage =             13, &
         interp_wage =               14, &
         interp_m_non_pec_norm =     15, & !this is the non-pecuniary benefit divided by the variance
         interp_non_pec_norm =       16, &
         interp_m_ui_ben =           17, &
         interp_ui_ben =             18, &

         interp_m_job_length =       19,  &
         interp_job_length =         20,  &
         interp_m_unemp_length =     21,  &
         interp_unemp_length =       22,  &


         !these are extra variables I'm creating for interpolation


         interp_m_ui_ben_pot =       23, & !this is the ui ben the individual would get if they lost their job
         interp_ui_ben_pot =         24, &
         interp_m_ui_left    =       25,  &  !how many weeks left of ui.  This goes from 1 to 99 and is only present when the individual is receiving ui benefits
         interp_ui_left    =         26




   end enum

   !these are for variables used to construct the utilty function
      !these are the state variabls that are really integers, but I need to store them as reals for the interpolation
   enum, bind(c)
      enumerator :: &

         util_cons_weight        = 1, &
         util_m_leisure_weight   = 2, &
         util_leisure_weight     = 3

   end enum

   enum, bind(c)
      enumerator :: &
         !these enumerators are for the random numbers used to interate the value function.
         iter_birth        = 1, &
         iter_m_jobloss    = 2, &
         iter_m_ui         = 3, &
         iter_jobloss      = 4, &
         iter_ui           = 5, &
         iter_m_job_offer  = 6, &
         iter_job_offer    = 7, &
         iter_m_hours      = 8, &
         iter_hours        = 9
   end enum

   enum, bind(c)
      enumerator :: &
         !these enumerators are used for simulating path involving random normals
         iter_norm_ur            = 1, &
         iter_norm_m_wage        = 2, &
         iter_norm_m_non_pec     = 3, &
         iter_norm_wage          = 4, &
         iter_norm_non_pec       = 5
   end enum

   !ennumeratores for unobsered heterogeneity
   enum, bind(c)
      enumerator :: &
         hetero_m_wage  = 1, &
         hetero_wage    = 2
   end enum

   enum, bind(c) !indicators for my output functions
      enumerator :: dv_choice_prob_husband = 1, dv_choice_prob_wife = 2
   end enum





end module enum_mod


module string_mod

    implicit none
    interface string_conv
        module procedure int_to_string
        module procedure real8_to_string
    end interface

   integer,parameter :: string_int_length =  12 !length of a string that represents an integer, this is the lenght for huge(0)
   integer,parameter :: string_real8_length = 26 !length of a string that represents an integer, this is the length for huge(0.0) for the GNU compiler, for the Intel compiler, it was 24


contains

function int_to_string(int_in)

   character(len=string_int_length) :: int_to_string
   integer, intent(in) :: int_in

   integer :: abs_int, digits
   character(len=1) :: char_len1
   character(len=2) :: char_len2

   abs_int = abs(int_in)

   !get number of significant digits.  The number of significant digits for huge(0.0) is 9
   digits = 1
   do while( ( digits < 10 ) .and. ( abs_int >= 10**digits ) )
      digits = digits +1
   end do

  ! if ( digits .eq. 10 ) digits = digits + 1 !function wasn't working for digits = 9 without this function

   if ( int_in < 0 ) then
      digits = digits + 1
   end if



   if (digits< 10 ) then
      write(char_len1, "(I1)" ) digits
      write( int_to_string,"(I" // char_len1 // ")" ) int_in
   else
      write(char_len2, "(I2)" ) digits
      write( int_to_string,"(I" // char_len2 // ")" ) int_in
   end if

 !  print *, "digits", digits



end function int_to_string



function real8_to_string(real8_in)

   character(len=string_real8_length) :: real8_to_string
   real*8, intent(in) :: real8_in

   write(real8_to_string,*) real8_in


end function real8_to_string



end module string_mod



module misc_funcs_mod
   !assortment of function I use
   use string_mod

contains

elemental function nan_inf_check(real_in)
   !checks whether a real number with name given by name_char_in is equal to nan or +-infinity
   real*8, intent(in) :: real_in
   logical :: nan_inf_check

   if ( isnan(real_in) .or. (real_in < -huge(0.0D+0) ) .or. (real_in > huge(0.0D+0) ) ) then
      nan_inf_check = .true.
   else
      nan_inf_check = .false.
   end if

end function nan_inf_check


function first_derivative_func( high_in, low_in, h_in )
   !gets the first derivative, using two sides
   real*8 :: first_derivative_func
   real*8, intent(in) :: high_in, low_in, h_in

   first_derivative_func = (high_in - low_in)/(2*h_in)

end function first_derivative_func


function second_derivative_func( high_in, low_in, origin_in, h_in )
   !gets the second derivative, using two sides
   real*8 :: second_derivative_func
   real*8, intent(in) :: high_in, low_in, origin_in, h_in

   second_derivative_func = (high_in -2*origin_in + low_in)/(h_in*h_in)

end function second_derivative_func

function cross_partial_func( high1_high2_in, high1_low2_in, low1_high2_in, low1_low2_in, h1_in, h2_in )
   real*8 :: cross_partial_func
   real*8, intent(in) :: high1_high2_in, high1_low2_in, low1_high2_in, low1_low2_in, h1_in, h2_in

   cross_partial_func = ( high1_high2_in - high1_low2_in - low1_high2_in + low1_low2_in )/ &
      (4*h1_in*h2_in)


end function cross_partial_func

elemental function bounds_func ( x_in, min_in, max_in )
   !makes sure x is between min_in and max_in
   real*8 :: bounds_func
   real*8, intent(in) :: x_in, min_in, max_in

   bounds_func = max( min( x_in, max_in ) , min_in )

end function

function evenly_spaced_func( n_nodes, a, b) result(vec)
   !generates evenly spaced nodes on interval [a,b]
   integer :: n_nodes
   real*8 :: a, b
   real*8, dimension(n_nodes) :: vec

   real*8 :: length_interval
   integer :: i

   length_interval = (b-a)/( n_nodes - 1 )

   vec(1) = a

   do i=2, n_nodes
      vec(i) = vec(i-1) + length_interval
   end do

end function evenly_spaced_func

subroutine round_sub( real_inout, dec_int_in )
   !rounds a real number to dec_int_in decimal places
   real*8, intent(in out) :: real_inout
   integer :: dec_int_in

   real*8 :: factor

   factor = (dble(10) ** dec_int_in)

   real_inout = nint( real_inout * factor ) / factor

end subroutine round_sub




end module misc_funcs_mod


module model_params_mod
!module for the parameters of my model
use enum_mod
use logit_mod
use misc_funcs_mod

implicit none

   integer, parameter :: n_main_params= 32
   integer, parameter :: n_nochange_params=53-n_main_params
   integer, parameter :: n_params = n_main_params + n_nochange_params
   integer, parameter :: n_hetero  = 2 ! number of unobserved heterogeneity terms

   integer, parameter :: output_len = 100 !length of characters for output labels

   integer, parameter :: max_job_length = 24 ! the maximum length of time with a job or unemploye

 !  character(30), parameter :: init_params_file="./init_params_est.txt" !file for reading in initial parameters
  ! character(30), parameter :: init_params_file="./init_params_est_beta0.txt" !file for reading in initial parameters
 !  character(30), parameter :: init_params_file="./params_final_beta99.txt" !file for reading in initial parameters

   real*8, parameter :: min_prob_val = 1.0D-15 !puts bounds on what the pt joboffer prob can be, comes from needing 1-min_prob_val to not equal 1

   real*8 :: replacement_rate_param = .5 !the ui replacement rate that I'm making the same for everyone now

   integer, parameter :: n_t_invar = 2 !number of time invariant variables
   integer, parameter :: n_t_var = 16 !number of time variante variables (not including job indicators and hours)
   integer, parameter :: n_cont_vars = n_t_invar + n_t_var !# variables stored as reals
   integer, parameter :: n_int_vars = 4 !number of variables that are integers

   integer, parameter :: n_like_vars = n_cont_vars +4

   character(len=30), dimension(n_cont_vars) :: var_labels
   character(len=output_len), dimension(n_like_vars) :: var_labels_long
   character(len=30), dimension(n_like_vars) :: like_var_labels
   character(len=30), dimension(n_params) :: param_labels

   real*8, parameter :: zero_tol = 1.0D-14 !check for if certain parameters are close to 0

   real*8, dimension(n_like_vars) :: der_delta !controlls how much to increase state variables by when constructing derivatives

   !following parameters used to set of a grid for interating the value function with OLS interpolation

   real*8, parameter :: week_to_month_convert = 4.34812 !converts weekly income to montly income (number from google's number converter)


   type :: mygrid_type
   !this datastructures contains pointers for refering to state variables that are both real and intergers.
      !the real variable contains double precession duplicates of the integer variables, which are useful for the interpolation function
      !these components are allocable because sometime I want this object to contain variables that change over time, and other times
         !I don't want this
      real*8,  dimension(:), allocatable :: rv !for real variable
      integer, dimension(:), allocatable :: iv !for integer variable

      real*8, dimension(:), allocatable :: iter !containing iteration variables, used for iterating the value function


   contains
      procedure :: print => print_mygrid
      procedure :: allocate => mygrid_allocate
      procedure :: t_var_allocate => mygrid_t_var_allocate
      procedure :: iter_allocate => mygrid_iter_allocate
      procedure :: mygrid_error_hunt => mygrid_error_hunt

   end type mygrid_type



contains



subroutine gen_var_labels()
!generates labels for the variables
  ! var_labels( var_m_joboffer_mean ) =  'm_joboffer_mean'
  ! var_labels( var_joboffer_mean )=       "joboffer_mean"
   var_labels( var_m_wage_mean )=         "m_wage_mean"
   var_labels( var_wage_mean )=           "wage_mean"
 !  var_labels( var_m_leisure_mean )=      "m_leisure_mean"
 !  var_labels( var_leisure_mean )=        "leisure_mean"
 !  var_labels( var_m_jobloss_mean )=      "m_jobloss_mean"
 !  var_labels( var_jobloss_mean )=        "jobloss_mean"
 !  var_labels( var_m_ui_mean )=           "m_ui_prob_mean"
 !  var_labels( var_ui_mean )=              "ui_prob_mean"
 !  var_labels( var_birth_mean )=           "birth_prob_mean"

   !ones that vary
   var_labels( var_ur_state )=           "ur_state"
   var_labels( var_uimax )=              "uimax"
 !  var_labels( var_uirate )=             "uirate"
   var_labels( var_uilength )=           "uilength"
   var_labels( var_kids )=               "kids"
   var_labels( var_youngest )=           "youngest"
   var_labels( var_assets )=             "assets"

   !job related variables
   var_labels( var_m_wage )=             "m_wage"
   var_labels( var_wage )=               "wage"
   var_labels( var_m_non_pec_norm )=     "m_non_pec_norm" !this is the non-pecuniary benefit divided by the variance
   var_labels( var_non_pec_norm )=       "non_pec_norm"
   var_labels( var_m_ui_ben )=           "m_ui_ben"
   var_labels( var_ui_ben )=             "ui_ben"


   var_labels( var_m_job_length ) =      "m_job_length"
   var_labels( var_job_length ) =        "job_length"
   var_labels( var_m_unemp_length )=     "m_unemp_length"
   var_labels( var_unemp_length ) =      "unemp_length"

!now generate the likelihood variables

  ! like_var_labels( var_m_joboffer_mean ) =  'm_joboffer_mean'
  ! like_var_labels( var_joboffer_mean )=       "joboffer_mean"
   like_var_labels( var_m_wage_mean )=         "m_wage_mean"
   like_var_labels( var_wage_mean )=           "wage_mean"
 !  like_var_labels( var_m_leisure_mean )=      "m_leisure_mean"
 !  like_var_labels( var_leisure_mean )=        "leisure_mean"
 !  like_var_labels( var_m_jobloss_mean )=      "m_jobloss_mean"
 !  like_var_labels( var_jobloss_mean )=        "jobloss_mean"
 !  like_var_labels( var_m_ui_mean )=           "m_ui_prob_mean"
 !  like_var_labels( var_ui_mean )=              "ui_prob_mean"
 !  like_var_labels( var_birth_mean )=           "birth_prob_mean"

   !ones that vary
   like_var_labels( var_ur_state )=           "ur_state"
   like_var_labels( var_uimax )=              "uimax"
 !  like_var_labels( var_uirate )=             "uirate"
   like_var_labels( var_uilength )=           "uilength"
   like_var_labels( var_kids )=               "kids"
   like_var_labels( var_youngest )=           "youngest"
   like_var_labels( var_assets )=             "assets"

   !job related variables
   like_var_labels( var_m_wage )=             "m_wage"
   like_var_labels( var_wage )=               "wage"
   like_var_labels( var_m_non_pec_norm )=     "m_non_pec_norm" !this is the non-pecuniary benefit divided by the variance
   like_var_labels( var_non_pec_norm )=       "non_pec_norm"
   like_var_labels( var_m_ui_ben )=           "m_ui_ben"
   like_var_labels( var_ui_ben )=             "ui_ben"


   like_var_labels( var_m_job_length ) =      "m_job_length"
   like_var_labels( var_job_length ) =        "job_length"
   like_var_labels( var_m_unemp_length )=     "m_unemp_length"
   like_var_labels( var_unemp_length ) =      "unemp_length"

   like_var_labels( var_m_wage_new )=          "m_wage_new"
   like_var_labels( var_wage_new )=            "wage_new"
   like_var_labels( var_m_non_pec_norm_new )=  "m_non_pec_norm_new" !this is the non-pecuniary benefit divided by the variance
   like_var_labels( var_non_pec_norm_new )=    "non_pec_norm_new"



end subroutine gen_var_labels

subroutine gen_var_labels_long()
!generates labels for the variables

   var_labels_long( var_m_wage_mean )=         "Husband's Hourly Wage Distribution Mean"
   var_labels_long( var_wage_mean )=           "Wife's Hourly Wage Distribution Mean"

   !ones that vary
   var_labels_long( var_ur_state )=           "State Unemployment Rate"
   var_labels_long( var_uimax )=              "State UI Benefits Maximum"
 !  var_labels( var_uirate )=             "uirate"
   var_labels_long( var_uilength )=           "State UI Duration Maximum"
   var_labels_long( var_kids )=               "Number of Kids"
   var_labels_long( var_youngest )=           "Age of Youngest Kids "
   var_labels_long( var_assets )=             "Net Liquid Assets"

   !job related variables
   var_labels_long( var_m_wage )=             "Husband's Hourly Wage"
   var_labels_long( var_wage )=               "Wife's Hourly Wage"
   var_labels_long( var_m_non_pec_norm )=     "Husband's Non. Pec. Benefit" !this is the non-pecuniary benefit divided by the variance
   var_labels_long( var_non_pec_norm )=       "Wife's Non. Pec. Benefit"
   var_labels_long( var_m_ui_ben )=           "Husband's UI Benefits"
   var_labels_long( var_ui_ben )=             "Wife's UI Benefits"

   var_labels_long( var_m_job_length ) =      "Husband's Length Employed"
   var_labels_long( var_job_length ) =        "Wife's Length Employed"
   var_labels_long( var_m_unemp_length )=     "Husband's Length Non-Employed"
   var_labels_long( var_unemp_length ) =      "Wife's Length Non-Employed"

   var_labels_long( var_m_wage_new )=          "Husband's Offered Hourly Wage"
   var_labels_long( var_wage_new )=            "Wife's Offered Hourly Wage"
   var_labels_long( var_m_non_pec_norm_new )=  "Husband's Offered Non. Pec. Benefit" !this is the non-pecuniary benefit divided by the variance
   var_labels_long( var_non_pec_norm_new )=    "Wife's Offered Non. Pec. Benefit"

end subroutine

subroutine gen_param_labels()


param_labels( param_joboffer_cons) =   'joboffer_cons'
param_labels( param_joboffer_ur) =  'joboffer_ur'
param_labels( param_joboffer_work) =  'joboffer_work'
!param_labels( param_joboffer_age) =  'joboffer_age'
!param_labels( param_joboffer_age2) =  'joboffer_age2'
!param_labels( param_joboffer_race) =  'joboffer_race'
!param_labels( param_joboffer_hs) =  'joboffer_hs'
!param_labels( param_joboffer_some_college) =  'joboffer_some_college'
!param_labels( param_joboffer_college) =  'joboffer_college'
param_labels( param_joboffer_job_length) =  'joboffer_job_length'
param_labels( param_joboffer_unemp_length) =  'joboffer_unemp_length'
param_labels( param_joboffer_gender) =  'joboffer_gender'
param_labels( param_joboffer_seam) =  'joboffer_seam'

param_labels( param_wage_cons) =  'wage_cons'
param_labels( param_wage_pt) =  'wage_pt'
param_labels( param_wage_ur) =  'wage_ur'
param_labels( param_wage_age) =  'wage_age'
param_labels( param_wage_age2) =  'wage_age2'
param_labels( param_wage_race) =  'wage_race'
param_labels( param_wage_hs) =  'wage_hs'
param_labels( param_wage_some_college) =  'wage_some_college'
param_labels( param_wage_college) =  'wage_college'
param_labels( param_wage_gender) =  'wage_gender'

param_labels( param_m_leisure_cons) =  'm_leisure_cons'
!param_labels( param_m_leisure_age) =  'm_leisure_age'
!param_labels( param_m_leisure_age2) =  'm_leisure_age2'
!param_labels( param_m_leisure_race) =  'm_leisure_race'
!param_labels( param_m_leisure_hs) =  'm_leisure_hs'
!param_labels( param_m_leisure_some_college) =  'm_leisure_some_college'
!param_labels( param_m_leisure_college) =  'm_leisure_college'
!param_labels( param_m_leisure_kids) =  'm_leisure_kids'
!param_labels( param_m_leisure_youngest) =  'm_leisure_youngest'

param_labels( param_leisure_cons) =  'leisure_cons'
!param_labels( param_leisure_age) =  'leisure_age'
!param_labels( param_leisure_age2) =  'leisure_age2'
!param_labels( param_leisure_race) =  'leisure_race'
!param_labels( param_leisure_hs) =  'leisure_hs'
!param_labels( param_leisure_some_college) =  'leisure_some_college'
!param_labels( param_leisure_college) =  'leisure_college'
!param_labels( param_leisure_any_kids) =  'leisure_any_kids'
param_labels( param_leisure_kids) =  'leisure_kids'
param_labels( param_leisure_youngest) =  'leisure_youngest'
param_labels( param_gender_reverse ) =  'gender_reverse'

param_labels( param_hetero_m_wage_var) =  'param_hetero_m_wage_var'
param_labels( param_hetero_wage_var) =  'param_hetero_wage_var'
param_labels( param_hetero_wage_covar) =  'param_hetero_wage_covar'

param_labels( param_sd_non_pec) =  'sd_non_pec'
param_labels( param_sd_wage) =  'sd_wage'
param_labels( param_prob_pt) =  'prob_pt'


param_labels( param_weight_utility) =  'weight_utility'
param_labels( param_rra) =  'rra'

param_labels( param_asset_error_cons) =  'asset_error_cons'
param_labels( param_asset_error_linear) =  'asset_error_linear'


param_labels( param_jobloss_cons) =  'jobloss_cons'
param_labels( param_jobloss_ur) =  'jobloss_ur'
!param_labels( param_jobloss_age) =  'jobloss_age'
!param_labels( param_jobloss_age2) =  'jobloss_age2'
!param_labels( param_jobloss_race) =  'jobloss_race'
!param_labels( param_jobloss_hs) =  'jobloss_hs'
!param_labels( param_jobloss_some_college) =  'jobloss_some_college'
!param_labels( param_jobloss_college) =  'jobloss_college'
param_labels( param_jobloss_job_length) =  'jobloss_job_length'
param_labels( param_jobloss_gender) =  'jobloss_gender'
param_labels( param_jobloss_seam_future) =  'jobloss_seam_future'
!param_labels( param_jobloss_kids) =  'jobloss_kids'
!param_labels( param_jobloss_youngest) =  'jobloss_youngest'
!param_labels( param_jobloss_birth) =  'jobloss_birth'


param_labels( param_ui_cons) =  'ui_cons'
param_labels( param_ui_ur) =  'ui_ur'
!param_labels( param_ui_age) =  'ui_age'
!param_labels( param_ui_age2) =  'ui_age2'
!param_labels( param_ui_race) =  'ui_race'
!param_labels( param_ui_hs) =  'ui_hs'
!param_labels( param_ui_some_college) =  'ui_some_college'
!param_labels( param_ui_college) =  'ui_college'
param_labels( param_ui_gender) =  'ui_gender'

param_labels( param_birth_cons) =  'birth_cons'
!param_labels( param_birth_age) =  'birth_age'
!param_labels( param_birth_age2) =  'birth_age2'
param_labels( param_birth_kids) =  'birth_kids'
param_labels( param_birth_youngest) =  'birth_youngest'

param_labels( param_state_ur_cons) =  'state_ur_cons'
param_labels( param_state_ur_on_state_ur) =  'state_ur_on_state_ur'
param_labels( param_state_ur_sd) =  'state_ur_sd'

param_labels( param_sd_m_wage_error) =  'sd_m_wage_error'
param_labels( param_sd_wage_error) =  'sd_m_wage_error'

param_labels( param_asset_lb ) =  'param_asset_lb'
param_labels( param_min_cons_val ) =  'min_cons_val'
param_labels( param_bankruptcy_prob ) =  'param_bankruptcy_prob'
param_labels( param_interest_rate) =  'interest_rate'

param_labels( param_discount_factor) =  'discount_factor'



end subroutine gen_param_labels


subroutine gen_labels()
   call gen_var_labels()
   call gen_param_labels()
end subroutine gen_labels


subroutine init_params(filename_in, params_init)
   !initializes the parameters from an external file
   character(len=30), intent(in) :: filename_in
   real*8, dimension(n_params), intent(out) :: params_init

   integer :: init_file_unit
   integer :: i
   logical :: file_exists
   character(50) :: string_ignore

   inquire(file=filename_in,exist=file_exists)
   if (.not. file_exists) then
      print *, "file", filename_in, "not present, stopping"
      stop
   end if

   open(newunit=init_file_unit, file=filename_in, status="old")

   do i=1,n_params
      read(init_file_unit,*), string_ignore, params_init(i)
   end do

   close(unit=init_file_unit)


end subroutine init_params

subroutine write_params(params_in,unit_in,all_params_logical_in)
   real*8, dimension(n_params), intent(in) :: params_in
   integer, intent(in) :: unit_in
   logical, intent(in) :: all_params_logical_in !whether to write all the parameters.  If false, only write
      !the main parameters
   integer :: i

   if (all_params_logical_in .eqv. .true. ) then
      do i=1,n_params
          write(unit_in,*)  param_labels(i), params_in(i)
      end do
   else
      do i=1,n_main_params
          write(unit_in,*)  param_labels(i), params_in(i)
      end do
   end if



end subroutine write_params

subroutine read_params(params_out,unit_in,all_params_logical_in)
   real*8, dimension(n_params), intent(out) :: params_out
   integer, intent(in) :: unit_in
   logical, intent(in) :: all_params_logical_in !whether to write all the parameters.  If false, only write
      !the main parameters
   character(len=50) :: char_ignore
   integer :: int_ignore, i


   if (all_params_logical_in .eqv. .true. ) then
      do i=1,n_params
          read(unit_in,*)  char_ignore, params_out(i)
      end do
   else
      do i=1,n_main_params
          read(unit_in,*)  char_ignore, params_out(i)
      end do
   end if

end subroutine read_params





subroutine print_mygrid(mygrid_in,print_t_invar_in,print_t_var_in)
   !prints the mygrid type.  logicals indicate whether certain components should be printed

   class(mygrid_type),intent(in) :: mygrid_in
   logical, intent(in) :: print_t_invar_in
   logical, intent(in) :: print_t_var_in

   if (print_t_invar_in) then
      print *, " "
   !   print *, "m_joboffer_mean", mygrid_in %   rv( var_m_joboffer_mean )
   !   print *, "joboffer_mean", mygrid_in %     rv( var_joboffer_mean )
      print *, "m_wage_mean", mygrid_in %       rv( var_m_wage_mean )
      print *, "wage_mean", mygrid_in %         rv( var_wage_mean )
  !    print *, "m_leisure_mean", mygrid_in %    rv( var_m_leisure_mean )
  !    print *, "leisure_mean", mygrid_in %      rv( var_leisure_mean )
  !    print *, "m_jobloss_mean", mygrid_in %   rv( var_m_jobloss_mean )
  !    print *, "jobloss_mean", mygrid_in %     rv( var_jobloss_mean )
  !    print *, "m_ui_prob_mean", mygrid_in %    rv( var_m_ui_mean )
  !    print *, "ui_prob_mean", mygrid_in %      rv( var_ui_mean )
  !    print *, "birth_prob_mean", mygrid_in %   rv( var_birth_mean )
   end if


   !ones that vary
   if (print_t_var_in) then
      print *, " "
      print *, "ur_state", mygrid_in %       rv( var_ur_state )
      print *, "uimax", mygrid_in %          rv( var_uimax )
   !   print *, "uirate", mygrid_in %         rv( var_uirate )
      print *, "uilength", mygrid_in %       rv( var_uilength )
      print *, "kids", mygrid_in %           rv ( var_kids)
      print *, "youngest", mygrid_in %       rv( var_youngest )
      print *, "assets", mygrid_in %         rv( var_assets )

      !variables if working
      print *, " "
      print *, "m_wage", mygrid_in %         rv( var_m_wage )
      print *, "wage", mygrid_in %           rv( var_wage )
      print *, "m_hours", mygrid_in %        iv( var_m_hours )
      print *, "hours", mygrid_in %          iv( var_hours )
      print *, "m_non_pec_norm", mygrid_in % rv( var_m_non_pec_norm ) !this should be divied by the variance
      print *, "non_pec_norm", mygrid_in %   rv( var_non_pec_norm )
      print *, "m_ui_ben", mygrid_in %       rv( var_m_ui_ben )
      print *, "ui_ben", mygrid_in %         rv( var_ui_ben )

      print *, " "
      print *, "income", inc_func( mygrid_in )


      !variables if not working
      print *, " "
      print *, "m_job_length", mygrid_in %            rv( var_m_job_length )
      print *, "job_length", mygrid_in %              rv( var_job_length )
      print *, "m_unemp_length", mygrid_in %          rv( var_m_unemp_length )
      print *, "unemp_length", mygrid_in %            rv( var_unemp_length )


      !job indicators
      print *, " "
      print *, "m_job", mygrid_in %          iv( var_m_job )
      print *, "job", mygrid_in %            iv( var_job )
   end if

   if ( allocated( mygrid_in % iter ) ) then

      print *, "m_ui_ben_pot",   mygrid_in % iter( interp_m_ui_ben_pot )
      print *, "ui_ben_pot",     mygrid_in % iter( interp_ui_ben_pot )
      print *, "m_ui_left",      mygrid_in % iter( interp_m_ui_left )
      print *, "ui_left",        mygrid_in % iter( interp_ui_left )


   end if


end subroutine print_mygrid



subroutine print_mygrid2(mygrid1_in,mygrid2_in,print_t_invar_in,print_t_var_in)
   !prints 2 mygrids side by side

   class(mygrid_type),intent(in) :: mygrid1_in
   class(mygrid_type),intent(in) :: mygrid2_in
   logical, intent(in) :: print_t_invar_in
   logical, intent(in) :: print_t_var_in

   if (print_t_invar_in) then
      print *, " "
    !  print *, "m_joboffer_mean", mygrid1_in %   rv( var_m_joboffer_mean ), mygrid2_in %   rv( var_m_joboffer_mean )
    !  print *, "joboffer_mean", mygrid1_in %     rv( var_joboffer_mean ), mygrid2_in %     rv( var_joboffer_mean )
      print *, "m_wage_mean", mygrid1_in %       rv( var_m_wage_mean ), mygrid2_in %       rv( var_m_wage_mean )
      print *, "wage_mean", mygrid1_in %         rv( var_wage_mean ), mygrid2_in %         rv( var_wage_mean )
    !  print *, "m_leisure_mean", mygrid1_in %    rv( var_m_leisure_mean ), mygrid2_in %    rv( var_m_leisure_mean )
    !  print *, "leisure_mean", mygrid1_in %      rv( var_leisure_mean ), mygrid2_in %      rv( var_leisure_mean )
    !  print *, "m_jobloss_mean", mygrid1_in %   rv( var_m_jobloss_mean ), mygrid2_in %   rv( var_m_jobloss_mean )
    !  print *, "jobloss_mean", mygrid1_in %     rv( var_jobloss_mean ), mygrid2_in %     rv( var_jobloss_mean )
    !  print *, "m_ui_prob_mean", mygrid1_in %    rv( var_m_ui_mean ), mygrid2_in %    rv( var_m_ui_mean )
    !  print *, "ui_prob_mean", mygrid1_in %      rv( var_ui_mean ), mygrid2_in %      rv( var_ui_mean )
    !  print *, "birth_prob_mean", mygrid1_in %   rv( var_birth_mean ), mygrid2_in %   rv( var_birth_mean )
   end if


   !ones that vary
   if (print_t_var_in) then
      print *, " "
      print *, "ur_state", mygrid1_in %       rv( var_ur_state ), mygrid2_in %       rv( var_ur_state )
      print *, "uimax", mygrid1_in %          rv( var_uimax ), mygrid2_in %          rv( var_uimax )
   !   print *, "uirate", mygrid1_in %         rv( var_uirate ), mygrid2_in %         rv( var_uirate )
      print *, "uilength", mygrid1_in %       rv( var_uilength ), mygrid2_in %       rv( var_uilength )
      print *, "kids", mygrid1_in %           rv ( var_kids ), mygrid2_in %          rv ( var_kids )
      print *, "youngest", mygrid1_in %       rv( var_youngest ), mygrid2_in %       rv( var_youngest )
      print *, "assets", mygrid1_in %         rv( var_assets ), mygrid2_in %         rv( var_assets )

      !variables if working
      print *, " "
      print *, "m_wage", mygrid1_in %         rv( var_m_wage ), mygrid2_in %         rv( var_m_wage )
      print *, "wage", mygrid1_in %           rv( var_wage ), mygrid2_in %           rv( var_wage )
      print *, "m_hours", mygrid1_in %        iv( var_m_hours ), mygrid2_in %        iv( var_m_hours )
      print *, "hours", mygrid1_in %          iv( var_hours ), mygrid2_in %          iv( var_hours )
      print *, "m_non_pec_norm", mygrid1_in % rv( var_m_non_pec_norm ), mygrid2_in % rv( var_m_non_pec_norm )  !this should be divied by the variance
      print *, "non_pec_norm", mygrid1_in %   rv( var_non_pec_norm ), mygrid2_in %   rv( var_non_pec_norm )
      print *, "m_ui_ben", mygrid1_in %       rv( var_m_ui_ben ), mygrid2_in %       rv( var_m_ui_ben )
      print *, "ui_ben", mygrid1_in %         rv( var_ui_ben ), mygrid2_in %         rv( var_ui_ben )

      print *, " "
      print *, "m_job_length", mygrid1_in %    rv( var_m_job_length ), mygrid2_in %    rv( var_m_job_length )
      print *, "job_length", mygrid1_in %       rv( var_job_length ), mygrid2_in %       rv( var_job_length )
      print *, "m_unemp_length", mygrid1_in %   rv( var_m_unemp_length ), mygrid2_in %   rv( var_m_unemp_length )
      print *, "unemp_length", mygrid1_in %     rv( var_unemp_length ), mygrid2_in %     rv( var_unemp_length )


      print *, " "
      print *, "m_job", mygrid1_in %          iv( var_m_job ), mygrid2_in %          iv( var_m_job )
      print *, "job", mygrid1_in %            iv( var_job ), mygrid2_in %            iv( var_job )

   end if


end subroutine print_mygrid2








subroutine mygrid_allocate(mygrid_out)
   !allocates the components of mygrid
   class(mygrid_type), intent(out) :: mygrid_out

   allocate( mygrid_out % rv(n_cont_vars) )
   allocate( mygrid_out % iv(n_int_vars)  )

   !this gaurantees the variables are intialized to 0, although the compiler should do this automatically
   mygrid_out % rv = 0
   mygrid_out % iv = 0

end subroutine mygrid_allocate


subroutine mygrid_t_var_allocate(mygrid_t_var_out)
   !allocates the time-varying components of mygrid_t_var (e.e. give them there own space in memory), and set them equal to the time_variant components of mygrid_in
   class(mygrid_type), intent(out) :: mygrid_t_var_out

   allocate( mygrid_t_var_out % rv(n_t_invar+1:n_cont_vars) )
   allocate( mygrid_t_var_out % iv(n_int_vars) )

   !this gaurantees the variables are intialized to 0, although the compiler should do this automatically
   mygrid_t_var_out % rv = 0
   mygrid_t_var_out % iv = 0

end subroutine mygrid_t_var_allocate

subroutine mygrid_iter_allocate(mygrid_out)
   !allocates the components of mygrid for iteration
   class(mygrid_type), intent(out) :: mygrid_out

   allocate( mygrid_out % rv(n_cont_vars) )
   allocate( mygrid_out % iv(n_int_vars)  )
   allocate( mygrid_out % iter (interp_m_ui_ben_pot: interp_ui_left)  )

   !this gaurantees the variables are intialized to 0, although the compiler should do this automatically
   mygrid_out % rv = 0
   mygrid_out % iv = 0
   mygrid_out % iter = 0

end subroutine mygrid_iter_allocate




function exp_arg_convert(x_in)
   !makes taking exp(.) numerically stable by putting the argument between two bounds that will gurarrante that exp(.)
      !will be strictly between 0 and infinity
   real*8, intent(in) :: x_in
   real*8 :: exp_arg_convert

   if (x_in > max_exp_arg) then
      exp_arg_convert = max_exp_arg
   else if (x_in < min_exp_arg) then
      exp_arg_convert = min_exp_arg
   else
      exp_arg_convert = x_in
   end if

end function



function prob_val_convert(x_in)
   !similar thing but for the ouput of the logit probability p=exp(.)/(1+exp(.))
   real*8, intent(in) :: x_in
   real*8 :: prob_val_convert

   if (x_in > (1-min_prob_val)) then
      prob_val_convert = 1-min_prob_val
   else if (x_in < min_prob_val) then
      prob_val_convert = min_prob_val
   else
      prob_val_convert = x_in
   end if

end function


subroutine param_predraw_convert(params_inout) !converts some of the parameters that I need to be either >0 or between 0 and 1
   real*8, dimension(n_main_params), intent(in out) :: params_inout
   real*8 :: exp_arg_temp, prob_val_temp


   params_inout(param_sd_non_pec) = sqrt( params_inout(param_sd_non_pec) )

   params_inout(param_sd_wage) = sqrt( params_inout(param_sd_wage) )

   prob_val_temp = prob_val_convert( params_inout(param_prob_pt) )
   params_inout(param_prob_pt) = -log( (1.0/ prob_val_temp) - 1 )


   params_inout(param_weight_utility) = sqrt( params_inout(param_weight_utility) )

   !imposing rra to be positive.  If this wasn't true, then household would never save.
   params_inout(param_rra) = sqrt( params_inout(param_rra) )

 !  params_inout(param_gender_reverse) = sqrt( - params_inout( param_gender_reverse) )


!     exp_arg_temp = log(params_inout(param_sd_non_pec) )
!   params_inout(param_sd_non_pec) = exp_arg_convert(exp_arg_temp)

!   exp_arg_temp = log(params_inout(param_sd_wage) )
!   params_inout(param_sd_wage) = exp_arg_convert(exp_arg_temp)

!   prob_val_temp = prob_val_convert( params_inout(param_prob_pt) )
!   params_inout(param_prob_pt) = -log( (1.0/ prob_val_temp) - 1 )

!   exp_arg_temp = log(params_inout(param_weight_utility) )
!   params_inout(param_weight_utility) = exp_arg_convert(exp_arg_temp)


end subroutine param_predraw_convert

subroutine param_postdraw_convert(params_inout) !converts some of the parameters that I need to be either >0 or between 0 and 1
   real*8, dimension(n_main_params), intent(in out) :: params_inout
   real*8 :: exp_arg_temp, prob_val_temp


   params_inout(param_sd_non_pec) =  params_inout(param_sd_non_pec)**2

   params_inout(param_sd_wage)  = params_inout(param_sd_wage) **2


   prob_val_temp = logit_prob( params_inout(param_prob_pt) )
  ! prob_val_temp = exp(params_inout(param_prob_pt))/(1+exp(params_inout(param_prob_pt)) )
   params_inout(param_prob_pt) = prob_val_temp

   params_inout(param_weight_utility) = params_inout(param_weight_utility)**2

   params_inout(param_rra) = params_inout(param_rra)**2

 !  params_inout(param_gender_reverse) = - params_inout(param_gender_reverse)**2

   params_inout(param_gender_reverse) = - abs( params_inout(param_gender_reverse) )
   params_inout(param_leisure_cons) =  abs( params_inout(param_leisure_cons) )

!   exp_arg_temp = exp_arg_convert(params_inout(param_sd_non_pec))
!   params_inout(param_sd_non_pec) = exp( exp_arg_temp )

!   exp_arg_temp = exp_arg_convert(params_inout(param_sd_wage))
!   params_inout(param_sd_wage)  = exp( exp_arg_temp )

!   prob_val_temp = exp(params_inout(param_prob_pt))/(1+exp(params_inout(param_prob_pt)) )
!   params_inout(param_prob_pt) = prob_val_temp

!   exp_arg_temp = exp_arg_convert(params_inout(param_weight_utility))
!   params_inout(param_weight_utility) = exp( exp_arg_temp )


end subroutine param_postdraw_convert


subroutine mygrid_error_hunt(mygrid_in,check_t_invar_in,check_t_var_in,i,t,choice)
   !hunts for errors in the mygrid type

   class(mygrid_type),intent(in) :: mygrid_in
   logical, intent(in) :: check_t_invar_in
   logical, intent(in) :: check_t_var_in
   integer, intent(in) :: i
   integer, intent(in) :: t
   integer, intent(in) :: choice

   integer :: k

   if (check_t_invar_in) then
      do k=1,n_t_invar
         if (nan_inf_check(mygrid_in % rv(k))) then
            print *, "error with variable", var_labels(k), "for household", i,  &
               mygrid_in % rv(k)
         end if
      end do
   end if


   !ones that vary
   if (check_t_var_in) then
      do k=n_t_invar+1,n_cont_vars
         if (nan_inf_check(mygrid_in % rv(k))) then
            print *, "error with variable", var_labels(k), "for household", i, &
               "at time, choice ", t, choice, mygrid_in % rv(k)
         end if
      end do

      !check that certain variables are greater than 0
      do k=var_ur_state, var_youngest
         if (mygrid_in % rv(k) <-zero_tol) then
            print *, "variable ", var_labels(k), "for household ", i, &
            "at time, choice ", t, choice, "less than 0 ", mygrid_in % rv(k)
         end if
      end do


      !now check that the lengths are greater than 0
      do k=var_m_job_length, var_unemp_length
         if (mygrid_in % rv(k) <-zero_tol) then
            print *, "variable ", var_labels(k), "for household ", i, &
            "at time, choice ", t, choice, "less than 0 ", mygrid_in % rv(k)
         end if
      end do


      !now check the job indicators
      if( .not. ((mygrid_in % iv( var_m_job ) .eq. 0) .or. (mygrid_in % iv( var_m_job ) .eq. 1)) ) then
         print *, "error in job indicator for hh", i, "at time,choice", t, choice, &
            mygrid_in % iv( var_m_job )
      end if

      if( .not. ((mygrid_in % iv( var_job ) .eq. 0) .or. (mygrid_in % iv( var_job ) .eq. 1)) ) then
         print *, "error in job indicator for hh", i, "at time, choice", t, choice, &
            mygrid_in % iv( var_job )
      end if

      !now check variables that depend on whether a job is held
      !first husband
      if (mygrid_in % iv( var_m_job) .eq. 1) then
         if  (mygrid_in % rv( var_m_wage) < zero_tol ) then
            print *, "error with wage being zero for husband with a job for hh ", i, &
            "at time, choice", t, choice, mygrid_in % rv( var_m_wage)
         end if

         if  (abs(mygrid_in % rv( var_m_ui_ben)) > zero_tol ) then
            print *, "error with ui not being zero for husband with a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_m_ui_ben)
         end if


         if ( .not. (( mygrid_in % iv( var_m_hours ) .eq. 20) .or. &
                     ( mygrid_in % iv( var_m_hours ) .eq. 40) ) ) then

            print *, "error in hours for husband with job for hh", i, &
               "at time, choice", t, choice, mygrid_in % iv( var_m_hours )

         end if

         if  (abs(mygrid_in % rv( var_m_unemp_length)) > zero_tol ) then
            print *, "error with unemp lenghth not being zero for husband with a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_m_unemp_length)
         end if



      else

         if  (abs(mygrid_in % rv( var_m_wage)) > zero_tol ) then
            print *, "error with wage not being zero for husband w/o a job for hh ", i, &
            "at time, choice", t, choice, mygrid_in % rv( var_m_wage)
         end if

         if  (abs(mygrid_in % rv( var_m_non_pec_norm)) > zero_tol ) then
            print *, "error with non pec not being zero for husband w/o a job for hh ", i, &
            "at time, choice", t, choice, mygrid_in % rv( var_m_non_pec_norm)
         end if

         if  ( mygrid_in % rv( var_m_ui_ben) < -zero_tol ) then
            print *, "error with ui for husband w/o a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_m_ui_ben)
         end if

         if ( mygrid_in % iv( var_m_hours ) .ne. 0 ) then
            print *, "error in hours for husband w/o a job for hh", i, &
            "at time, choice", t, choice, mygrid_in % iv( var_m_hours )
         end if


         if  (abs(mygrid_in % rv( var_m_job_length)) > zero_tol ) then
            print *, "error with job lenghth not being zero for husband without a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_m_job_length)
         end if


      end if

      !now wife
      if (mygrid_in % iv( var_job) .eq. 1) then
         if  (mygrid_in % rv( var_wage) < zero_tol ) then
            print *, "error with wage being zero for wife with a job for hh ", i, &
            "at time, choice", t, choice, mygrid_in % rv( var_wage)
         end if

         if  (abs(mygrid_in % rv( var_ui_ben)) > zero_tol ) then
            print *, "error with ui not being zero for wife with a job for hh ", i, &
             "at time, choice, ", t, choice, mygrid_in % rv( var_ui_ben)
         end if


         if ( .not. (( mygrid_in % iv( var_hours ) .eq. 20) .or. &
                     ( mygrid_in % iv( var_hours ) .eq. 40) ) ) then

            print *, "error in hours for wife with job for hh", i, &
               "at time, choice", t, choice, mygrid_in % iv( var_hours )

         end if

         if  (abs(mygrid_in % rv( var_unemp_length)) > zero_tol ) then
            print *, "error with unemp lenghth not being zero for wife with a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_unemp_length)
         end if

      else

         if  (abs(mygrid_in % rv( var_wage)) > zero_tol ) then
            print *, "error with wage not being zero for wife w/o a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_wage)
         end if

         if  (abs(mygrid_in % rv( var_non_pec_norm)) > zero_tol ) then
            print *, "error with non pec not being zero for wife w/o a job for hh ", i, &
               "at time", t, choice, mygrid_in % rv( var_non_pec_norm)
         end if

         if  ( mygrid_in % rv( var_ui_ben) < -zero_tol ) then
            print *, "error with ui for wife w/o a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_ui_ben)
         end if

         if ( mygrid_in % iv( var_hours ) .ne. 0 ) then
            print *, "error in hours for wife w/o a job for hh", i, &
               "at time, choice", t, choice, mygrid_in % iv( var_hours )
         end if


         if  (abs(mygrid_in % rv( var_job_length)) > zero_tol ) then
            print *, "error with job length not being zero for wife with a job for hh ", i, &
               "at time, choice", t, choice, mygrid_in % rv( var_job_length)
         end if

      end if

      !check to make sure ui is 0 if unemp_lenght is greater than ui lenght
      if ( ( nint( mygrid_in % rv( var_m_unemp_length) ) > nint( mygrid_in % rv( var_uilength) ) ) .and. &
           ( mygrid_in % rv( var_m_ui_ben) > zero_tol ) ) then
         print *, "m_ui benefits >0 when max uilength has been exceeded for hh", i, &
            "at time, choice", t, choice, mygrid_in % rv( var_m_unemp_length), &
            mygrid_in % rv( var_uilength), mygrid_in % rv( var_m_ui_ben)

      end if

      if ( ( nint( mygrid_in % rv( var_unemp_length) ) > nint( mygrid_in % rv( var_uilength) ) ) .and. &
           ( mygrid_in % rv( var_ui_ben) > zero_tol ) ) then
         print *, "ui benefits >0 when max uilength has been exceeded for hh", i, &
            "at time, choice", t, choice, mygrid_in % rv( var_unemp_length), &
            mygrid_in % rv( var_uilength), mygrid_in % rv( var_ui_ben)

      end if



   end if


   !now check the iter object, if they're allocated
   if ( allocated( mygrid_in % iter ) ) then
      if (mygrid_in % iv( var_m_job ) .eq. 1 ) then

         if( abs( mygrid_in % iter( interp_m_ui_ben_pot ) ) < zero_tol ) then

            print *, "error with husband's potential ui", mygrid_in % iter( interp_m_ui_ben_pot )
            print *, "husband's job indicator", mygrid_in % iv( var_m_job )

         end if

         if( abs( mygrid_in % iter( interp_m_ui_left ) ) > zero_tol ) then

            print *, "error with husband's ui left", mygrid_in % iter( interp_m_ui_left )
            print *, "husband's job indicator", mygrid_in % iv( var_m_job )

         end if

      else

        if( abs( mygrid_in % iter( interp_m_ui_ben_pot ) ) > zero_tol ) then

            print *, "error with husband's potential ui", mygrid_in % iter( interp_m_ui_ben_pot )
            print *, "husband's job indicator", mygrid_in % iv( var_m_job )

         end if


         if((  mygrid_in % iter( interp_m_ui_left )  < -zero_tol ) .and. &
            ( mygrid_in % rv( var_m_ui_ben) > -zero_tol ) ) then

            print *, "error with husband's ui left", mygrid_in % iter( interp_m_ui_left )
            print *, "with ui ben equaling",mygrid_in % rv( var_m_ui_ben)
            print *, "husband's job indicator", mygrid_in % iv( var_m_job )


         end if

         if((  mygrid_in % iter( interp_m_ui_left )  > zero_tol ) .and. &
            (  mygrid_in % rv( var_m_ui_ben)  < zero_tol ) ) then

            print *, "error with husband's ui left", mygrid_in % iter( interp_m_ui_left )
            print *, "with ui ben equaling",mygrid_in % rv( var_m_ui_ben)
            print *, "husband's job indicator", mygrid_in % iv( var_m_job )


         end if


      end if


      if (mygrid_in % iv( var_job ) .eq. 1 ) then

         if( abs( mygrid_in % iter( interp_ui_ben_pot ) ) < zero_tol ) then

            print *, "error with wife's potential ui", mygrid_in % iter( interp_ui_ben_pot )
            print *, "wife's job indicator", mygrid_in % iv( var_job )

         end if

         if( abs( mygrid_in % iter( interp_ui_left ) ) > zero_tol ) then

            print *, "error with wife's ui left", mygrid_in % iter( interp_ui_left )
            print *, "wife's job indicator", mygrid_in % iv( var_job )


         end if

      else

        if( abs( mygrid_in % iter( interp_ui_ben_pot ) ) > zero_tol ) then

            print *, "error with wife's potential ui", mygrid_in % iter( interp_ui_ben_pot )
            print *, "wife's job indicator", mygrid_in % iv( var_job )


         end if

         if((  mygrid_in % iter( interp_ui_left )  < -zero_tol ) .and. &
            ( mygrid_in % rv( var_ui_ben) > -zero_tol ) ) then

            print *, "error with wife's ui left", mygrid_in % iter( interp_ui_left )
            print *, "with ui ben equaling",mygrid_in % rv( var_ui_ben)
            print *, "wife's job indicator", mygrid_in % iv( var_job )


         end if

         if((  mygrid_in % iter( interp_ui_left )  > zero_tol ) .and. &
            ( mygrid_in % rv( var_ui_ben) < zero_tol ) ) then

            print *, "error with wife's ui left", mygrid_in % iter( interp_ui_left )
            print *, "with ui ben equaling",mygrid_in % rv( var_ui_ben)
            print *, "wife's job indicator", mygrid_in % iv( var_job )


         end if


      end if



   end if



end subroutine mygrid_error_hunt

subroutine mygrid_same_check(gender_in, mygrid1_in, mygrid2_in,i,t)
   character(len=1), intent(in) :: gender_in
   type(mygrid_type), intent(in) :: mygrid1_in
   type(mygrid_type), intent(in) :: mygrid2_in
   integer, intent(in) :: i, t

   if (gender_in .eq. "m" ) then

      if (mygrid1_in % iv(var_m_job) .ne. mygrid2_in % iv(var_m_job) ) then
         print *, "m_job different when should be same for hh", i, "at time", t
      end if

      if ( mygrid1_in % iv(var_m_hours) .ne. mygrid2_in % iv(var_m_hours)   ) then
         print *, "m_hours different when should be same for hh", i, "at time", t
      end if

      if ( abs(mygrid1_in % rv(var_m_wage) - mygrid2_in % rv(var_m_wage) ) > zero_tol ) then
         print *, "m_wage different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_m_non_pec_norm) - &
            mygrid2_in % rv(var_m_non_pec_norm) ) > zero_tol ) then
         print *, "m_non_pec different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_m_ui_ben) - mygrid2_in % rv(var_m_ui_ben) ) > zero_tol ) then
         print *, "m_ui_ben different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_m_job_length) - mygrid2_in % rv(var_m_job_length) ) > zero_tol ) then
         print *, "m_job_length different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_m_unemp_length) - mygrid2_in % rv(var_m_unemp_length) ) > zero_tol ) then
         print *, "m_unemp_length different when should be same for hh", i, "at time", t
      end if


   else if (gender_in .eq. "f" ) then

      if (mygrid1_in % iv(var_job) .ne. mygrid2_in % iv(var_job) ) then
         print *, "job different when should be same for hh", i, "at time", t
      end if

      if ( mygrid1_in % iv(var_hours) .ne. mygrid2_in % iv(var_hours)  ) then
         print *, "hours different when should be same for hh", i, "at time", t
      end if

      if ( abs(mygrid1_in % rv(var_wage) - mygrid2_in % rv(var_wage) ) > zero_tol ) then
         print *, "wage different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_non_pec_norm) - &
            mygrid2_in % rv(var_non_pec_norm) ) > zero_tol ) then
         print *, "non_pec different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_ui_ben) - mygrid2_in % rv(var_ui_ben) ) > zero_tol ) then
         print *, "ui_ben different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_job_length) - mygrid2_in % rv(var_job_length) ) > zero_tol ) then
         print *, "job length different when should be same for hh", i, "at time", t
      end if

      if (  abs(mygrid1_in % rv(var_unemp_length) - mygrid2_in % rv(var_unemp_length) ) > zero_tol ) then
         print *, "unemp length different when should be same for hh", i, "at time", t
      end if

   else
      print *, "error with gender in for mygrid_same_check"

   end if

      !checks whether either a husband or wife's variables are the same


end subroutine mygrid_same_check

function inc_func(mygrid_in)
   !gets a household's income, which is based on the mygrid object
   class(mygrid_type), intent(in) :: mygrid_in
   real*8 :: inc_func

   inc_func =  mygrid_in % rv( var_m_wage )     *  mygrid_in % iv( var_m_hours ) + &
               mygrid_in % rv( var_wage )       *  mygrid_in % iv( var_hours ) + &
               mygrid_in % rv( var_m_ui_ben )   +  mygrid_in % rv( var_ui_ben )
   inc_func = inc_func * week_to_month_convert

end function inc_func


function m_ui_ben_func(mygrid_in,ui_ever_in)
   !gets future ui benefits based on current wages, ui variables, and whether ui was received
   class(mygrid_type), intent(in) :: mygrid_in
   integer, intent(in) :: ui_ever_in
   real*8 :: m_ui_ben_func


   if (ui_ever_in .eq. 0 ) then
      m_ui_ben_func = 0
   else if (ui_ever_in .eq. 1 ) then

      m_ui_ben_func  = min(  mygrid_in % rv( var_m_wage) * mygrid_in % iv( var_m_hours) * &
                           replacement_rate_param, mygrid_in % rv( var_uimax) )

   else
       print *, "error with ui_ever_in for ui_ben_func"
       stop
   end if

end function m_ui_ben_func


function ui_ben_func(mygrid_in,ui_ever_in)
   !gets future ui benefits based on current wages, ui variables, and whether ui was received
   class(mygrid_type), intent(in) :: mygrid_in
   integer, intent(in) :: ui_ever_in
   real*8 :: ui_ben_func


   if (ui_ever_in .eq. 0 ) then
      ui_ben_func = 0
   else if (ui_ever_in .eq. 1 ) then

      ui_ben_func  = min(  mygrid_in % rv( var_wage) * mygrid_in % iv( var_hours) * &
                           replacement_rate_param, mygrid_in % rv( var_uimax) )

   else
       print *, "error with ui_ever_in for ui_ben_func"
       stop
   end if

end function ui_ben_func


function ui_length_func(ur,eb,euc1,euc2,euc3)!for determining how long a household can receive ui
   !using a nice table from Jessie's Rothstein's paper
   !Unemployment Insurance and Job Search in the Great Recession" (October 2011)
   real*8, intent(in) :: ur
   integer, intent(in) :: eb
   integer, intent(in) :: euc1
   integer, intent(in) :: euc2
   integer, intent(in) :: euc3
   real*8 :: ui_length_func

   ui_length_func = 26

   if (euc3 .eq. 1) then
      ui_length_func = ui_length_func + 20 + 14

      if (ur .ge. 6) ui_length_func  = ui_length_func + 13
      if (ur .ge. 8.5) ui_length_func  = ui_length_func + 6

   else if (euc2 .eq. 1) then
      ui_length_func = ui_length_func + 20

      if (ur .ge. 6) ui_length_func  = ui_length_func + 13

   else if (euc1 .eq. 1) then
      ui_length_func = ui_length_func + 13
   end if

   if (eb .eq. 1) then
      if (ur .ge. 6.5) ui_length_func  = ui_length_func + 13
      if (ur .ge. 8) ui_length_func  = ui_length_func + 7

   end if

   !convert from weeks to months based on conversion factor from google
   ui_length_func = ui_length_func*0.229984


end function ui_length_func


subroutine der_delta_setup()
   !sets up the step sizes for the derivatives

  ! der_delta( var_m_joboffer_mean )=    .5
  ! der_delta( var_joboffer_mean )=      .5
   der_delta( var_m_wage_mean )=        .5
   der_delta( var_wage_mean )=          .5
  ! der_delta( var_m_leisure_mean )=     .5
  ! der_delta( var_leisure_mean )=       .5
  ! der_delta( var_m_jobloss_mean )=    .5
  ! der_delta( var_jobloss_mean )=      .5
  ! der_delta( var_m_ui_mean )=     .5   !IMPORTANT, I need to pick the UI means more carefully
  ! der_delta( var_ui_mean )=       .5
  ! der_delta( var_birth_mean )=    1

   !ones that vary
   der_delta( var_ur_state )=           1
   der_delta( var_uimax )=              50
  ! der_delta( var_uirate )=             .1
   der_delta( var_uilength )=           5
   der_delta( var_kids )=               1
   der_delta( var_youngest )=           2
   der_delta( var_assets )=             100

   !job related variables
   der_delta( var_m_wage )=             10
   der_delta( var_wage )=               10
   der_delta( var_m_non_pec_norm )=     1 !this is the non-pecuniary benefit divided by the variance
   der_delta( var_non_pec_norm )=       1
   der_delta( var_m_ui_ben )=           10
   der_delta( var_ui_ben )=             10

   der_delta( var_m_job_length )=       4
   der_delta( var_job_length )=         4
   der_delta( var_m_unemp_length )=     4
   der_delta( var_unemp_length )=       4

   !job offer variables
   der_delta( var_m_wage_new )=             10
   der_delta( var_wage_new )=               10
   der_delta( var_m_non_pec_norm_new )=     1 !this is the non-pecuniary benefit divided by the variance
   der_delta( var_non_pec_norm_new )=       1



end subroutine der_delta_setup


end module model_params_mod



module utility_function_mod


use model_params_mod
use enum_mod

implicit none

   integer, parameter :: n_utility_params = 3
   real*8, parameter :: rra_close_one_bound = 1.0D-8  !used to determine when the rra parameter is close to one, in which case
      !need to do logs instead
   real*8,parameter :: income_increaser = 0    !this just makes sure I'm not taking log of 0
   real*8, parameter :: hours_weight = dble(1.0/40.0) !I multiply hours worked by this value for the utility function
   real*8, parameter :: zero_cons_value= -huge(0.0D+00) !value if consumption is zero

   real*8, parameter :: min_cons_val = 1
   real*8, parameter :: c_scale_param = 1.0D-2

   !2/11/14, introduce a parameter that imposes a cost having reversed gender roles
!   real*8, parameter :: gender_reverse_cost = .35


contains


function cons_func(c, rra)
   !my comsumption function, does (c^(1-p)-1 )/(1-p) or ln(c) if p is close to one
   real*8, intent(in) :: c !consumption
   real*8, intent(in) :: rra !coefficient of relative risk aversion
   real*8 :: cons_func

   real*8 :: c_scaled !scaling c by a factor seems to help.  If I just use montly income, then if sigma somewhat large, say around
      !4, then c^(1-sigma) is a really small number, so it's hard to detect changes in utility accurately

   if ( (c < zero_tol) .and. ( rra< zero_tol ) ) then
      cons_func = zero_cons_value !something close to -infinity when c=0 would analytically result in the consumption function being -infinity
   else

      c_scaled = c * c_scale_param

      if (abs(rra-1) < rra_close_one_bound ) then
         cons_func = log(c_scaled)
      else
         cons_func = ( c_scaled**(1-rra) -1 )/ (1-rra)
      end if

   end if

end function cons_func

subroutine utility_function_setup(  kids_in, youngest_in, params_in, utility_params_out)
   !calcuates the weight on consumption and the value of leisure for a household at a period of time.  Made this a separate subroutine to reduce the number of times I need to take logs and exponents
 !  real*8, intent(in) :: m_leisure_mean_in
 !  real*8, intent(in) :: leisure_mean_in
   real*8, intent(in) :: kids_in
   real*8, intent(in) :: youngest_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8, dimension(n_utility_params), intent(out) :: utility_params_out

   real*8 :: m_leisure_mean_temp, leisure_mean_temp
   real*8 :: exp_m_leisure_mean, exp_leisure_mean
   real*8 :: m_leisure_weight, leisure_weight

   !add the affects of the kids and youngest variables
!   m_leisure_mean_temp = m_leisure_mean_in  + &
!      params_in(param_m_leisure_kids)         * kids_in  + &
!      params_in(param_m_leisure_youngest)     * youngest_in

   m_leisure_mean_temp = params_in( param_m_leisure_cons )

   leisure_mean_temp = params_in( param_leisure_cons ) + &
      params_in(param_leisure_kids)         * kids_in  + &
      params_in(param_leisure_youngest)     * youngest_in


!   if (kids_in > 0) then
!      leisure_mean_temp = leisure_mean_in + &
!   !   params_in(param_leisure_any_kids)   +
!      params_in(param_leisure_kids)         * kids_in  + &
!      params_in(param_leisure_youngest)     * youngest_in
!   else
!      leisure_mean_temp = leisure_mean_in
!   end if

!2/16/14, changing how I do things with the utility weight (having it be the weight for the consumption part of the utility funciton now)

!   !store the exponentiation to reduced the number of exp(.) calculations
!   exp_m_leisure_mean=exp(m_leisure_mean_temp )
!   exp_leisure_mean=exp(leisure_mean_temp )

!   utility_params_out( util_cons_weight )= params_in(param_weight_utility)/ &
!      (1+exp_m_leisure_mean+exp_leisure_mean)

!   utility_params_out( util_m_leisure_weight ) = &
!      exp_m_leisure_mean * utility_params_out( util_cons_weight )
!   utility_params_out( util_leisure_weight )  = &
!      exp_leisure_mean * utility_params_out( util_cons_weight )

   utility_params_out( util_cons_weight )=         params_in(param_weight_utility)
   utility_params_out( util_m_leisure_weight ) =   m_leisure_mean_temp
   utility_params_out( util_leisure_weight ) =     leisure_mean_temp


end subroutine utility_function_setup


function utility_function(mygrid_in, assets_next_in, utility_params_in, params_in)
   !this evaluate the utility function in my model.
   !utility_function setup needs to have been run already


   real*8 :: utility_function
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, intent(in) :: assets_next_in
   real*8, dimension(n_utility_params), intent(in) :: utility_params_in
   real*8, dimension(n_params), intent(in) :: params_in

   real*8 ::  cons_func_value, cons

   cons = mygrid_in % rv( var_assets) + inc_func( mygrid_in ) - assets_next_in
   cons = max( cons, min_cons_val )
   cons_func_value = cons_func( cons, params_in(param_rra) )

   utility_function = &
      utility_params_in( util_cons_weight ) * cons_func_value + &
      utility_params_in( util_m_leisure_weight ) * &
         (1- mygrid_in % iv( var_m_hours ) * hours_weight ) + &
      utility_params_in( util_leisure_weight ) * &
         (1- mygrid_in % iv( var_hours ) * hours_weight ) + &
      mygrid_in % rv( var_m_non_pec_norm ) * params_in(param_sd_non_pec) + &
      mygrid_in % rv( var_non_pec_norm ) * params_in(param_sd_non_pec) + &
      params_in( param_gender_reverse ) *  &   !params_in( param_weight_utility ) * & !2/16/14, not multiplying by the utility weight anymore
      ( 1 - mygrid_in % iv(var_m_job) ) * mygrid_in % iv(var_job)

!   !2/11/14 add the gender cost, coded seperatly to allow for this variable to be commented out
!   utility_function = utility_function - &
!      gender_reverse_cost * params_in( param_weight_utility ) * &
!      ( 1 - mygrid_in % iv(var_m_job) ) * mygrid_in % iv(var_job)



end function utility_function


subroutine print_utility_params(utility_params_in)
   real*8, dimension(n_utility_params), intent(in) :: utility_params_in

   print *, "cons_weight",    utility_params_in( util_cons_weight )
   print *, "m_leisure_weight ",   utility_params_in( util_m_leisure_weight  )
   print *, "leisure_weight ",   utility_params_in( util_leisure_weight  )

end subroutine print_utility_params





end module utility_function_mod


!!!!!!!!!!!!!!!!!!!!!!!!!!


module interp_support_mod

use enum_mod
use model_params_mod

   integer, parameter :: n_interact =  31  !0 31  !this needed to be checked to make sure it's right
   integer, parameter :: n_grid_points = 119 + n_interact !this needs to be checked to make sure its right

   integer, parameter :: n_interp_vars = 26
   integer, parameter :: n_interp_vars_discrete = 6 !number of discrete variables for my interpolation algorithm

   logical :: interp_setup_logical = .false. !whether the setup routines in this module have been called


   real*8, dimension(n_cont_vars) :: grid_mean !contains "means" for the grid I use to construct my statespace
   real*8, dimension(n_cont_vars) :: grid_sd !same thing, but for standard deviations (sd used loosely)
   real*8, dimension(n_cont_vars) :: grid_sd_inv !same thing, but for standard deviations (sd used loosely)
   real*8, dimension(n_cont_vars) :: grid_max !the largest possible value for a state variable
   real*8, dimension(n_cont_vars) :: grid_min


   !need to give more nodes for assets so that
   integer,parameter :: n_asset_nodes = 7
   real*8, dimension(0:n_asset_nodes) :: asset_nodes !these nodes are on the -1,1 hypercube
   integer, parameter :: n_coef_asset_max = n_asset_nodes + 2 !number of coeficents used for maximizing the value function wrt assets


   integer, dimension(n_cont_vars,0:1,0:1) :: var_present
   integer, dimension(n_interp_vars,0:1,0:1) :: interp_var_present


   integer, dimension(3, n_interact ) :: interact_list !list of interations I deal with for constructing the iterpolation vector


   real*8, parameter :: asset_sd_inc = 4 !for increasing the right tail for the asset distribution
   real*8 :: grid_sd_asset_inv2

   character(len=30), dimension(n_interp_vars) :: interp_var_labels
   character(len=30), dimension(n_grid_points) :: grid_labels


contains

function to_unit_cube_func( index_in, point_in ) result(cube_point)
   !converts my state space to the [1,1] hypercube
   integer, intent(in) :: index_in
   real*8, intent(in) :: point_in
   real*8 :: cube_point

   cube_point = ( point_in - grid_mean(index_in) ) * grid_sd_inv( index_in )

end function

function from_unit_cube_func( index_in, cube_point_in ) result(point)
   !converts my state space to the [1,1] hypercube
   integer, intent(in) :: index_in
   real*8, intent(in) :: cube_point_in
   real*8 :: point

   point = cube_point_in * grid_sd( index_in ) + grid_mean(index_in)

end function


subroutine mygrid_to_interp( mygrid_in, interp_vec_out)
   !converts a mygrid to an interpolation vector
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension( n_interp_vars ), intent(out) :: interp_vec_out

   integer :: m_job, job, m_no_ui, no_ui, i
   real*8, dimension(n_cont_vars) :: rv_convert
   real*8 :: length_temp

   m_job = mygrid_in % iv( var_m_job )
   job = mygrid_in % iv( var_job )
   m_no_ui =0
   no_ui = 0

   interp_vec_out = 0

   !do discrete variables first

   !job indicators
   interp_vec_out( interp_m_job ) = m_job
   interp_vec_out( interp_job ) = job

   !hours
   if ( mygrid_in % iv( var_m_hours ) .eq. 20 ) then
      interp_vec_out( interp_m_pt ) = 1
   end if

   if ( mygrid_in % iv( var_hours ) .eq. 20 ) then
      interp_vec_out( interp_pt ) = 1
   end if

   !no ui indicators
   if ( (  m_job .eq. 0 ) .and. ( mygrid_in % rv( var_m_ui_ben ) < zero_tol ) ) then

      m_no_ui = 1
      interp_vec_out( interp_m_no_ui ) = 1

   end if

   if ( (  job .eq. 0 ) .and. ( mygrid_in % rv( var_ui_ben ) < zero_tol ) ) then

      no_ui = 1
      interp_vec_out( interp_no_ui ) = 1

   end if


   !now the continuous variables

   !convert to unit cube
   do i = 1, n_cont_vars
      rv_convert(i) = to_unit_cube_func( i, mygrid_in % rv(i) )
   end do

   !now put this on the interpolation vector
   interp_vec_out( interp_m_wage_mean : interp_ur_state ) = &
      rv_convert( var_m_wage_mean: var_ur_state )

   interp_vec_out( interp_kids : interp_unemp_length ) = &
      rv_convert( var_kids: var_unemp_length )


  !modify the point for assets slightly
   if ( mygrid_in % rv ( var_assets) > grid_mean( var_assets ) ) then
      interp_vec_out( interp_assets ) = ( mygrid_in % rv( var_assets ) - grid_mean( var_assets) ) * &
         grid_sd_asset_inv2
   end if


   !now for the interpolation_specific variables.  What I do depends on whether this mygrid object is
      !for interation the value funciton of evaluation the likelihood function

   if ( allocated( mygrid_in % iter ) ) then !for iterating value function

      interp_vec_out( interp_m_ui_ben_pot ) = &
         to_unit_cube_func(  var_m_ui_ben, mygrid_in % iter( interp_m_ui_ben_pot )  )

      interp_vec_out( interp_ui_ben_pot ) = &
         to_unit_cube_func(  var_ui_ben, mygrid_in % iter( interp_ui_ben_pot )  )

      interp_vec_out( interp_m_ui_left ) = &
         to_unit_cube_func(  var_m_unemp_length, mygrid_in % iter( interp_m_ui_left )  )

      interp_vec_out( interp_ui_left ) = &
         to_unit_cube_func(  var_unemp_length, mygrid_in % iter( interp_ui_left )  )

   else !for evaluation the likelihood function

      !potential ui benefits
      interp_vec_out( interp_m_ui_ben_pot ) = to_unit_cube_func(  var_m_ui_ben, &
                                                               m_ui_ben_func(mygrid_in,m_job) )
      interp_vec_out( interp_ui_ben_pot ) = to_unit_cube_func( var_ui_ben, &
                                                               ui_ben_func(mygrid_in,job) )

      length_temp = nint( mygrid_in % rv( var_uilength) - mygrid_in % rv( var_m_unemp_length) )
      interp_vec_out( interp_m_ui_left ) = to_unit_cube_func( var_m_unemp_length, length_temp )

      length_temp = nint( mygrid_in % rv( var_uilength) - mygrid_in % rv( var_unemp_length) )
      interp_vec_out( interp_ui_left ) = to_unit_cube_func( var_unemp_length, length_temp )

   end if



   !now set some of the variabels to zero that aren't present
   if (m_job .eq. 1 ) then
      interp_vec_out( interp_m_no_ui ) = 0
      interp_vec_out( interp_m_ui_ben ) = 0
      interp_vec_out( interp_m_unemp_length ) = 0
      interp_vec_out( interp_m_ui_left ) = 0

   else
      interp_vec_out( interp_m_pt ) = 0
      interp_vec_out( interp_m_wage ) = 0
      interp_vec_out( interp_m_non_pec_norm ) = 0
      interp_vec_out( interp_m_job_length ) = 0
      interp_vec_out( interp_m_ui_ben_pot ) = 0

   end if

   if ( job .eq. 1 ) then
      interp_vec_out( interp_no_ui ) = 0
      interp_vec_out( interp_ui_ben ) = 0
      interp_vec_out( interp_unemp_length ) = 0
      interp_vec_out( interp_ui_left ) = 0

   else
      interp_vec_out( interp_pt ) = 0
      interp_vec_out( interp_wage ) = 0
      interp_vec_out( interp_non_pec_norm ) = 0
      interp_vec_out( interp_job_length ) = 0
      interp_vec_out( interp_ui_ben_pot ) = 0

   end if

   if ( m_no_ui .eq. 1 ) then
      interp_vec_out( interp_m_ui_ben ) = 0
      interp_vec_out( interp_m_ui_left ) = 0
   end if

   if ( no_ui .eq. 1 ) then
      interp_vec_out( interp_ui_ben ) = 0
      interp_vec_out( interp_ui_left ) = 0
   end if

   !and finally, make sure everything is between -1 and 1
   do i= n_interp_vars_discrete + 1, n_interp_vars
      interp_vec_out(i) = bounds_func( interp_vec_out(i), -1.0D+0, 1.0D+0 )
   end do




end subroutine


subroutine interp_to_mygrid( interp_vec_in, iter_switch_in, mygrid_out )
   !save as above subroutine but in reverse
   real*8, dimension( n_interp_vars ), intent(in) :: interp_vec_in
   logical, intent(in) :: iter_switch_in !controls whether to set up the iter part of the mygrid object
   type(mygrid_type), intent(out) :: mygrid_out

   integer :: m_job, job, m_no_ui, no_ui, i
   real*8, dimension(n_cont_vars ) :: rv_temp
   real*8 :: m_ui_ben_pot, ui_ben_pot, m_ui_left, ui_left

   m_job = nint( interp_vec_in( interp_m_job ) )
   job =   nint( interp_vec_in( interp_job ) )
   m_no_ui = nint( interp_vec_in( interp_m_no_ui ) )
   no_ui =   nint( interp_vec_in( interp_no_ui ) )

   if  ( iter_switch_in .eqv. .true. ) then
      call mygrid_out % iter_allocate()
   else
      call mygrid_out % allocate()
   end if

   !first some of the discrete variables
   mygrid_out % iv( var_m_job ) = m_job
   mygrid_out % iv( var_job ) = job

   if ( m_job .eq. 1 ) then
      if ( nint(interp_vec_in( interp_m_pt ) )  .eq. 1 ) then
         mygrid_out % iv( var_m_hours ) = 20
      else
         mygrid_out % iv( var_m_hours ) = 40
      end if

   else
      mygrid_out % iv( var_m_hours ) = 0

   end if

   if ( job .eq. 1 ) then
      if ( nint( interp_vec_in( interp_pt ) ) .eq. 1 ) then
         mygrid_out % iv( var_hours ) = 20
      else
         mygrid_out % iv( var_hours ) = 40
      end if

   else
      mygrid_out % iv( var_hours ) = 0

   end if

   !!!!
   !now for continuous variables
   !unpack some of them
   rv_temp( var_m_wage_mean: var_ur_state ) = &
      interp_vec_in( interp_m_wage_mean : interp_ur_state )

   rv_temp( var_kids: var_unemp_length ) = &
      interp_vec_in( interp_kids : interp_unemp_length )

   !and transforms these into the right grid
   do i =1, n_cont_vars
      mygrid_out % rv(i) = from_unit_cube_func( i, rv_temp(i) )

   end do

   !something slightly different for assets
   if ( interp_vec_in ( interp_assets ) > 0 ) then
      mygrid_out % rv( var_assets ) = &
         ( interp_vec_in( interp_assets ) ) * (1/grid_sd_asset_inv2 ) + &
         grid_mean( var_assets )
   end if

   !and also get the variables that don't go on the mygrid object
   !will use these later to construct ui max benefits and max duration
   if ( m_job .eq. 1 ) then

      m_ui_ben_pot = from_unit_cube_func( var_m_ui_ben, &
                                          interp_vec_in( interp_m_ui_ben_pot ) )
      m_ui_left = 0

   else if ( m_no_ui .eq. 0 ) then

      m_ui_ben_pot = 0

      m_ui_left = from_unit_cube_func( var_m_unemp_length, &
                                          interp_vec_in( interp_m_ui_left ) )

   else

      m_ui_ben_pot = 0

      m_ui_left = 0

   end if

   if ( job .eq. 1 ) then

      ui_ben_pot = from_unit_cube_func( var_ui_ben, &
                                          interp_vec_in( interp_ui_ben_pot ) )
      ui_left = 0

   else if ( no_ui .eq. 0 ) then

      ui_ben_pot = 0

      ui_left = from_unit_cube_func( var_unemp_length, &
                                          interp_vec_in( interp_ui_left ) )

   else

      ui_ben_pot = 0

      ui_left = 0

   end if

   !now assign these to the mygrid object
   if ( iter_switch_in .eqv. .true. ) then

      mygrid_out % iter( interp_m_ui_ben_pot ) = m_ui_ben_pot

      mygrid_out % iter( interp_ui_ben_pot ) = ui_ben_pot

      mygrid_out % iter( interp_m_ui_left ) = m_ui_left

      mygrid_out % iter( interp_ui_left ) =  ui_left


   end if



   !now set some of the variabels to zero that aren't present
   if (m_job .eq. 1 ) then
      mygrid_out % rv( var_m_ui_ben ) = 0
      mygrid_out % rv( var_m_unemp_length ) = 0
      m_ui_left  = 0

   else
      mygrid_out % rv( var_m_wage ) = 0
      mygrid_out % rv( var_m_non_pec_norm ) = 0
      mygrid_out % rv( var_m_job_length ) = 0
      m_ui_ben_pot = 0

   end if

   if ( m_no_ui .eq. 1 ) then
      mygrid_out % rv( var_m_ui_ben ) = 0
      m_ui_left  = 0
   end if


   if (job .eq. 1 ) then
      mygrid_out % rv( var_ui_ben ) = 0
      mygrid_out % rv( var_unemp_length ) = 0
      ui_left  = 0

   else
      mygrid_out % rv( var_wage ) = 0
      mygrid_out % rv( var_non_pec_norm ) = 0
      mygrid_out % rv( var_job_length ) = 0
      ui_ben_pot = 0

   end if

   if ( no_ui .eq. 1 ) then
      mygrid_out % rv( var_ui_ben ) = 0
      ui_left  = 0
   end if




   !now deal with the uimax and uilenght variables
   !!!!
   ! some things I do here are kind of shacky
   !!!


   !first set these variables equal to their mean values
   mygrid_out % rv( var_uimax) = grid_mean( var_uimax )
   mygrid_out % rv( var_uilength) = grid_mean( var_uilength )


   !need to do potential ui benefits
 !  m_ui_ben_pot_out = interp_vec_transform( interp_m_ui_ben_pot )
 !  ui_ben_pot_out = interp_vec_transform( interp_ui_ben_pot )

   !recover max length if receiving ui
   !can get this from either the husband or the wife
   if ( ( m_job .eq. 0) .and. ( m_no_ui .eq. 0 ) ) then
      mygrid_out % rv( var_uilength) = mygrid_out % rv( var_m_unemp_length ) + m_ui_left
   end if

   if ( ( job .eq. 0) .and. ( no_ui .eq. 0 ) ) then
      mygrid_out % rv( var_uilength) = max( mygrid_out % rv( var_unemp_length ) + ui_left, &
         mygrid_out % rv( var_uilength) )
   end if

   !this is a bit sketch, but for now, set the max ui benefits equal to the largest potential ui benefits
   if ( ( m_job .eq. 1) .or. ( job .eq. 1 ) ) then
      mygrid_out % rv( var_uimax) = max(  m_ui_ben_pot, ui_ben_pot )

   end if



end subroutine interp_to_mygrid


subroutine gen_var_present()
   integer :: m_job, job, i

   !this section of code declares whether a variable is present in a (m_job,job) subgrid as well as the respective interaction
   var_present=1
   interp_var_present=1

   m_job = 1
   var_present( var_m_ui_ben, m_job, :) = 0
   var_present( var_m_unemp_length, m_job, :) = 0

   interp_var_present( interp_m_ui_ben, m_job, :) = 0
   interp_var_present( interp_m_unemp_length, m_job, :) = 0
   interp_var_present( interp_m_ui_left, m_job, :) = 0
   interp_var_present( interp_m_no_ui, m_job, :) = 0


   m_job = 0
   var_present( var_m_wage, m_job, :) = 0
   var_present( var_m_non_pec_norm, m_job, :) = 0
   var_present( var_m_job_length, m_job, :) = 0

   interp_var_present( interp_m_wage, m_job, :) = 0
   interp_var_present( interp_m_non_pec_norm, m_job, :) = 0
   interp_var_present( interp_m_job_length, m_job, :) = 0
   interp_var_present( interp_m_ui_ben_pot, m_job, :) = 0

   job = 1
   var_present( var_ui_ben, :, job) = 0
   var_present( var_unemp_length, :, job) = 0

   interp_var_present( interp_ui_ben, :, job) = 0
   interp_var_present( interp_unemp_length, :, job) = 0
   interp_var_present( interp_ui_left, :, job ) = 0
   interp_var_present( interp_no_ui, :, job ) = 0


   job = 0
   var_present( var_wage, :, job ) = 0
   var_present( var_non_pec_norm, :, job) = 0
   var_present( var_job_length, :, job ) = 0

   interp_var_present( interp_wage, :, job) = 0
   interp_var_present( interp_non_pec_norm, :, job) = 0
   interp_var_present( interp_job_length, :, job) = 0
   interp_var_present( interp_ui_ben_pot, :, job) = 0


!   do m_job = 0, 1
!      do job = 0, 1
!         print *, "m_job", m_job, "job", job
!         do i=1,n_cont_vars
!            print *, var_labels(i), var_present(i, m_job, job )

!         end do
!      end do
!   end do

!   stop

end subroutine gen_var_present

subroutine gen_interact_list(interact_file_in)
   !sets up the list of interaction vectors
   character(len=30), intent(in) :: interact_file_in

   integer :: i, j, v, unit_int, n_interact_temp
   integer, dimension(n_interp_vars, n_interp_vars) :: interact_matrix
   character(len=30) :: char_ignore

   open( newunit=unit_int, file=interact_file_in, status = "old" )
   read(unit_int,*), char_ignore

   do i=1, n_interp_vars
      read( unit_int,*), char_ignore, (interact_matrix(i,j),j=1,n_interp_vars)
   end do

   close( unit_int )


   !now make sure some things in the interact matrix are 0
   !first, set any discrete interactions to 0 because I deal with these separatley
   interact_matrix( : n_interp_vars_discrete, : n_interp_vars_discrete ) = 0



   !now remove any interacts for variables in which one is only present if the spouse has a job
      !and another is only present if the spouse doesn't have a job
   !also set to 0 interactions job interactions that are automatic, like m_job*m_wage
   do  i = 1, n_interp_vars

      select case (i)

         case ( interp_m_pt, interp_m_wage, interp_m_non_pec_norm, interp_m_job_length, &
            interp_m_ui_ben_pot )

            interact_matrix( i, interp_m_job ) = 0
            interact_matrix( i, interp_m_no_ui ) = 0
            interact_matrix( i, interp_m_ui_ben ) = 0
            interact_matrix( i, interp_m_unemp_length ) = 0
            interact_matrix( i, interp_m_ui_left ) = 0

            interact_matrix( interp_m_job, i ) = 0
            interact_matrix( interp_m_no_ui, i ) = 0
            interact_matrix( interp_m_ui_ben, i ) = 0
            interact_matrix( interp_m_unemp_length, i ) = 0
            interact_matrix( interp_m_ui_left, i ) = 0

         case ( interp_m_ui_ben, interp_m_unemp_length, interp_m_ui_left )

            interact_matrix( i, interp_m_job ) = 0
            interact_matrix( i, interp_m_pt ) = 0
            interact_matrix( i, interp_m_wage ) = 0
            interact_matrix( i, interp_m_non_pec_norm ) = 0
            interact_matrix( i, interp_m_job_length ) = 0
            interact_matrix( i, interp_m_ui_ben_pot ) = 0

            interact_matrix( interp_m_job, i ) = 0
            interact_matrix( interp_m_pt, i ) = 0
            interact_matrix( interp_m_wage, i ) = 0
            interact_matrix( interp_m_non_pec_norm, i ) = 0
            interact_matrix( interp_m_job_length, i ) = 0
            interact_matrix( interp_m_ui_ben_pot, i ) = 0

         case ( interp_pt, interp_wage, interp_non_pec_norm, interp_job_length, &
            interp_ui_ben_pot )

            interact_matrix( i, interp_job ) = 0
            interact_matrix( i, interp_no_ui ) = 0
            interact_matrix( i, interp_ui_ben ) = 0
            interact_matrix( i, interp_unemp_length ) = 0
            interact_matrix( i, interp_ui_left ) = 0

            interact_matrix( interp_job, i ) = 0
            interact_matrix( interp_no_ui, i ) = 0
            interact_matrix( interp_ui_ben, i ) = 0
            interact_matrix( interp_unemp_length, i ) = 0
            interact_matrix( interp_ui_left, i ) = 0

         case ( interp_ui_ben, interp_unemp_length, interp_ui_left )

            interact_matrix( i, interp_job ) = 0
            interact_matrix( i, interp_pt ) = 0
            interact_matrix( i, interp_wage ) = 0
            interact_matrix( i, interp_non_pec_norm ) = 0
            interact_matrix( i, interp_job_length ) = 0
            interact_matrix( i, interp_ui_ben_pot ) = 0

            interact_matrix( interp_job, i ) = 0
            interact_matrix( interp_pt, i ) = 0
            interact_matrix( interp_wage, i ) = 0
            interact_matrix( interp_non_pec_norm, i ) = 0
            interact_matrix( interp_job_length, i ) = 0
            interact_matrix( interp_ui_ben_pot, i ) = 0

         !and something slightly different with the no_ui indicators
         case ( interp_m_no_ui )

            interact_matrix( i, interp_m_job ) = 0
            interact_matrix( i, interp_m_pt ) = 0
            interact_matrix( i, interp_m_wage ) = 0
            interact_matrix( i, interp_m_non_pec_norm ) = 0
            interact_matrix( i, interp_m_job_length ) = 0
            interact_matrix( i, interp_m_ui_ben_pot ) = 0

            interact_matrix( i, interp_m_ui_ben ) = 0
            interact_matrix( i, interp_m_ui_left ) = 0

            interact_matrix( i, interp_assets ) = 0





            interact_matrix( interp_m_job, i ) = 0
            interact_matrix( interp_m_pt, i ) = 0
            interact_matrix( interp_m_wage, i ) = 0
            interact_matrix( interp_m_non_pec_norm, i ) = 0
            interact_matrix( interp_m_job_length, i ) = 0
            interact_matrix( interp_m_ui_ben_pot, i ) = 0

            interact_matrix( interp_m_ui_ben, i ) = 0
            interact_matrix( interp_m_ui_left, i ) = 0

            interact_matrix( interp_assets, i ) = 0

         case ( interp_no_ui )

            interact_matrix( i, interp_job ) = 0
            interact_matrix( i, interp_pt ) = 0
            interact_matrix( i, interp_wage ) = 0
            interact_matrix( i, interp_non_pec_norm ) = 0
            interact_matrix( i, interp_job_length ) = 0
            interact_matrix( i, interp_ui_ben_pot ) = 0

            interact_matrix( i, interp_ui_ben ) = 0
            interact_matrix( i, interp_ui_left ) = 0

            interact_matrix( i, interp_assets ) = 0


            interact_matrix( interp_job, i ) = 0
            interact_matrix( interp_pt, i ) = 0
            interact_matrix( interp_wage, i ) = 0
            interact_matrix( interp_non_pec_norm, i ) = 0
            interact_matrix( interp_job_length, i ) = 0
            interact_matrix( interp_ui_ben_pot, i ) = 0

            interact_matrix( interp_ui_ben, i ) = 0
            interact_matrix( interp_ui_left, i ) = 0

            interact_matrix( interp_assets, i ) = 0


      end select

   end do

   !also set the ui_ben interactions with assets equal to zero becuase I handle those separately in my interpolation program
   interact_matrix( interp_assets, interp_m_ui_ben ) = 0
   interact_matrix( interp_m_ui_ben, interp_assets ) = 0

   interact_matrix( interp_assets, interp_ui_ben ) = 0
   interact_matrix( interp_ui_ben, interp_assets ) = 0

   !also for some interactions
   interact_matrix( interp_no_ui, interp_m_ui_ben ) = 0
   interact_matrix( interp_m_ui_ben, interp_no_ui ) = 0

   interact_matrix( interp_m_no_ui, interp_ui_ben ) = 0
   interact_matrix( interp_ui_ben, interp_m_no_ui ) = 0


   !now get the number of interactions
   n_interact_temp = count( interact_matrix > 0 )

   if ( n_interact_temp .ne. n_interact ) then
      print *, "I haven't set n_interact to right value, it should be ", n_interact_temp, &
         "but I've set it equal to ", n_interact
      stop
   end if



   !now the interaction variables for the value function
   v=0
   do i=2,n_interp_vars
   do j=1,i-1
      if ( (interact_matrix(i,j) > 0) ) then

         v=v+1
         interact_list(1, v) = i
         interact_list(2, v) = j
         interact_list(3, v) = interact_matrix(i,j)
      end if

   end do
   end do

   !now for printing an error if any of interactions between variable i and variable j, in which j is discrete and can't be negative, is
      !not 0 or in the 1st or second quadrant

   if ( any( interact_matrix(:, : n_interp_vars_discrete ) > 2) ) then
      print *, "there's a discrete interaction that's in the 3rd or 4th quadrant, which isn't allowed to happen"
      stop
   end if

   !now print error if any of the interaction matrix cells are greater than 4
   if ( any( interact_matrix(:, :  ) > 4) ) then
      print *, "there's an entry in the interaction matrix that's greater than 4, which isn't supposed to happen"
      stop
   end if



end subroutine gen_interact_list

subroutine gen_n_interp()
   integer :: n_grid_points_temp
   !gets the number of grid points and number of interp coefficients


   n_grid_points_temp = 9 + & !discrete variable
                        4*n_asset_nodes + & !number of asset splines
                        4*(n_interp_vars -n_interp_vars_discrete - 1 ) + & !number of 1d points (not including assets)
                        6 + & !number of asset and ui interactions
                        n_interact

   if(  n_grid_points_temp .ne. n_grid_points ) then
      print *, "n_grid_points equals", n_grid_points, "when it should equal ", n_grid_points_temp

      stop

   end if

end subroutine gen_n_interp





subroutine gen_grid_mean_sd()
   !generates the meand and variance for the grid for my statespace

   !time-invariante vars
   !I think to think about these function mean and variances more carefully
 !  grid_mean( var_m_joboffer_mean )=    -1.5
 !  grid_mean( var_joboffer_mean )=      -1.5
   grid_mean( var_m_wage_mean )=        2.5
   grid_mean( var_wage_mean )=          2.5
 !  grid_mean( var_m_leisure_mean )=     -3
 !  grid_mean( var_leisure_mean )=       -3
 !  grid_mean( var_m_jobloss_mean )=    -3
 !  grid_mean( var_jobloss_mean )=      -3
 !  grid_mean( var_m_jobloss_mean )=    -4
 !  grid_mean( var_jobloss_mean )=      -4
 !  grid_mean( var_m_ui_mean )=     -1.5   !IMPORTANT, I need to pick the UI means more carefully
 !  grid_mean( var_ui_mean )=       -1.5
 !  grid_mean( var_birth_mean )=    -7

   !ones that vary
   grid_mean( var_ur_state )=           8
   grid_mean( var_uimax )=              420
 !  grid_mean( var_uirate )=             .52
   grid_mean( var_uilength )=           14
   grid_mean( var_kids )=               2
   grid_mean( var_youngest )=           9
   grid_mean( var_assets )=             50000

   !job related variables
   grid_mean( var_m_wage )=             25
   grid_mean( var_wage )=               25
   grid_mean( var_m_non_pec_norm )=     0 !this is the non-pecuniary benefit divided by the variance
   grid_mean( var_non_pec_norm )=       0
   grid_mean( var_m_ui_ben )=           400
   grid_mean( var_ui_ben )=             400

   grid_mean( var_m_job_length )=       12
   grid_mean( var_job_length )=         12
   grid_mean( var_m_unemp_length )=     12
   grid_mean( var_unemp_length )=       12






   !time-invariante vars
   !I think to think about these function mean and variances more carefully
 !  grid_sd( var_m_joboffer_mean )=    1.5
 !  grid_sd( var_joboffer_mean )=      1.5
   grid_sd( var_m_wage_mean )=        1.5
   grid_sd( var_wage_mean )=          1.5
 !  grid_sd( var_m_leisure_mean )=     2
 !  grid_sd( var_leisure_mean )=       3
 !  grid_sd( var_m_jobloss_mean )=    1
 !  grid_sd( var_jobloss_mean )=      1
 !  grid_sd( var_m_ui_mean )=     1   !IMPORTANT, I need to pick the UI means more carefully
 !  grid_sd( var_ui_mean )=       1
 !  grid_sd( var_birth_mean )=    3

   !ones that vary
   grid_sd( var_ur_state )=           6
   grid_sd( var_uimax )=              200
 !  grid_sd( var_uirate )=             .15
   grid_sd( var_uilength )=           8
   grid_sd( var_kids )=               2
   grid_sd( var_youngest )=           9
   grid_sd( var_assets ) =            50000-1

   !job related variables
   grid_sd( var_m_wage )=             20
   grid_sd( var_wage )=               20
   grid_sd( var_m_non_pec_norm )=     2 !this is the non-pecuniary benefit divided by the variance
   grid_sd( var_non_pec_norm )=       2
   grid_sd( var_m_ui_ben )=           300
   grid_sd( var_ui_ben )=             300

   grid_sd( var_m_job_length )=       12
   grid_sd( var_job_length )=         12
   grid_sd( var_m_unemp_length )=     12
   grid_sd( var_unemp_length )=       12

!   grid_sd = grid_sd/10.0

   grid_max = grid_mean + grid_sd
   grid_min = grid_mean - grid_sd

   !set lb ui to 0.  I have the mean-sd not go to 0 so I can chose to have ui always be positive for when households are receiving ui,
      !but have it go to 0 when the spouse isn't receiving ui.
   grid_min( var_m_ui_ben ) = 0
   grid_min( var_ui_ben ) = 0


   grid_sd_inv=1/grid_sd


   !now deal with asset nodes
   asset_nodes(0) = -1
   asset_nodes(1) = -.975D+0
   asset_nodes(2) = -.90D+0
   asset_nodes(3) = -.75
   asset_nodes(4) = -.5
   asset_nodes(5) = 0
   asset_nodes(6) = .5
   asset_nodes(7) = 1

   !a higher grid sd for assets above mean
   grid_sd_asset_inv2 = 1/ ( grid_sd(var_assets)*asset_sd_inc )

!   print *,  grid_sd_inv( var_assets ), grid_sd_asset_inv2

   !slightly different for asset max
   grid_max(var_assets) = grid_mean(var_assets) + grid_sd(var_assets)*asset_sd_inc



end subroutine







subroutine get_mygrid_origin(m_job_in, job_in, mygrid_origin_out)
   !gets the origin mygrid type for a (m_job, job) combo
   integer, intent(in) :: job_in
   integer, intent(in) :: m_job_in
   type(mygrid_type), intent(out) :: mygrid_origin_out

   integer :: i

   call mygrid_origin_out % allocate()

  ! print *, "job indicators in", m_job_in, job_in

   do i=1,n_cont_vars
      if ( var_present(i, m_job_in, job_in ) .eq. 1) then
        ! print *, "variable  ", var_labels(i), "  present"
         mygrid_origin_out % rv(i) = grid_mean(i)
      else
         mygrid_origin_out % rv(i) = 0
      end if
   end do

   mygrid_origin_out % iv(var_m_job) = m_job_in
   mygrid_origin_out % iv(var_job) = job_in

   if ( m_job_in .eq. 1) then
      mygrid_origin_out % iv(var_m_hours) = 40
   else
      mygrid_origin_out % iv(var_m_hours) = 0
   end if

   if ( job_in .eq. 1) then
      mygrid_origin_out % iv(var_hours) = 40
   else
      mygrid_origin_out % iv(var_hours) = 0
   end if


end subroutine get_mygrid_origin







subroutine gen_interp_coef( values_in, coef_out )
   !generates interpolation coefficients for my my spline interplation
   real*8, dimension(n_grid_points), intent(in) :: values_in
   real*8, dimension(n_grid_points), intent(out) :: coef_out

   integer:: i, j, k, v, quadrant
   real*8 :: value_temp
   real*8 :: value_both_nojob, value_husband_job, value_wife_job, value_both_job !these are the "origin" values
   real*8 :: value_m_pt, value_pt
   real*8 :: value_m_no_ui, value_no_ui, value_both_no_ui
   real*8 :: value_asset_low_no_ui, value_asset_low_m_no_ui
   real*8 :: value_m_ui_ben_no_ui, value_ui_ben_m_no_ui
   real*8, dimension( n_interp_vars, 0:1, 0:1 ) :: point_neg, point_pos !the latter indexes are m_job, job
 !  real*8 :: m_wage_high_ft, m_wage_low_ft, wage_high_ft, wage_low_ft !used for constructing the wage and hours interaction

 !  print *, "doing discrete variables"

   !first do the main origin points
   value_both_nojob = values_in(1)
   coef_out(1) = value_both_nojob


   !now store the coeffient values for the the discrete variables
   value_husband_job = values_in(2)
   value_wife_job    = values_in(3)

   coef_out(2) = value_husband_job - value_both_nojob
   coef_out(3) = value_wife_job - value_both_nojob

   !store these values on the point_pos vector
   point_pos( interp_m_job, 0, 0 ) = value_husband_job !tad bit confusing.  Respresent the effect of starting at the both_no_job origin and then going to
      !point in which the husband has a job
   point_pos( interp_job, 0, 0 ) = value_wife_job

   !pt
   value_m_pt = values_in(4)
   value_pt   = values_in(5)

   coef_out(4) = value_m_pt - value_husband_job
   coef_out(5) = value_pt - value_wife_job

   point_pos( interp_m_pt, 1, 0 ) = value_m_pt
   point_pos( interp_pt, 0, 1 ) = value_pt

   !no ui
   value_m_no_ui = values_in(6)
   value_no_ui   = values_in(7)

   coef_out(6) = value_m_no_ui - value_both_nojob
   coef_out(7) = value_no_ui - value_both_nojob

   point_pos( interp_m_no_ui, 0, 0 ) = value_m_no_ui
   point_pos( interp_no_ui, 0, 0 ) = value_no_ui

   !now in
   !now store intraction between job indicators and no_ui indicators
   value_both_job = values_in(8)
   value_both_no_ui = values_in(9)

   coef_out(8) = value_both_job - value_husband_job - value_wife_job + value_both_nojob
   coef_out(9) = value_both_no_ui - value_m_no_ui -  value_no_ui + value_both_nojob

   !now store the interactions on the point positive matrix
   point_pos( interp_m_job, 0, 1 ) = value_both_job
   point_pos( interp_job, 1, 0 ) = value_both_job


   v= 9

   !now for assets

   !!!!!!!!!!!!!

   !now the assets coefficients
   !first to the spline where the household has no ui
   call asset_coef_gen( value_both_no_ui, values_in( v+1: v+n_asset_nodes ), &
      coef_out( v+1 : v+n_asset_nodes )  )

   v = v + n_asset_nodes

   !!!!!!!!!!!!!!!!!!!!!!

   !only husband with ui
   call asset_coef_gen( value_no_ui, values_in( v+1: v+n_asset_nodes ), &
      coef_out( v+1 : v+n_asset_nodes )  )

   value_asset_low_no_ui = values_in (v+1)

   v = v + n_asset_nodes


   !!!!!!!!!!!!!!!!!!!!!!!!!!!


   !now only wife with ui
   call asset_coef_gen( value_m_no_ui, values_in( v+1: v+n_asset_nodes ), &
      coef_out( v+1 : v+n_asset_nodes )  )

   value_asset_low_m_no_ui = values_in (v+1)


   v = v + n_asset_nodes

   !!!!!!!!!!!!!!!!!!!!!!!


   !now the main base spline where the household does have ui
   call asset_coef_gen( value_both_nojob, values_in( v+1: v+n_asset_nodes ), &
      coef_out( v+1 : v+n_asset_nodes )  )

   !do interaction here

   point_neg(interp_assets,0,0) = values_in( v+1 )
   point_pos(interp_assets,0,0) = values_in( v+7 )

   v = v + n_asset_nodes

   !!!!!!!!!!!!!!!!!!!!!!


   !now set up coefficients that entail perturbing points in only one direction

   !for 1d, do a linear spline through nodes -1,-.5,0,5,1, which yields 4 coefficients
      !execpt for assets, in which I use more nodes
 !  print *, "doing one dimensional points"

   do k = n_interp_vars_discrete + 1, n_interp_vars

      if ( k .ne. interp_assets ) then

         call coef_1d_gen( k, values_in(v+1:v+4), point_neg, point_pos, coef_out(v+1:v+4) )

         v = v+4

      end if !of whether or not this is the asset_variable

   end do

   !now do linear interaction terms in which I want a value for theta_ij*x_i*x_j, where the x's vary from -1,1 and
      !the theta varies depending on which quadrant I'm in.  the order is based on ordering for the cartesian graph
 !  print *, "doing 2 dimensional points"


   !do no_ui and ui_ben interactions
   call coef_interact_gen( interp_no_ui, interp_m_ui_ben, 4, values_in(v+1), point_neg, &
         point_pos, coef_out(v+1) )
   value_m_ui_ben_no_ui = values_in(v+1)


   call coef_interact_gen( interp_m_no_ui, interp_ui_ben, 4, values_in(v+2), point_neg, &
         point_pos, coef_out(v+2) )
   value_ui_ben_m_no_ui = values_in(v+2)

   v = v + 2


   !!!!!!!!!!!!!!!!
   !first do asset and ui interactions

   !only husband with ui
   call asset_ui_interact_gen(   values_in(v+1), &
                                 value_asset_low_no_ui, &
                                 value_m_ui_ben_no_ui, &
                                 value_no_ui, &
                                 coef_out(v+1) )


   !only wife with ui
   call asset_ui_interact_gen(   values_in(v+2), &
                                 value_asset_low_m_no_ui, &
                                 value_ui_ben_m_no_ui, &
                                 value_m_no_ui, &
                                 coef_out(v+2) )

   !both with ui
   call asset_ui_interact_gen(   values_in(v+3), &
                                 point_neg(interp_assets,0,0), &
                                 point_neg(interp_m_ui_ben,0,0), &
                                 value_both_nojob, &
                                 coef_out(v+3) )

   call asset_ui_interact_gen(   values_in(v+4), &
                                 point_neg(interp_assets,0,0), &
                                 point_neg(interp_ui_ben,0,0), &
                                 value_both_nojob, &
                                 coef_out(v+4) )

   v = v + 4




   do i=1, n_interact
      j = interact_list(1, i )
      k = interact_list(2, i )
      quadrant = interact_list( 3, i )

      call coef_interact_gen( j, k, quadrant, values_in(v+1), point_neg, &
         point_pos, coef_out(v+1) )


      v = v+1

   end do


contains

subroutine asset_coef_gen( origin_in, values_in, coef_out )
   !generates the asset coefficients
   real*8, intent(in) :: origin_in
   real*8, dimension( n_asset_nodes ), intent(in)  :: values_in
   real*8, dimension( n_asset_nodes), intent(out) :: coef_out

   !spline between -1 and -.975
                     ! -.975               ! -1
   coef_out(1) = (values_in(2) - values_in(1)) / abs( asset_nodes(1) - asset_nodes(0) )

   !spline between -.975 and -.9
                     ! -.9               ! -.975
   coef_out(2) = (values_in(3) - values_in(2)) / abs( asset_nodes(2) - asset_nodes(1) )

   !spline between -.9 and -.75
                     ! -.75               ! -.9
   coef_out(3) = (values_in(4) - values_in(3)) / abs( asset_nodes(3) - asset_nodes(2) )

   !spline between -.75 and -.5
                     ! -.5               ! -.75
   coef_out(4) = (values_in(5) - values_in(4)) / abs( asset_nodes(4) - asset_nodes(3) )

   !spline between -.5 and 0
                     ! 0              ! -.5
   coef_out(5) = (origin_in - values_in(5)) / abs( asset_nodes(5) - asset_nodes(4) )

   !spline between 0 and .5
                       ! .5             ! 0
   coef_out(6) = (values_in(6) - origin_in) / abs( asset_nodes(6) - asset_nodes(5) )

   !spline between .5 and 1
                       ! 1               ! .5
   coef_out(7) = (values_in(7) - values_in(6)) / abs( asset_nodes(7) - asset_nodes(6) )


end subroutine asset_coef_gen


subroutine coef_1d_gen( k, values_in, point_neg_inout, point_pos_inout, coef_out )
   !for generating points which vary in only one direction as well as adjusts the positive and negative values storage matrices
   integer, intent(in) :: k !index of the current variable in question
   real*8, dimension(4), intent(in) :: values_in
   real*8, dimension( n_interp_vars, 0:1, 0:1 ), intent(in out) :: point_neg_inout, point_pos_inout !the latter indexes are m_job, job
   real*8, dimension(4), intent(out) :: coef_out


   real*8 :: origin_temp, slope_temp

   !first figure out what the appropriate origin value is supposed to be
   select case(k)
      case ( interp_m_wage_mean : interp_youngest, interp_m_ui_ben, interp_ui_ben, &
         interp_m_unemp_length, interp_unemp_length, interp_m_ui_left, interp_ui_left)

         origin_temp = value_both_nojob

         point_neg_inout(k, 0, 0 ) = values_in(1)
         point_pos_inout(k, 0, 0 ) = values_in(4)

         point_neg_inout(k, 1, 0 ) = values_in(1) + value_husband_job - value_both_nojob
         point_pos_inout(k, 1, 0 ) = values_in(4) + value_husband_job - value_both_nojob

         point_neg_inout(k, 0, 1 ) = values_in(1) + value_wife_job - value_both_nojob
         point_pos_inout(k, 0, 1 ) = values_in(4) + value_wife_job - value_both_nojob

         point_neg_inout(k, 1, 1 ) = values_in(1) + value_both_job - value_both_nojob
         point_pos_inout(k, 1, 1 ) = values_in(4) + value_both_job - value_both_nojob


      case ( interp_m_wage, interp_m_non_pec_norm, interp_m_job_length, interp_m_ui_ben_pot )

         origin_temp = value_husband_job

         point_neg_inout(k, 1, 0 ) = values_in(1)
         point_pos_inout(k, 1, 0 ) = values_in(4)

         point_neg_inout(k, 1, 1 ) = values_in(1) + value_both_job - value_husband_job
         point_pos_inout(k, 1, 1 ) = values_in(4) + value_both_job - value_husband_job

      case ( interp_wage, interp_non_pec_norm, interp_job_length, interp_ui_ben_pot )

         origin_temp = value_wife_job

         point_neg_inout(k, 0, 1 ) = values_in(1)
         point_pos_inout(k, 0, 1 ) = values_in(4)

         point_neg_inout(k, 1, 1 ) = values_in(1) + value_both_job - value_wife_job
         point_pos_inout(k, 1, 1 ) = values_in(4) + value_both_job - value_wife_job

      case default

         print *, "error with select case for coef_1d_func"
         stop

   end select


   !spline between -1 and -5
                     ! -.5               ! -1
   coef_out(1) = (values_in(2) - values_in(1)) * 2  !2=1/.5, the step size

   !spline between -.5 and 0
                     ! 0              ! -.5
   coef_out(2) = (origin_temp - values_in(2)) * 2

   !spline between 0 and .5
                       ! .5             ! 0
   coef_out(3) = (values_in(3) - origin_temp) * 2

   !spline between .5 and 1
                       ! 1               ! .5
   coef_out(4) = (values_in(4) - values_in(3)) * 2


   !PATCH, the upper part of the the wage mean splits (from the 2nd to last to last node) was of the wrong direction.  Probabably should think of
      !better fix, but that's what I got for now
   if ( ( k .eq. interp_m_wage_mean ) .or. ( k .eq. interp_wage_mean ) ) then

       coef_out(3) = (values_in(4) - origin_temp)

       coef_out(4) = (values_in(4) - origin_temp)


   end if


!   !PATCH, the potential ui ben slopes from the lowest node to the second lowest node was way too step, so for now, having the slope for potential
   !ui be entirely linear, with only using the top node
   if ( ( k .eq. interp_m_ui_ben_pot ) .or. ( k .eq. interp_ui_ben_pot ) ) then

      slope_temp = (values_in(4) - origin_temp)

      coef_out(1:4) = slope_temp


   end if


end subroutine coef_1d_gen

subroutine asset_ui_interact_gen( interact_in, asset_low_in, ui_low_in, origin_in, coef_out )
   !subroutine for the asset and ui interactions
   real*8, intent(in) :: interact_in, asset_low_in, ui_low_in, origin_in
   real*8, intent(out) :: coef_out

   coef_out = interact_in - asset_low_in - ui_low_in + origin_in


end subroutine asset_ui_interact_gen


subroutine coef_interact_gen( j, k, quadrant_in, value_in, point_neg_inout, point_pos_inout, coef_out)
   !for generating points that interact with each other
   integer, intent(in) :: j !this is for the job variables, so it needs to equal 1 or 2
   integer, intent(in) :: k !index of the current variable in question
   integer, intent(in) :: quadrant_in !what quadrant this is for
   real*8, intent(in) :: value_in
   real*8, dimension( n_interp_vars, 0:1, 0:1 ), intent(in out) :: point_neg_inout, point_pos_inout !the latter indexes are m_job, job
   real*8 , intent(out) :: coef_out

   real*8 :: origin_temp
   integer :: m_job, job, m_job_new, job_new

   m_job = 0
   job = 0

   select case(j)

      case ( interp_m_pt, interp_m_wage, interp_m_non_pec_norm, interp_m_job_length, &
         interp_m_ui_ben_pot )

         m_job = 1

      case ( interp_pt, interp_wage, interp_non_pec_norm, interp_job_length, interp_ui_ben_pot )
         job = 1

   end select

   select case(k)

      case ( interp_m_pt, interp_m_wage, interp_m_non_pec_norm, interp_m_job_length, &
         interp_m_ui_ben_pot )

         m_job = 1

      case ( interp_pt, interp_wage, interp_non_pec_norm, interp_job_length, interp_ui_ben_pot )
         job = 1

   end select


   !now get what the origin value is supposed to be based on the job indicators
   if ( ( m_job .eq. 0 ) .and. ( job .eq. 0 ) )  then
      origin_temp = value_both_nojob

   else if ( job .eq. 0 )  then
      origin_temp = value_husband_job

   else if ( m_job .eq. 0 )  then
      origin_temp = value_wife_job

   else
      origin_temp = value_both_job

   end if



   !now generate the coefficients based on the quadrant it's for
   if ( quadrant_in .eq. 1 ) then
      coef_out =    value_in - point_pos_inout(j,m_job,job) - point_pos_inout(k,m_job,job) + origin_temp

   else if ( quadrant_in .eq. 2 ) then
      coef_out = -( value_in - point_neg_inout(j,m_job,job) - point_pos_inout(k,m_job,job) + origin_temp )

   else if ( quadrant_in .eq. 3 ) then
      coef_out =    value_in - point_neg_inout(j,m_job,job) - point_neg_inout(k,m_job,job) + origin_temp

   else !quadrant 4
      coef_out = -( value_in - point_pos_inout(j,m_job,job) - point_neg_inout(k,m_job,job) + origin_temp )
   end if


   !now update the point_pos and point_neg matrices if variabe k was one of the job indicators
   if ( k <= 2 ) then

      m_job_new = m_job
      job_new  = job


      select case( k)
         case ( interp_m_job )
            m_job_new = 1

         case ( interp_job )
            job_new = 1

         case default
            print *, "error with the job index"
            stop

      end select



      point_pos_inout(j, m_job_new, job_new) = coef_out +  point_pos_inout(j,m_job,job) + &
         point_pos_inout(k,m_job,job) - origin_temp


      point_neg_inout(j, m_job_new, job_new) = -coef_out +  point_neg_inout(j,m_job,job) + &
         point_pos_inout(k,m_job,job) - origin_temp

    !  print *, "value in", value_in
    !  print *, "point_pos_inout", point_pos_inout(j, m_job_new, job_new)

    !  stop

   end if





end subroutine coef_interact_gen




end subroutine gen_interp_coef










subroutine gen_grid_points( grid_points_out )
   !generates grids points on the -1,1 hypercube.
   real*8, dimension(n_interp_vars, n_grid_points), intent(out) :: grid_points_out

   integer:: i, j, k, v, quadrant

   grid_points_out = 0

   !first do the main origin points

   !now store the coeffient values for the the discrete variables
   !job points
   grid_points_out( interp_m_job, 2) = 1

   grid_points_out( interp_job, 3) = 1


   !pt
   grid_points_out( interp_m_job, 4) = 1
   grid_points_out( interp_m_pt, 4) = 1

   grid_points_out( interp_job, 5) = 1
   grid_points_out( interp_pt, 5) = 1


   !no ui
   grid_points_out( interp_m_no_ui, 6) = 1

   grid_points_out( interp_no_ui, 7) = 1

   !now for interactions between job indicators and no ui indicators
   grid_points_out( interp_m_job, 8) = 1
   grid_points_out( interp_job, 8) = 1

   grid_points_out( interp_m_no_ui, 9) = 1
   grid_points_out( interp_no_ui, 9) = 1


   v= 9

   !now the assets coefficients

   !!!!!!!!!!!!!!!!!!!!!!!!!!!!

   !first to the spline where the household has no ui
   grid_points_out( interp_m_no_ui, v+1: v + n_asset_nodes ) = 1
   grid_points_out( interp_no_ui, v+1: v + n_asset_nodes ) = 1

   grid_points_out( interp_assets, v+1: v + 5 ) = asset_nodes(0: 4 )
   grid_points_out( interp_assets, v+6: v + 7 ) = asset_nodes(6: 7 )

   v = v + n_asset_nodes

   !!!!!!!

   !now the spline where only the husband has ui
   grid_points_out( interp_no_ui, v+1: v + n_asset_nodes ) = 1

   grid_points_out( interp_assets, v+1: v + 5 ) = asset_nodes(0: 4 )
   grid_points_out( interp_assets, v+6: v + 7 ) = asset_nodes(6: 7 )

   v = v + n_asset_nodes

   !!!!!!!!!!!!!!

   !now the spline where only the wife has ui
   grid_points_out( interp_m_no_ui, v+1: v + n_asset_nodes ) = 1

   grid_points_out( interp_assets, v+1: v + 5 ) = asset_nodes(0: 4 )
   grid_points_out( interp_assets, v+6: v + 7 ) = asset_nodes(6: 7 )

   v = v + n_asset_nodes

   !!!!!!!!!!!

   !now the main base spline where the household does have ui
   grid_points_out( interp_assets, v+1: v + 5 ) = asset_nodes(0: 4 )
   grid_points_out( interp_assets, v+6: v + 7 ) = asset_nodes(6: 7 )

   v = v + n_asset_nodes


   !now set up coefficients that entail perturbing points in only one direction

   do k = n_interp_vars_discrete + 1, n_interp_vars

      if ( k .ne. interp_assets ) then

         grid_points_out( k, v+1 ) = -1
         grid_points_out( k, v+2 ) = -.5

         grid_points_out( k, v+3 ) = .5
         grid_points_out( k, v+4 ) = 1

         call grid_assign_support( k, grid_points_out(:, v+1 ) )
         call grid_assign_support( k, grid_points_out(:, v+2 ) )
         call grid_assign_support( k, grid_points_out(:, v+3 ) )
         call grid_assign_support( k, grid_points_out(:, v+4 ) )

         v = v+4

      end if !of whether or not this is the asset_variable

   end do

   !now no_ui and ui interactions
   grid_points_out( interp_no_ui,      v+1 ) = 1
   grid_points_out( interp_m_ui_ben,   v+1 ) = -1

   grid_points_out( interp_m_no_ui, v+2 )   = 1
   grid_points_out( interp_ui_ben,  v+2 )   = -1

   v = v + 2

   !now the ui and asset interaction terms
   grid_points_out( interp_assets, v+1: v + 4 ) = -1

   grid_points_out( interp_no_ui,      v+1 ) = 1
   grid_points_out( interp_m_ui_ben,   v+1 ) = -1

   grid_points_out( interp_m_no_ui, v+2 )   = 1
   grid_points_out( interp_ui_ben,  v+2 )   = -1

   grid_points_out( interp_m_ui_ben,   v+3 )   = -1
   grid_points_out( interp_ui_ben,     v+4 )   = -1

   v = v+ 4


   !now for interaction terms
   do i=1, n_interact
      j = interact_list(1, i )
      k = interact_list(2, i )
      quadrant = interact_list( 3, i )

      if ( quadrant .eq. 1 ) then
         grid_points_out(j,v+1) = 1
         grid_points_out(k,v+1) = 1

      else if ( quadrant .eq. 2 ) then
         grid_points_out(j,v+1) = -1
         grid_points_out(k,v+1) = 1

      else if ( quadrant .eq. 3 ) then
         grid_points_out(j,v+1) = -1
         grid_points_out(k,v+1) = -1

      else !quadrant 4
         grid_points_out(j,v+1) = 1
         grid_points_out(k,v+1) = -1

      end if

      call grid_assign_support ( j, grid_points_out( :,v+1 ) )
      call grid_assign_support ( k, grid_points_out( :,v+1 ) )

      v = v+1

   end do

contains

subroutine grid_assign_support(index_in, grid_point_inout )
   !given index_in, determines whether any of the job indicators need to be set to 1
   integer, intent(in) :: index_in
   real*8, dimension( n_interp_vars ) :: grid_point_inout

   select case( index_in )

      case ( interp_m_pt, interp_m_wage, interp_m_non_pec_norm, interp_m_job_length, interp_m_ui_ben_pot )

         grid_point_inout( interp_m_job ) = 1


      case ( interp_pt, interp_wage, interp_non_pec_norm, interp_job_length, interp_ui_ben_pot )

         grid_point_inout( interp_job ) = 1


   end select


end subroutine grid_assign_support

end subroutine gen_grid_points









function interp_asset_func( x_in, coef_in )
   !a special interp function just for assets since it has extra nodes
   real*8 :: interp_asset_func
 ! ******************************************
 ! Created variables to reduce repeated vector lookups
   real*8 :: node1, node2, node3, node4, node5, node6
 ! ******************************************
   real*8, intent(in) :: x_in !this need to vary between -1 and 1
   real*8, dimension(n_asset_nodes ) ::  coef_in

 ! ******************************************
 ! Saved values instead of repeatedly looking them up
   node1 = asset_nodes(1)
   node2 = asset_nodes(2)
   node3 = asset_nodes(3)
   node4 = asset_nodes(4)
   node5 = asset_nodes(5)
   node6 = asset_nodes(6)
 ! ******************************************

 ! ******************************************
 ! Reordered if's in a binary search
 ! ******************************************
   if ( x_in < node4 ) then
      if ( x_in < node2 ) then
         if ( x_in < node1 ) then
            interp_asset_func = ( x_in - node1 ) * coef_in(1) &
                           -abs( node2 - node1 ) * coef_in(2) &
                           -abs( node3 - node2 ) * coef_in(3) &
                           -abs( node4 - node3 ) * coef_in(4) &
                           -abs( node5 - node4 ) * coef_in(5)
         else
            interp_asset_func = ( x_in - node2 ) * coef_in(2) &
                           -abs( node3 - node2 ) * coef_in(3) &
                           -abs( node4 - node3 ) * coef_in(4) &
                           -abs( node5 - node4 ) * coef_in(5)
         endif
      else
         if ( x_in < node3 ) then
            interp_asset_func = ( x_in - node3 ) * coef_in(3) &
                           -abs( node4 - node3 ) * coef_in(4) &
                           -abs( node5 - node4 ) * coef_in(5)
         else
            interp_asset_func = ( x_in - node4 ) * coef_in(4) &
                           -abs( node5 - node4 ) * coef_in(5)
         endif
      endif
   else
      if ( x_in < node6 ) then
         if ( x_in < node5 ) then
            interp_asset_func = x_in * coef_in(5)
         else
            interp_asset_func = x_in * coef_in(6)
         endif
      else
         interp_asset_func = node6 * coef_in(6) + (x_in - node6 )* coef_in(7)
      endif

   endif


end function interp_asset_func



function interp_func( cube_point_in, coef_vec_in )
   !does interpolation for a (m_job,job) combo with splines
   real*8 :: interp_func
   real*8, dimension(n_interp_vars), intent(in) :: cube_point_in
   real*8, dimension(n_grid_points), intent(in) :: coef_vec_in !the parameters


 ! ******************************************
 ! Created variables to reduce repeated vector lookups
   real*8 :: cubeP_k, cubeP_j
 ! ******************************************
   integer :: m_job, job, i, j, k, v, m_no_ui, no_ui

   !this makes code easier to read and reduces amount of array lookup
   m_job = nint(cube_point_in( interp_m_job ) )
   job = nint(cube_point_in( interp_job ) )

   m_no_ui =  nint(cube_point_in( interp_m_no_ui ) )
   no_ui =  nint(cube_point_in( interp_no_ui ) )


  ! call mygrid_to_interp( mygrid_in, cube_point_in )

!   do i = 1, n_interp_vars
!      print *, interp_var_labels(i), cube_point_in(i)

!   end do

!   stop

  ! v=1 !initialize counter

 ! ******************************************
 !  Removed line :  interp_func = 0
 !  because interp_func is immediately reset
 !  to coef_vec_in(v) on the next line
 ! ******************************************

 !  print *, "interp_func ", interp_func

   interp_func = coef_vec_in(1)
   !so I start at 0^n, so the final interpolation function is based on deviations from 0

   !do the discrete variables first
   interp_func = interp_func + dot_product(  coef_vec_in(2:7), &
                                             cube_point_in( interp_m_job : interp_no_ui ) )
   !some key interactions
   interp_func = interp_func + coef_vec_in(8) * cube_point_in( interp_m_job) * cube_point_in( interp_job)
   interp_func = interp_func + coef_vec_in(9) * cube_point_in( interp_m_no_ui) * cube_point_in( interp_no_ui)

   v = 9



   !now do assets, in which what I do depends on hh receiveds ui

   if ( ( m_no_ui .eq. 1 ) .and. (no_ui .eq. 1 ) ) then !both not receiving ui

      !do the asset interpolation for both not having a job and not having ui
      interp_func = interp_func + interp_asset_func( cube_point_in( interp_assets ), &
         coef_vec_in(v+1: v+n_asset_nodes) )

      v = v + 4*n_asset_nodes


   else if ( ( m_job .eq. 0 ) .and. ( no_ui .eq. 1 ) ) then !husband receiving ui

      v = v + n_asset_nodes

      interp_func = interp_func + interp_asset_func( cube_point_in( interp_assets ), &
         coef_vec_in(v+1: v+n_asset_nodes) )

       v = v + 3*n_asset_nodes

   else if ( ( m_no_ui .eq. 1 ) .and. ( job .eq. 0 ) ) then !wife receiving ui

      !n_assets_nodes + 1 for this case
      v = v + 2*n_asset_nodes

      interp_func = interp_func + interp_asset_func( cube_point_in( interp_assets ), &
         coef_vec_in(v+1: v+n_asset_nodes) )

       v = v + 2*n_asset_nodes

   else !base case, either both receiving ui or one/both have a job

      !n_asset_nodes +2 for this case
      v = v + 3*n_asset_nodes

      !this is the asset interpolation function for when the household has other sourses of income
      interp_func = interp_func + interp_asset_func( cube_point_in( interp_assets ), &
         coef_vec_in(v+1: v+n_asset_nodes) )

       v = v + n_asset_nodes

   end if


  ! print *, "interp func after dealing with assets", interp_func


   !now do points that vary in one direction



 !  print *, "interp_func ", interp_func

   !1d points
   do k = n_interp_vars_discrete + 1, n_interp_vars
 ! ******************************************
 ! Saved value instead of repeatedly looking it up
      cubeP_k = cube_point_in(k)
 ! ******************************************

      if ( k .ne. interp_assets) then

         if ( cubeP_k < -.5 ) then

            interp_func = interp_func + coef_vec_in(v+1) * ( cubeP_k + .5 )  &
                  -.5*coef_vec_in(v+2) !connecting the dots requires subtracting the last term

         else if ( cubeP_k < 0 ) then

            interp_func = interp_func + coef_vec_in(v+2) * cubeP_k

         else if ( cubeP_k < .5 ) then

            interp_func = interp_func + coef_vec_in(v+3) * cubeP_k

         else

            interp_func = interp_func + coef_vec_in(v+4) * ( cubeP_k -.5 )  &
                  +.5* coef_vec_in(v+3)

         end if

         v = v+4

      end if

   !   print *, "interp_func ", interp_func

   end do

  ! print *, "interp func after dealing with 1d points", interp_func

   !interact terms no ui and ui

   interp_func = interp_func + (1-m_no_ui) * no_ui  * &
      cube_point_in( interp_m_ui_ben ) *  &
      coef_vec_in(v+1)

   interp_func = interp_func + m_no_ui * (1-no_ui) * &
      cube_point_in( interp_ui_ben ) * &
      coef_vec_in(v+2)

   v = v + 2

   !interaction terms with assets and ui

   !only husband receiving ui
   interp_func = interp_func + (1-m_no_ui) * no_ui  * &
      cube_point_in( interp_assets ) * cube_point_in( interp_m_ui_ben ) *  &
      coef_vec_in(v+1)

   !only wife receiving ui
   interp_func = interp_func + m_no_ui * (1-no_ui) * &
      cube_point_in( interp_assets ) * cube_point_in( interp_ui_ben ) * &
      coef_vec_in(v+2)

   !base case
   interp_func = interp_func + (1-m_no_ui) * (1-no_ui) * &
      cube_point_in( interp_assets ) * cube_point_in( interp_m_ui_ben ) *  &
      coef_vec_in(v+3)

   interp_func = interp_func + (1-m_no_ui) * (1-no_ui) * &
      cube_point_in( interp_assets ) * cube_point_in( interp_ui_ben ) *  &
      coef_vec_in(v+4)

   v = v + 4


   !interaction terms
   do i=1, n_interact
      j = interact_list(1, i )
      k = interact_list(2, i )

 ! ******************************************
 ! Saved values instead of repeatedly looking them up
      cubeP_j = cube_point_in(j)
      cubeP_k = cube_point_in(k)
 ! ******************************************
    !  print *, "variables ", var_labels( j), var_labels(k)


      interp_func = interp_func + coef_vec_in(v+1) * cubeP_j * cubeP_k

      v=v+1

     ! print *, "interp_func ", interp_func

   end do


  ! print *, "interp final", interp_func




end function interp_func











subroutine gen_coef_asset_max( cube_point_in, coef_vec_in, coef_out )
   !does partial interpolation to prepare for maximizing the value function wrt assets
   real*8, dimension(n_interp_vars), intent(in) :: cube_point_in
   real*8, dimension(n_grid_points), intent(in) :: coef_vec_in !the parameters
   real*8, dimension(n_coef_asset_max), intent(out) :: coef_out


 ! ******************************************
 ! Created variables to reduce repeated vector lookups
   real*8 :: cubeP_k, cubeP_j
   real*8 :: cons_temp !this will eventually be coef_out(1), the collection of all the linear combinations that don't involve assets
   real*8 :: interact_temp !this will eventually be coef_out(n_coef_asset_max), the collection of all terms involving interaction between
      !assets and another variable
 ! ******************************************
   integer :: m_job, job, i, j, k, v, m_no_ui, no_ui

   !this makes code easier to read and reduces amount of array lookup
   m_job = nint(cube_point_in( interp_m_job ) )
   job = nint(cube_point_in( interp_job ) )

   m_no_ui =  nint(cube_point_in( interp_m_no_ui ) )
   no_ui =  nint(cube_point_in( interp_no_ui ) )

   !initialize the interaction term to 0
   interact_temp = 0


  ! call mygrid_to_interp( mygrid_in, cube_point_in )

!   do i = 1, n_interp_vars
!      print *, interp_var_labels(i), cube_point_in(i)

!   end do

!   stop

  ! v=1 !initialize counter

 ! ******************************************
 !  Removed line :  interp_func = 0
 !  because interp_func is immediately reset
 !  to coef_vec_in(v) on the next line
 ! ******************************************

 !  print *, "interp_func ", interp_func

   cons_temp = coef_vec_in(1)
   !so I start at 0^n, so the final interpolation function is based on deviations from 0

   !do the discrete variables first
   cons_temp = cons_temp + dot_product(  coef_vec_in(2:7), &
                                             cube_point_in( interp_m_job : interp_no_ui ) )
   !some key interactions
   cons_temp = cons_temp + coef_vec_in(8) * cube_point_in( interp_m_job) * cube_point_in( interp_job)
   cons_temp = cons_temp + coef_vec_in(9) * cube_point_in( interp_m_no_ui) * cube_point_in( interp_no_ui)

   v = 9



   !now do assets, in which what I do depends on hh receiveds ui

   if ( ( m_no_ui .eq. 1 ) .and. (no_ui .eq. 1 ) ) then !both not receiving ui

      !do the asset interpolation for both not having a job and not having ui
      coef_out(2 : 1 + n_asset_nodes) = coef_vec_in(v+1: v+n_asset_nodes)

      v = v + 4*n_asset_nodes


   else if ( ( m_job .eq. 0 ) .and. ( no_ui .eq. 1 ) ) then !husband receiving ui

      v = v + n_asset_nodes

      coef_out(2 : 1 + n_asset_nodes) = coef_vec_in(v+1: v+n_asset_nodes)

       v = v + 3*n_asset_nodes

   else if ( ( m_no_ui .eq. 1 ) .and. ( job .eq. 0 ) ) then !wife receiving ui

      !n_assets_nodes + 1 for this case
      v = v + 2*n_asset_nodes

      coef_out(2 : 1 + n_asset_nodes) = coef_vec_in(v+1: v+n_asset_nodes)

       v = v + 2*n_asset_nodes

   else !base case, either both receiving ui or one/both have a job

      !n_asset_nodes +2 for this case
      v = v + 3*n_asset_nodes

      !this is the asset interpolation function for when the household has other sourses of income
      coef_out(2 : 1 + n_asset_nodes) = coef_vec_in(v+1: v+n_asset_nodes)

       v = v + n_asset_nodes

   end if


  ! print *, "interp func after dealing with assets", interp_func


   !now do points that vary in one direction



 !  print *, "interp_func ", interp_func

   !1d points
   do k = n_interp_vars_discrete + 1, n_interp_vars
 ! ******************************************
 ! Saved value instead of repeatedly looking it up
      cubeP_k = cube_point_in(k)
 ! ******************************************

      if ( k .ne. interp_assets) then

         if ( cubeP_k < -.5 ) then

            cons_temp = cons_temp + coef_vec_in(v+1) * ( cubeP_k + .5 )  &
                  -.5*coef_vec_in(v+2) !connecting the dots requires subtracting the last term

         else if ( cubeP_k < 0 ) then

            cons_temp = cons_temp + coef_vec_in(v+2) * cubeP_k

         else if ( cubeP_k < .5 ) then

            cons_temp = cons_temp + coef_vec_in(v+3) * cubeP_k

         else

            cons_temp = cons_temp + coef_vec_in(v+4) * ( cubeP_k -.5 )  &
                  +.5* coef_vec_in(v+3)

         end if

         v = v+4

      end if

   !   print *, "interp_func ", interp_func

   end do

  ! print *, "interp func after dealing with 1d points", interp_func

   !interact terms no ui and ui

   cons_temp = cons_temp + (1-m_no_ui) * no_ui  * &
      cube_point_in( interp_m_ui_ben ) *  &
      coef_vec_in(v+1)

   cons_temp = cons_temp + m_no_ui * (1-no_ui) * &
      cube_point_in( interp_ui_ben ) * &
      coef_vec_in(v+2)

   v = v + 2

   !interaction terms with assets and ui

   !only husband receiving ui
   interact_temp = interact_temp + (1-m_no_ui) * no_ui  * &
      cube_point_in( interp_m_ui_ben ) *  &
      coef_vec_in(v+1)

   !only wife receiving ui
   interact_temp = interact_temp + m_no_ui * (1-no_ui) * &
      cube_point_in( interp_ui_ben ) * &
      coef_vec_in(v+2)

   !base case
   interact_temp = interact_temp + (1-m_no_ui) * (1-no_ui) * &
      cube_point_in( interp_m_ui_ben ) *  &
      coef_vec_in(v+3)

   interact_temp = interact_temp + (1-m_no_ui) * (1-no_ui) * &
      cube_point_in( interp_ui_ben ) *  &
      coef_vec_in(v+4)

   v = v + 4


   !interaction terms
   do i=1, n_interact
      j = interact_list(1, i )
      k = interact_list(2, i )

 ! ******************************************
 ! Saved values instead of repeatedly looking them up
      cubeP_j = cube_point_in(j)
      cubeP_k = cube_point_in(k)
 ! ******************************************
    !  print *, "variables ", var_labels( j), var_labels(k)

      if ( ( j .ne. interp_assets ) .and. ( k .ne. interp_assets ) ) then

         cons_temp = cons_temp + coef_vec_in(v+1) * cubeP_j * cubeP_k

      else if ( j .eq. interp_assets ) then

         interact_temp = interact_temp +  coef_vec_in(v+1) *  cubeP_k

      else if ( k .eq. interp_assets ) then

         interact_temp = interact_temp +  coef_vec_in(v+1) *  cubeP_j

      else
         print *, "error in gen_coef_asset_max"
         stop
      end if


      v=v+1

     ! print *, "interp_func ", interp_func

   end do

   !now finally put the constanst and interaction term on the output vector
   coef_out(1) = cons_temp
   coef_out(n_coef_asset_max) = interact_temp


  ! print *, "interp final", interp_func




end subroutine gen_coef_asset_max







subroutine gen_interp_labels()
   !sets up the interp_var_labels vector as well as the grid_labels vector
   integer :: v,i,j,k

   interp_var_labels( interp_m_job )=              "m_job"
   interp_var_labels( interp_job )=                "job"
   interp_var_labels( interp_m_pt )=               "m_pt" !this is the non-pecuniary benefit divided by the variance
   interp_var_labels( interp_pt )=                 "pt"
   interp_var_labels( interp_m_no_ui )=            "m_no_ui"
   interp_var_labels( interp_no_ui )=             "no_ui"


   interp_var_labels( interp_m_wage_mean )=         "m_wage_mean"
   interp_var_labels( interp_wage_mean )=           "wage_mean"

   !ones that vary
   interp_var_labels( interp_ur_state )=           "ur_state"

   interp_var_labels( interp_kids )=               "kids"
   interp_var_labels( interp_youngest )=           "youngest"
   interp_var_labels( interp_assets )=             "assets"

   !job related variables
   interp_var_labels( interp_m_wage )=             "m_wage"
   interp_var_labels( interp_wage )=               "wage"
   interp_var_labels( interp_m_non_pec_norm )=     "m_non_pec_norm" !this is the non-pecuniary benefit divided by the variance
   interp_var_labels( interp_non_pec_norm )=       "non_pec_norm"
   interp_var_labels( interp_m_ui_ben )=           "m_ui_ben"
   interp_var_labels( interp_ui_ben )=             "ui_ben"

   interp_var_labels( interp_m_job_length ) =      "m_job_length"
   interp_var_labels( interp_job_length ) =        "job_length"
   interp_var_labels( interp_m_unemp_length )=     "m_unemp_length"
   interp_var_labels( interp_unemp_length ) =      "unemp_length"

   !some extra variables
   interp_var_labels( interp_m_ui_ben_pot )=       "m_ui_ben_pot"
   interp_var_labels( interp_ui_ben_pot )=         "ui_ben_pot"
   interp_var_labels( interp_m_ui_left )=          "m_ui_left" !this is the non-pecuniary benefit divided by the variance
   interp_var_labels( interp_ui_left )=            "ui_left"


   !now generates the grid labels
   grid_labels(1) = "cons"

   grid_labels(2) = "m_job"
   grid_labels(3) = "job"
   grid_labels(4) = "m_pt"
   grid_labels(5) = "pt"
   grid_labels(6) = "m_no_ui"
   grid_labels(7) = "no_ui"
   grid_labels(8) = "m_no_ui"
   grid_labels(9) = "no_ui"

   v=9

   do k=1,n_asset_nodes
      grid_labels(v + k) = "assets_no_ui1_" // trim( int_to_string(k) )

   end do

   v = v+ n_asset_nodes

   do k=1,n_asset_nodes
      grid_labels(v + k) = "assets_no_ui2_" // trim( int_to_string(k) )

   end do

   v = v+ n_asset_nodes

   do k=1,n_asset_nodes
      grid_labels(v + k) = "assets_no_ui3_" // trim( int_to_string(k) )

   end do

   v = v+ n_asset_nodes

   do k=1,n_asset_nodes
      grid_labels(v + k) = "assets_" // trim( int_to_string(k) )

   end do

   v = v+ n_asset_nodes


   do k = n_interp_vars_discrete + 1, n_interp_vars

      if ( k .ne. interp_assets ) then

         do i = 1, 4
            grid_labels( v+ i ) = trim( interp_var_labels( k) ) // "_" // trim( int_to_string(i) )
         end do

         v = v+4

      end if !of whether or not this is the asset_variable

   end do

   grid_labels( v+ 1 ) = "no_ui_m_ui_ben"
   grid_labels( v+ 2 ) = "m_no_ui_ui_ben"

   v = v + 2

   grid_labels( v+ 1 ) = "asset_m_ui_1"
   grid_labels( v+ 2 ) = "asset_ui_1"
   grid_labels( v+ 3 ) = "asset_m_ui_2"
   grid_labels( v+ 4 ) = "asset_ui_2"

   v= v+4

   !now for interaction terms
   do i=1, n_interact
      j = interact_list(1, i )
      k = interact_list(2, i )

      grid_labels( v + 1 ) = trim( interp_var_labels(j) ) // "_" //trim( interp_var_labels( k) )

      v = v+1

   end do



end subroutine gen_interp_labels

subroutine interp_setup_all(interact_file_in) !setup up all the assorted matrices and vector for working with the ols interpolation function
   character(len=30), intent(in) :: interact_file_in

   interp_setup_logical = .true.

   call gen_grid_mean_sd()
   call gen_interact_list(interact_file_in)
   call gen_var_present()
   call gen_n_interp()
   call gen_interp_labels
   call gen_var_labels



end subroutine interp_setup_all



subroutine mygrid_bounds_all( mygrid_inout )
   !puts all the variables for the mygrid object with the right bounds.  Also sets the non-present variables
      !to zero in case this hasn't been done already.
   type(mygrid_type), intent(in out ) :: mygrid_inout
   integer :: i

   do i = 1, n_cont_vars

      select case(i)

         case ( : var_assets)

            mygrid_inout % rv(i) = bounds_func( mygrid_inout % rv(i), &
               grid_min(i), grid_max(i) )

         case ( var_m_wage,  var_m_non_pec_norm, var_m_job_length )

            if( mygrid_inout % iv( var_m_job ) .eq. 1) then

               mygrid_inout % rv(i) = bounds_func( mygrid_inout % rv(i), &
                  grid_min(i), grid_max(i) )

            else

                mygrid_inout % rv(i) = 0

            end if

         case ( var_m_ui_ben, var_m_unemp_length  )

            if( mygrid_inout % iv( var_m_job ) .eq. 0) then

               mygrid_inout % rv(i) = bounds_func( mygrid_inout % rv(i), &
                  grid_min(i), grid_max(i) )

            else

                mygrid_inout % rv(i) = 0

            end if

         case ( var_wage,  var_non_pec_norm, var_job_length )

            if( mygrid_inout % iv( var_job ) .eq. 1) then

               mygrid_inout % rv(i) = bounds_func( mygrid_inout % rv(i), &
                  grid_min(i), grid_max(i) )

            else

                mygrid_inout % rv(i) = 0

            end if

         case ( var_ui_ben, var_unemp_length )

            if( mygrid_inout % iv( var_job ) .eq. 0) then

               mygrid_inout % rv(i) = bounds_func( mygrid_inout % rv(i), &
                  grid_min(i), grid_max(i) )

            else

                mygrid_inout % rv(i) = 0

            end if

         case default
            print *, "error in select case for getting the choice probabilitiy derivatives"
            stop

      end select

   end do !over i



end subroutine mygrid_bounds_all







end module interp_support_mod







!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module model_probs_mod
   !module for calculating various probabilities in my model

   use model_params_mod
   use enum_mod
   use interp_support_mod
   use normal_mod

contains

function m_joboffer_xb_like_func(mygrid_t_invar_in, mygrid_t_var_in, params_in, seam_in)
   !gets the logit xb argument for the joboffer prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_t_invar_in
   type(mygrid_type), intent(in) :: mygrid_t_var_in
   real*8, dimension(n_params), intent(in) :: params_in
   integer, intent(in) :: seam_in
   real*8 :: m_joboffer_xb_like_func

   m_joboffer_xb_like_func = &
      params_in(param_joboffer_cons) + &
      params_in(param_joboffer_seam)            * seam_in + &
      params_in(param_joboffer_ur)              * mygrid_t_var_in % rv( var_ur_state )  + &
      params_in(param_joboffer_work)            * mygrid_t_var_in % iv( var_m_job ) + &
      params_in(param_joboffer_job_length)      * mygrid_t_var_in % rv( var_m_job_length ) + &
      params_in(param_joboffer_unemp_length)    * mygrid_t_var_in % rv( var_m_unemp_length )

end function m_joboffer_xb_like_func


function joboffer_xb_like_func(mygrid_t_invar_in, mygrid_t_var_in, params_in, seam_in)
   !gets the logit xb argument for the joboffer prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_t_invar_in
   type(mygrid_type), intent(in) :: mygrid_t_var_in
   real*8, dimension(n_params), intent(in) :: params_in
   integer, intent(in) :: seam_in
   real*8 :: joboffer_xb_like_func

   joboffer_xb_like_func = &
      params_in(param_joboffer_cons) + params_in(param_joboffer_gender)  + &
      params_in(param_joboffer_seam)            * seam_in + &
      params_in(param_joboffer_ur)              * mygrid_t_var_in % rv( var_ur_state )  + &
      params_in(param_joboffer_work)            * mygrid_t_var_in % iv( var_job ) + &
      params_in(param_joboffer_job_length)      * mygrid_t_var_in % rv( var_job_length ) + &
      params_in(param_joboffer_unemp_length)    * mygrid_t_var_in % rv( var_unemp_length )

end function joboffer_xb_like_func



function m_joboffer_prob_iter_func(mygrid_in, params_in)
   !gets the joboffer prob for iterating the value function, with the time-invariant mean as one of
      !the inputs

   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: m_joboffer_prob_iter_func, xb_temp

   xb_temp = &
      params_in(param_joboffer_cons) + &
      params_in(param_joboffer_seam)*.25  + &
      params_in(param_joboffer_ur)              * mygrid_in % rv( var_ur_state )  + &
      params_in(param_joboffer_work)            * mygrid_in % iv( var_m_job ) + &
      params_in(param_joboffer_job_length)      * mygrid_in % rv( var_m_job_length ) + &
      params_in(param_joboffer_unemp_length)    * mygrid_in % rv( var_m_unemp_length )

   m_joboffer_prob_iter_func = logit_prob(xb_temp)

end function m_joboffer_prob_iter_func

function joboffer_prob_iter_func(mygrid_in, params_in)
   !gets the joboffer prob for iterating the value function, with the time-invariant mean as one of
      !the inputs

   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: joboffer_prob_iter_func, xb_temp

   xb_temp = &
      params_in(param_joboffer_cons) + params_in(param_joboffer_gender)  + &
      params_in(param_joboffer_seam)*.25  + &
      params_in(param_joboffer_ur)              * mygrid_in % rv( var_ur_state )  + &
      params_in(param_joboffer_work)            * mygrid_in % iv( var_job ) + &
      params_in(param_joboffer_job_length)      * mygrid_in % rv( var_job_length ) + &
      params_in(param_joboffer_unemp_length)    * mygrid_in % rv( var_unemp_length )

   joboffer_prob_iter_func = logit_prob(xb_temp)

end function joboffer_prob_iter_func

function m_wage_xb_func(mygrid_t_invar_in, mygrid_t_var_in, params_in, m_hours_new_in)
   !gets the logit xb argument for the wage prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_t_invar_in
   type(mygrid_type), intent(in) :: mygrid_t_var_in
   real*8, dimension(n_params), intent(in) :: params_in
   integer, intent(in) :: m_hours_new_in
   real*8 :: m_wage_xb_func
   real*8 :: hours_xb


   if (m_hours_new_in .eq. 20) then
      hours_xb = params_in(param_wage_pt)
   else
      hours_xb = 0
   end if

   m_wage_xb_func = mygrid_t_invar_in % rv( var_m_wage_mean ) + hours_xb + &
      params_in(param_wage_ur) * mygrid_t_var_in % rv( var_ur_state )


end function m_wage_xb_func


function wage_xb_func(mygrid_t_invar_in, mygrid_t_var_in, params_in, hours_new_in)
   !gets the logit xb argument for the wage prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_t_invar_in
   type(mygrid_type), intent(in) :: mygrid_t_var_in
   real*8, dimension(n_params), intent(in) :: params_in
   integer, intent(in) :: hours_new_in
   real*8 :: wage_xb_func
   real*8 :: hours_xb


   if (hours_new_in .eq. 20) then
      hours_xb = params_in(param_wage_pt)
   else
      hours_xb = 0
   end if

   wage_xb_func = mygrid_t_invar_in % rv(var_wage_mean) + hours_xb + &
      params_in(param_wage_ur) * mygrid_t_var_in % rv( var_ur_state )


end function wage_xb_func


function m_wage_new_func(mygrid_in, params_in, rand_normal_in)
   !gets new wage for husband given a standard normal and the mygrid with new hours
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8, intent(in) :: rand_normal_in
   real*8 :: m_wage_new_func

   real*8 :: m_wage_xb
   real*8 :: hours_xb

   if ( mygrid_in % iv( var_m_hours) .eq. 20) then
      hours_xb = params_in(param_wage_pt)
   else
      hours_xb = 0
   end if

   m_wage_xb = mygrid_in % rv( var_m_wage_mean ) + hours_xb + &
      params_in(param_wage_ur) * mygrid_in % rv( var_ur_state )

   m_wage_new_func = exp( m_wage_xb + params_in( param_sd_wage ) * rand_normal_in )


end function m_wage_new_func


function wage_new_func(mygrid_in, params_in, rand_normal_in)
   !gets new wage for husband given a standard normal and the mygrid with the new hours
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8, intent(in) :: rand_normal_in
   real*8 :: wage_new_func

   real*8 :: wage_xb
   real*8 :: hours_xb

   if ( mygrid_in % iv( var_hours) .eq. 20) then
      hours_xb = params_in(param_wage_pt)
   else
      hours_xb = 0
   end if

   wage_xb = mygrid_in % rv( var_wage_mean ) + hours_xb + &
      params_in(param_wage_ur) * mygrid_in % rv( var_ur_state )

   wage_new_func = exp( wage_xb + params_in( param_sd_wage ) * rand_normal_in )


end function wage_new_func






function m_ln_wage_prob_func(m_wage_in, m_wage_xb_in, params_in)
   !gets the ln of the husband's wage probs, incoroprating how I put bounds on wags

   real*8, intent(in) :: m_wage_in
   real*8, intent(in) :: m_wage_xb_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: m_ln_wage_prob_func


!   if (  ( m_wage_in > ( grid_min(var_m_wage) + zero_tol ) ) .and. &
!         ( m_wage_in < ( grid_max(var_m_wage) - zero_tol ) )  ) then

      m_ln_wage_prob_func = &
         ln_pdf_norm(   log( m_wage_in), &
                        m_wage_xb_in, &
                        params_in(param_sd_wage) )

!   else if ( m_wage_in <= ( grid_min(var_m_wage) + zero_tol ) ) then
!      m_ln_wage_prob_func = &
!         log( cdf_norm( log( grid_min(var_m_wage) ), m_wage_xb_in,  params_in(param_sd_wage) ) )

!   else
!       m_ln_wage_prob_func = &
!         log( 1- cdf_norm( log( grid_max(var_m_wage) ), m_wage_xb_in,  params_in(param_sd_wage) ) )

!   end if


end function m_ln_wage_prob_func

function ln_wage_prob_func(wage_in, wage_xb_in, params_in)
   !gets the ln of the husband's wage probs, incoroprating how I put bounds on wags

   real*8, intent(in) :: wage_in
   real*8, intent(in) :: wage_xb_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: ln_wage_prob_func


!   if (  ( wage_in > ( grid_min(var_wage) + zero_tol ) ) .and. &
!         ( wage_in < ( grid_max(var_wage) - zero_tol ) )  ) then

      ln_wage_prob_func = &
         ln_pdf_norm(   log( wage_in), &
                        wage_xb_in, &
                        params_in(param_sd_wage) )

!   else if ( wage_in <= ( grid_min(var_wage) + zero_tol ) ) then
!      ln_wage_prob_func = &
!         log( cdf_norm( log( grid_min(var_wage) ), wage_xb_in,  params_in(param_sd_wage) ) )

!   else
!       ln_wage_prob_func = &
!         log( 1- cdf_norm( log( grid_max(var_wage) ), wage_xb_in,  params_in(param_sd_wage) ) )

!   end if


end function ln_wage_prob_func




function m_jobloss_xb_like_func(mygrid_t_invar_in, mygrid_t_var_in, params_in, seam_in)
   !gets the logit xb argument for the joboffer prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_t_invar_in
   type(mygrid_type), intent(in) :: mygrid_t_var_in
   real*8, dimension(n_params), intent(in) :: params_in
   integer, intent(in) :: seam_in
   real*8 :: m_jobloss_xb_like_func

   m_jobloss_xb_like_func = &
      params_in(param_jobloss_cons) + &
      params_in(param_jobloss_seam_future)     * seam_in + &
      params_in(param_jobloss_ur)              * mygrid_t_var_in % rv( var_ur_state )  + &
      params_in(param_jobloss_job_length)      * mygrid_t_var_in % rv( var_m_job_length )

end function m_jobloss_xb_like_func

function jobloss_xb_like_func(mygrid_t_invar_in, mygrid_t_var_in, params_in, seam_in)
   !gets the logit xb argument for the joboffer prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_t_invar_in
   type(mygrid_type), intent(in) :: mygrid_t_var_in
   real*8, dimension(n_params), intent(in) :: params_in
   integer, intent(in) :: seam_in
   real*8 :: jobloss_xb_like_func

   jobloss_xb_like_func = &
      params_in(param_jobloss_cons)  + params_in(param_jobloss_gender) + &
      params_in(param_jobloss_seam_future)     * seam_in + &
      params_in(param_jobloss_ur)              * mygrid_t_var_in % rv( var_ur_state )  + &
      params_in(param_jobloss_job_length)      * mygrid_t_var_in % rv( var_job_length )

end function jobloss_xb_like_func

function m_jobloss_prob_iter_func(mygrid_in, params_in)
   !gets the logit xb argument for the joboffer prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: m_jobloss_prob_iter_func

   real*8 :: xb_temp

   xb_temp = &
      params_in(param_jobloss_cons) + &
      params_in(param_jobloss_seam_future)*.25    + &
      params_in(param_jobloss_ur)              * mygrid_in % rv( var_ur_state )  + &
      params_in(param_jobloss_job_length)      * mygrid_in % rv( var_m_job_length )

    m_jobloss_prob_iter_func = logit_prob(xb_temp)

end function m_jobloss_prob_iter_func


function jobloss_prob_iter_func(mygrid_in, params_in)
   !gets the logit xb argument for the joboffer prob for evaluating the likelihood, given that I've
      !already gotten the time-invariant part of the mean
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: jobloss_prob_iter_func

   real*8 :: xb_temp

   xb_temp = &
      params_in(param_jobloss_cons)  + params_in(param_jobloss_gender) + &
      params_in(param_jobloss_seam_future)*.25  + &
      params_in(param_jobloss_ur)              * mygrid_in % rv( var_ur_state )  + &
      params_in(param_jobloss_job_length)      * mygrid_in % rv( var_job_length )

    jobloss_prob_iter_func = logit_prob(xb_temp)

end function jobloss_prob_iter_func

function birth_prob_iter_func(mygrid_in, params_in)
   !for birth prob
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: birth_prob_iter_func

   real*8 :: xb_temp

   xb_temp = params_in(param_birth_cons) + &
      params_in(param_birth_kids) *  mygrid_in % rv( var_kids ) + &
      params_in(param_birth_youngest) * mygrid_in % rv( var_youngest )

   birth_prob_iter_func = logit_prob(xb_temp)


end function birth_prob_iter_func



function m_ui_prob_iter_func(mygrid_in, params_in)
   !for m_ui prob
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: m_ui_prob_iter_func

   real*8 :: xb_temp

   xb_temp = params_in(param_ui_cons) + &
      params_in( param_ui_ur ) *  mygrid_in % rv( var_ur_state )

   m_ui_prob_iter_func = logit_prob(xb_temp)

end function m_ui_prob_iter_func


function ui_prob_iter_func(mygrid_in, params_in)
   !for m_ui prob
   type(mygrid_type), intent(in) :: mygrid_in
   real*8, dimension(n_params), intent(in) :: params_in
   real*8 :: ui_prob_iter_func

   real*8 :: xb_temp

   xb_temp = params_in(param_ui_cons) + params_in(param_ui_gender) + &
      params_in( param_ui_ur ) *  mygrid_in % rv( var_ur_state )

   ui_prob_iter_func = logit_prob(xb_temp)

end function ui_prob_iter_func




end module model_probs_mod





