program param_draw_test
!test the accept/reject new params subroutine

use enum_mod
use model_params_mod
use interp_support_mod

use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use likelihood_mod
use bayesian_mod

use csv_file
use random_gen_mod
use mpi_mod

   character(len=30),parameter :: init_params_file = "init_params_sept24.txt"
   character(len=30),parameter :: sipp_data_file= "sipp_fortran_small.csv"
   character(len=30)          :: interact_file = "interact_matrix.csv"
   character(len=30), parameter :: seed_file = "seed_save5.txt"





   type(bayes_obj_type) :: bayes_obj
   type(like_type), dimension(:), allocatable :: like_object
   type(like_target_type), dimension(:), allocatable :: like_target
   type(data_i_type), dimension(:), allocatable ::  hh_data

   real*8, dimension(n_main_params) :: params_old, params_new
   integer :: i, t, b,j,block_in,n_params_block_in
   integer, dimension(:), pointer :: block_in_list
   real*8 :: like_print_temp

   integer, parameter :: i_print = 2
   integer, parameter :: t_print = 5

   real*8, dimension(iter_m_job_offer: iter_hours,N_t,n_obs_total) :: joboffer_random
   real*8, dimension(n_obs_total) ::  mh_random


   call mpi_setup

   !first setup based on block of interest
   block_in = block_leisure_params3
   block_in_list => leisure_block3_list
   n_params_block_in = n_params_leisure_block3



   print *, "i_print ", i_print
   print *, "t_print ", t_print
   print *, " "


   !initialize random numbers
   call init_random_seed_mpi(same = .false. )
   call export_random_seed_mpi()
 !  call read_random_seed_mpi( same = .false.)

   call gen_labels()
   call interp_setup_all( interact_file )

   call read_sipp_data(sipp_data_file, hh_data)
   call bayes_obj % setup(init_params_file)

 !  if (iter .eq. 22001 ) then
   !   rw_chol_joboffer_block = 0
   !   rw_chol_wage_block = 0
   !   rw_chol_leisure_block = 0
      print_extra = .true.


   bayes_obj % iter = 1

   !read in other ols vecs if I want
   if (read_interp_matrices .eqv. .true. ) then
      call read_interp_init( bayes_obj )

   end if


   print *, "about to setup like object"

   call like_setup_all( hh_data, &
                        bayes_obj % params_current, &
                        est_savings, &
                        bayes_obj % value_matrix_current, &
                        bayes_obj % asset_matrix_current, &
                        like_object, &
                        like_target )

   like_print_temp = log_like_func_all( like_object, block_in )

   if( myrank .eq. 0 ) print *, "log like func", like_print_temp

   print *, "done with setup"


 !  call like_object(2) % mygrid_t_var(2) % print( .false., .true.)

  ! call interp_matrix_write( bayes_obj % asset_matrix_current, output_unit )
 !  stop

   print *, "   "
   params_old(:n_main_params) = bayes_obj % params_current(:n_main_params)





   !switch individual variables
   !do one loop first

   if( bayes_obj % iter .eq. 0) bayes_obj % iter=1

   call random_number(joboffer_random)
   call random_number(mh_random)
   call mh_step_ind( bayes_obj, block_joboffers_ind, hh_data, like_object, like_target, &
                     joboffer_random(:,:,min_obs:max_obs), mh_random(min_obs:max_obs) )
   print *, "got individual joboffers"


   select case (block_in )

      case( block_joboffer_params1 : block_leisure_params3 )

         call mh_step_params( bayes_obj, block_in, hh_data, like_object, like_target )

      case( block_asset_error_params1: block_asset_error_params1 )

         call mh_step_asset_error( bayes_obj, block_in, hh_data, like_object, like_target  )

      case default
         print *, "error with block_in"
         stop

   end select

   params_new(:n_main_params) = bayes_obj % params_proposal(:n_main_params)



  ! now print out the parameters that are drawn

   if ( myrank .eq. 0 ) then

      print *, "label ", "initial ", "proposal ", "dif "
      do i=1,n_params_block_in
         j=block_in_list(i)
         print *, param_labels(j), params_old(j), params_new(j), params_old(j) - params_new(j)
       ! print *, param_labels(j), params_old(j), params_old(j) - params_new(j)
      end do

      print *, "param accepted?", bayes_obj % accept_history_params( block_in, bayes_obj % iter )

   end if



   !   call like_same_check(like_object, like_target, block_wage_params1)

      call mpi_finalize(err)
      stop


 !  print *, "   "
 !  print *, "-----------------------------------------"
 !  print *, "   "

 !  print *, "now print like targets"
 !  call like_target(i_print) % print(like_object(i_print), t_print)

!   print *, "   "
!   print *, "-----------------------------------------"
!   print *, "   "

!   print *, "now print associations between the like targets"
!   call like_object(i_print) % print_which_like_target(like_target(i_print))

 !  print *, "constant of interest", bayes_obj % ols_vec_current(1)

   call mpi_finalize(err)

end program
