program param_draw_test


use enum_mod
use model_params_mod
use interp_support_mod

use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use likelihood_mod
use bayesian_mod

use csv_file
use random_gen_mod
use mpi_mod


   character(len=30), parameter :: seed_file = "seed_save5.txt"

   type(bayes_obj_type) :: bayes_obj

   real*8, dimension(n_params) :: params_init
   real*8, dimension(n_main_params) :: proposal_params
   integer :: i

   character(len=30),parameter          :: init_params_file = "init_params_sept24.txt"

   call mpi_setup

   !initialize random numbers
   call init_random_seed_mpi(same = .false. )
   call export_random_seed_mpi( seed_file )
 !  call read_random_seed_mpi( same = .false., filename_opt = seed_file)

   print *, "about to setup objects"

   call bayes_obj % setup(init_params_file)

  ! bayes_obj % params_current(param_prob_pt) = .99

   params_init = bayes_obj % params_current

   call gen_param_labels()

   print *, "printing choleksy matrices for the blocks"

!   print *, "joboffer block"
!   do i=1,n_params_joboffer_block
!      print *, rw_chol_joboffer_block(i,:)
!   end do

!   print *, "wage block"
!   do i=1,n_params_wage_block
!      print *, rw_chol_wage_block(i,:)
!   end do

!   print *, "leisure block"
!   do i=1,n_params_leisure_block
!      print *, rw_chol_leisure_block(i,:)
!   end do

!   read(*,*)

   call draw_new_params(block_wage_params1, params_init,proposal_params)

   params_init = bayes_obj % params_current

   print *, "label ", "initial ", "proposal ", "dif "
   do i=1,n_main_params
      print *, param_labels(i), params_init(i), proposal_params(i), proposal_params(i) - params_init(i)
   end do


   call mpi_finalize(err)


end program
