program rw_cov_init
   !creates the random walk covariance matrix input files
   
   use bayesian_mod
      
   integer,parameter :: n_simulation_draws = 10000   
   type(bayesian_object_type) :: bayesian_object
   real*8,parameter :: random_walk_scalar = 1
   real*8, dimension(n_main_params) :: mean_temp
   real*8, dimension(n_main_params) :: sd_temp
   real*8, dimension(n_main_params,n_main_params) :: cov_temp, chol_temp
   integer :: i,j
  
     call lists_init()
  
   sd_temp(param_joboffer_cons) = .1 * random_walk_scalar
   sd_temp(param_joboffer_ur) = .01 * random_walk_scalar
   sd_temp(param_joboffer_work) = .05 * random_walk_scalar
!   sd_temp(param_joboffer_age) = .01 * random_walk_scalar
!   sd_temp(param_joboffer_age2) = .001 * random_walk_scalar
!   sd_temp(param_joboffer_race) = .01 * random_walk_scalar
!   sd_temp(param_joboffer_hs) = .01 * random_walk_scalar
!   sd_temp(param_joboffer_some_college) = .01 * random_walk_scalar
!   sd_temp(param_joboffer_college) = .01 * random_walk_scalar
   sd_temp(param_joboffer_gender) = .02 * random_walk_scalar
   sd_temp(param_joboffer_seam) = .05 * random_walk_scalar
      
   sd_temp(param_wage_cons) = .1 * random_walk_scalar
   sd_temp(param_wage_pt) = .04 * random_walk_scalar
   sd_temp(param_wage_ur) = .001 * random_walk_scalar
   sd_temp(param_wage_age) = .01 * random_walk_scalar
   sd_temp(param_wage_age2) = .001 * random_walk_scalar
   sd_temp(param_wage_race) = .02 * random_walk_scalar
   sd_temp(param_wage_hs) = .04 * random_walk_scalar
   sd_temp(param_wage_some_college) = .04 * random_walk_scalar
   sd_temp(param_wage_college) = .04 * random_walk_scalar
   sd_temp(param_wage_gender) = .05 * random_walk_scalar
      
   sd_temp(param_m_leisure_cons) = .1 * random_walk_scalar
!   sd_temp(param_m_leisure_age) = .01 * random_walk_scalar
!   sd_temp(param_m_leisure_age2) = .001 * random_walk_scalar
!   sd_temp(param_m_leisure_race) = .01 * random_walk_scalar
!   sd_temp(param_m_leisure_hs) = .01 * random_walk_scalar
!   sd_temp(param_m_leisure_some_college) = .01 * random_walk_scalar
!   sd_temp(param_m_leisure_college) = .01 * random_walk_scalar
!   sd_temp(param_m_leisure_kids) = .01 * random_walk_scalar
!   sd_temp(param_m_leisure_youngest) = .01 * random_walk_scalar
      
   sd_temp(param_leisure_cons) = .1 * random_walk_scalar
   sd_temp(param_leisure_age) = .01 * random_walk_scalar
   sd_temp(param_leisure_age2) = .001 * random_walk_scalar
!   sd_temp(param_leisure_race) = .01 * random_walk_scalar
!   sd_temp(param_leisure_hs) = .01 * random_walk_scalar
!   sd_temp(param_leisure_some_college) = .01 * random_walk_scalar
!   sd_temp(param_leisure_college) = .01 * random_walk_scalar
   sd_temp(param_leisure_kids) = .01 * random_walk_scalar
   sd_temp(param_leisure_youngest) = .01 * random_walk_scalar
      
   sd_temp(param_sd_non_pec) = .1 * random_walk_scalar
   sd_temp(param_sd_wage) = .1 * random_walk_scalar
   sd_temp(param_prob_pt) = .01 * random_walk_scalar
   sd_temp(param_weight_utility) = .1 * random_walk_scalar
   
   !need to square it to get variances
   sd_temp = sd_temp * sd_temp
  
   cov_temp = 0
   do i=1,n_main_params
       cov_temp(i,i) = sd_temp(i)
   end do
   
   call chol_decomp_sub(n_main_params, cov_temp, chol_temp )

!   !now draw simulated random parameters to test this subroutine
!   bayesian_object % iter = n_simulation_draws
   
!   call init_params(bayesian_object % params_current)
!   mean_temp = bayesian_object % params_current(1:n_main_params)
!   call param_predraw_convert(mean_temp)
   

   
   
!   do i=1,n_simulation_draws
!      call get_random_mvn( n_main_params, &
!                           mean_temp, &
!                           chol_temp, &
!                           bayesian_object % params_history(:,i))
      
!      call param_postdraw_convert(  bayesian_object % params_history(:,i) )

!   end do

   !now export the files
   call bayesian_object % random_walk_write(cov_temp)

end program 
