clear all

global pathmpi  /h1/j/js/jse4fp/sipp_fortran_mpi/
global pathdata  /h1/j/js/jse4fp/sipp_datawork/

*first mess with the simulated data
insheet using ${pathmpi}stationary_dist.csv, comma clear

keep m_job job wage m_wage assets

gen employment = 0
replace employment = 1 if m_job == 0 & job == 0
replace employment = 2 if m_job == 1 & job == 0
replace employment = 3 if m_job == 0 & job == 1
replace employment = 4 if m_job == 1 & job == 1

label define employment 1 "Both Not Working" 2 "Husband Working" 3 "Wife Working" 4 "Both Working" 
label values employment employment

gen obsdata = 0

tempfile sim

save `sim', replace

use ${pathdata}sipp_fortran_big.dta, clear


replace m_wage = 45 if m_wage>45 & m_job==1
replace wage = 45 if wage>45 & job==1

gen assets =.
replace assets = liquid_net1 if liquid_time1 ~= -1
replace assets = liquid_net2 if liquid_time2 ~= -1
replace assets = liquid_net3 if liquid_time3 ~= -1

replace assets = 1 if assets < 1
replace assets = 250000 if assets > 250000

gen m_original_job04 = 0
replace m_original_job = 1 if time ==1 & m_job ==1 & spanel ==2004

gen m_new_job04 = 0
replace m_new_job04 = 1      if time > 1 & m_job ==1 & spanel == 2004 & (l.m_job_no ~= m_job_no)


keep m_job job wage m_wage assets m_original_job04 m_new_job04

gen employment = 0
replace employment = 1 if m_job == 0 & job == 0
replace employment = 2 if m_job == 1 & job == 0
replace employment = 3 if m_job == 0 & job == 1
replace employment = 4 if m_job == 1 & job == 1
label values employment employment

gen obsdata = 1

append using `sim'

save ${pathmpi}stationary_data.dta, replace


*now get means and percentiles and store them
gen both_nowork 	= employment == 1
gen husband_work 	= employment == 2
gen wife_work 		= employment == 3
gen both_work 		= employment == 4

sum both_nowork if obsdata == 1
global frac_both_nowork1 = r(mean) 
sum both_nowork if obsdata == 0
global frac_both_nowork2 = r(mean) 

sum husband_work if obsdata == 1
global frac_husband_work1 = r(mean) 
sum husband_work if obsdata == 0
global frac_husband_work2 = r(mean) 

sum wife_work if obsdata == 1
global frac_wife_work1 = r(mean) 
sum wife_work if obsdata == 0
global frac_wife_work2 = r(mean) 

sum both_work if obsdata == 1
global frac_both_work1 = r(mean) 
sum both_work if obsdata == 0
global frac_both_work2 = r(mean) 

sum m_wage if job ==1 & obsdata == 1, detail
global m_wage_p10_1 = r(p10)
global m_wage_p25_1 = r(p25)
global m_wage_p50_1 = r(p50)
global m_wage_p75_1 = r(p75)
global m_wage_p90_1 = r(p90)

sum m_wage if job ==1 & obsdata == 0, detail
global m_wage_p10_2 = r(p10)
global m_wage_p25_2 = r(p25)
global m_wage_p50_2 = r(p50)
global m_wage_p75_2 = r(p75)
global m_wage_p90_2 = r(p90)

sum wage if job ==1 & obsdata == 1, detail
global wage_p10_1 = r(p10)
global wage_p25_1 = r(p25)
global wage_p50_1 = r(p50)
global wage_p75_1 = r(p75)
global wage_p90_1 = r(p90)

sum wage if job ==1 & obsdata == 0, detail
global wage_p10_2 = r(p10)
global wage_p25_2 = r(p25)
global wage_p50_2 = r(p50)
global wage_p75_2 = r(p75)
global wage_p90_2 = r(p90)

sum assets if obsdata == 1, detail
global assets_p10_1 = r(p10)
global assets_p25_1 = r(p25)
global assets_p50_1 = r(p50)
global assets_p75_1 = r(p75)
global assets_p90_1 = r(p90)

sum assets if obsdata == 0, detail
global assets_p10_2 = r(p10)
global assets_p25_2 = r(p25)
global assets_p50_2 = r(p50)
global assets_p75_2 = r(p75)
global assets_p90_2 = r(p90)

*now for comparison with wages and the start of the panel vs jobs that were accepted

sum m_wage if m_original_job04 == 1, detail
global m_wage_p10_original = r(p10)
global m_wage_p25_original = r(p25)
global m_wage_p50_original = r(p50)
global m_wage_p75_original = r(p75)
global m_wage_p90_original = r(p90)

sum m_wage if m_new_job04 == 1, detail
global m_wage_p10_new = r(p10)
global m_wage_p25_new = r(p25)
global m_wage_p50_new = r(p50)
global m_wage_p75_new = r(p75)
global m_wage_p90_new = r(p90)


gen m_wage_percentile_data = .
replace m_wage_percentile_data = ${m_wage_p10_1} in 1
replace m_wage_percentile_data = ${m_wage_p25_1} in 2
replace m_wage_percentile_data = ${m_wage_p50_1} in 3
replace m_wage_percentile_data = ${m_wage_p75_1} in 4
replace m_wage_percentile_data = ${m_wage_p90_1} in 5

gen m_wage_percentile_sim = .
replace m_wage_percentile_sim = ${m_wage_p10_2} in 1
replace m_wage_percentile_sim = ${m_wage_p25_2} in 2
replace m_wage_percentile_sim = ${m_wage_p50_2} in 3
replace m_wage_percentile_sim = ${m_wage_p75_2} in 4
replace m_wage_percentile_sim = ${m_wage_p90_2} in 5



gen wage_percentile_data = .
replace wage_percentile_data = ${wage_p10_1} in 1
replace wage_percentile_data = ${wage_p25_1} in 2
replace wage_percentile_data = ${wage_p50_1} in 3
replace wage_percentile_data = ${wage_p75_1} in 4
replace wage_percentile_data = ${wage_p90_1} in 5

gen wage_percentile_sim = .
replace wage_percentile_sim = ${wage_p10_2} in 1
replace wage_percentile_sim = ${wage_p25_2} in 2
replace wage_percentile_sim = ${wage_p50_2} in 3
replace wage_percentile_sim = ${wage_p75_2} in 4
replace wage_percentile_sim = ${wage_p90_2} in 5

gen assets_percentile_data = .
replace assets_percentile_data = ${assets_p10_1} in 1
replace assets_percentile_data = ${assets_p25_1} in 2
replace assets_percentile_data = ${assets_p50_1} in 3
replace assets_percentile_data = ${assets_p75_1} in 4
replace assets_percentile_data = ${assets_p90_1} in 5

gen assets_percentile_sim = .
replace assets_percentile_sim = ${assets_p10_2} in 1
replace assets_percentile_sim = ${assets_p25_2} in 2
replace assets_percentile_sim = ${assets_p50_2} in 3
replace assets_percentile_sim = ${assets_p75_2} in 4
replace assets_percentile_sim = ${assets_p90_2} in 5


outsheet m_wage_percentile_data- assets_percentile_sim using ${pathmpi}input_stationary1.csv in 1/5, comma replace



gen emp_dist_data = .
replace emp_dist_data = ${frac_both_nowork1} in 1
replace emp_dist_data = ${frac_husband_work1} in 2
replace emp_dist_data = ${frac_wife_work1} in 3
replace emp_dist_data = ${frac_both_work1} in 4

gen emp_dist_sim = .
replace emp_dist_sim = ${frac_both_nowork2} in 1
replace emp_dist_sim = ${frac_husband_work2} in 2
replace emp_dist_sim = ${frac_wife_work2} in 3
replace emp_dist_sim = ${frac_both_work2} in 4

outsheet emp_dist_data emp_dist_sim using ${pathmpi}input_stationary2.csv in 1/4, comma replace


gen m_wage_percentile_original = .
replace m_wage_percentile_original = ${m_wage_p10_original} in 1
replace m_wage_percentile_original = ${m_wage_p25_original} in 2
replace m_wage_percentile_original = ${m_wage_p50_original} in 3
replace m_wage_percentile_original = ${m_wage_p75_original} in 4
replace m_wage_percentile_original = ${m_wage_p90_original} in 5

gen m_wage_percentile_new = .
replace m_wage_percentile_new = ${m_wage_p10_new} in 1
replace m_wage_percentile_new = ${m_wage_p25_new} in 2
replace m_wage_percentile_new = ${m_wage_p50_new} in 3
replace m_wage_percentile_new = ${m_wage_p75_new} in 4
replace m_wage_percentile_new = ${m_wage_p90_new} in 5

outsheet  m_wage_percentile_original m_wage_percentile_new using ${pathmpi}input_stationary3.csv in 1/5, comma replace

save ${pathmpi}stationary_data.dta, replace

*graphical analysis for the model fit

/*

twoway (kdensity m_wage if m_job == 1 & obsdata == 1) (kdensity m_wage if m_job == 1 & obsdata == 0), /// 
ytitle(Kernel Density) xtitle(Husband's Wage) title(Model Fit of Husband's Wage Distribution) ///
legend(order (1 "Real Data" 2 "Simulated Data" )) scheme(s1color)

graph export m_wage_fit.png, replace

twoway (kdensity wage if job == 1 & obsdata == 1) (kdensity wage if job == 1 & obsdata == 0), /// 
ytitle(Kernel Density) xtitle(Wife's Wage) title(Model Fit of Wife's Wage Distribution) ///
legend(order (1 "Real Data" 2 "Simulated Data" )) scheme(s1color)

graph export wage_fit.png, replace

/*
twoway (kdensity assets if obsdata == 1) (kdensity assets if obsdata == 0), /// 
ytitle(Kernel Density) xtitle(Liquid Assets) title(Model Fit of Household's Asset Distribution) ///
legend(order (1 "Real Data" 2 "Simulated Data" )) scheme(s1color)

graph export asset_fit.png, replace


*setup some stuff to run the do file which generates the employment frequencies


global n_samples = 2

global label_sample1 = "Real Data"
global label_sample2 = "Simulated Data"

global bar_title = "Model Fit of Household's Employment Distribution"
global save_file = "employment_fit.png"

clear 

do ${pathmpi}bar_chart/bar_prog.do

*/









