clear all

global pathmpi  /h1/j/js/jse4fp/sipp_fortran_mpi/
global pathdata  /h1/j/js/jse4fp/sipp_datawork/

use ${pathmpi}stationary_data.dta, 

*graphical analysis for the model fit

twoway (kdensity m_wage if m_job == 1 & obsdata == 1) (kdensity m_wage if m_job == 1 & obsdata == 0), /// 
ytitle(Kernel Density) xtitle(Husband's Wage) title(Model Fit of Husband's Wage Distribution) ///
legend(order (1 "Real Data" 2 "Simulated Data" )) scheme(s1color)

graph export m_wage_fit.png, replace

twoway (kdensity wage if job == 1 & obsdata == 1) (kdensity wage if job == 1 & obsdata == 0), /// 
ytitle(Kernel Density) xtitle(Wife's Wage) title(Model Fit of Wife's Wage Distribution) ///
legend(order (1 "Real Data" 2 "Simulated Data" )) scheme(s1color)

graph export wage_fit.png, replace

/*
twoway (kdensity assets if obsdata == 1) (kdensity assets if obsdata == 0), /// 
ytitle(Kernel Density) xtitle(Liquid Assets) title(Model Fit of Household's Asset Distribution) ///
legend(order (1 "Real Data" 2 "Simulated Data" )) scheme(s1color)

graph export asset_fit.png, replace

*/

*setup some stuff to run the do file which generates the employment frequencies


global n_samples = 2

global label_sample1 = "Real Data"
global label_sample2 = "Simulated Data"

global bar_title = "Model Fit of Household's Employment Distribution"
global save_file = "employment_fit.png"


global frac_both_nowork1 = emp_dist_data[1]   
global frac_husband_work1 = emp_dist_data[2] 
global frac_wife_work1 = emp_dist_data[3] 
global frac_both_work1 = emp_dist_data[4] 


global frac_both_nowork2 = emp_dist_sim[1]
global frac_husband_work2 = emp_dist_sim[2] 
global frac_wife_work2 = emp_dist_sim[3]
global frac_both_work2 = emp_dist_sim[4] 

clear 

do ${pathmpi}bar_chart/bar_prog.do











