program iterate_test2

use enum_mod
use model_params_mod
use interp_support_mod


use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use normal_mod
use stat_estimates_mod

use csv_file


implicit none


   character(len=30),parameter :: init_params_file  = "init_params_new.txt"
   integer:: i,m_job,job
   real*8:: hours,m_hours

   real*8, dimension(n_cont_vars) :: derivative
   real*8 :: utility_origin, utility_peturb
   real*8 :: asset_choice
   real*8, dimension(n_utility_params) :: utility_params

   type(mygrid_type) :: mygrid, mygrid_origin
   real*8, dimension(n_params)  :: params



!!!!!!!!!!!!!!!!!




   !now read in the parameters
   call init_params(init_params_file, params)

   call interp_list_setup_all()
   call gen_param_labels()
   call gen_var_labels()
   call der_delta_setup



   !get the origin point
   m_job=1
   job=1

   call get_mygrid_origin(job, m_job, mygrid)
      call mygrid % print(.true., .true.)

   mygrid_origin = mygrid

   call utility_function_setup(  &
      mygrid % rv(var_kids), &
      mygrid % rv(var_youngest), &
      params, &
      utility_params )

   asset_choice = mygrid % rv( var_assets )
   utility_origin = utility_function( mygrid, asset_choice, utility_params, params )


 !  call iterate_origin % mygrid % print(.true.)
 !  read(*,*)


   print *, "origin utility value", utility_origin
 !  print *, "origin utility params"
 !  call print_utility_params( iterate_origin % utility_params )
 !  read(*,*)

   !now get derivatives
   call gen_var_labels()
   print *, "getting derivatives"
   do i=1,n_cont_vars
      if (var_present(i, job, m_job) .eq. 1) then
         mygrid = mygrid_origin
         mygrid % rv(i) = mygrid % rv(i) + der_delta(i)

         call utility_function_setup(  &
            mygrid % rv(var_kids), &
            mygrid % rv(var_youngest), &
            params, &
            utility_params )

            asset_choice = mygrid % rv( var_assets )
            utility_peturb =  utility_function( mygrid, asset_choice, utility_params, params )



        ! print *, "peturb utility params"
       !  call print_utility_params( iterate_peturb % utility_params )

      !   print *, "dif in utility params", sum(iterate_origin % utility_params - iterate_peturb % utility_params)

         derivative(i) = utility_peturb - utility_origin
         print *, i, var_labels(i),  derivative(i)
      end if

   end do

   print *, "pause"
 !  read(*,*)










end program
