program like_test

!tests the differences between two value functions to see if they're reasonable

use enum_mod
use model_params_mod
use interp_support_mod

use utility_function_mod
use model_probs_mod
use logit_mod

use iterate_object_mod
use value_grid_object_mod
use iterate_mod

use likelihood_mod
use sipp_data_mod

use normal_mod
use stat_estimates_mod

use csv_file

!use statespace_trans_params_mod


implicit none

   character(len=30),parameter :: init_params_file       = "init_params_new.txt"
   character(len=30),parameter :: interact_file_in       = "interact_matrix.csv"
   character(len=30),parameter :: value_matrix_init_file = "value_matrix_out.csv"
   character(len=30),parameter :: asset_matrix_init_file = "asset_matrix_out.csv"



   real*8, dimension(n_params) :: params
   real*8, dimension( max_n_grid_points, 0:1,0:1 ) :: value_matrix_init
   real*8, dimension( max_n_grid_points, 0:1,0:1 ) :: asset_matrix_init


   type(like_type)   :: like_object
   type(mygrid_type) :: mygrid1, mygrid2


   integer :: i,t,m_job, job
   real*8 :: asset_choice, value1, value2, val_dif, val_dif_perturb
   integer :: unit_int


   !now read in the parameters
   call init_params(init_params_file, params)

   call gen_var_labels()
   call der_delta_setup()
   call interp_list_setup_all(interact_file_in)

   !init ols matrix to 0
   call init_interp_matrices( value_matrix_init_file, asset_matrix_init_file, value_matrix_init, asset_matrix_init )


   m_job = 0
   job =0

   call get_mygrid_origin(m_job, job, mygrid1)

   mygrid1 % rv( var_m_ui_ben ) = 20
   mygrid1 % rv( var_ui_ben ) = 20
   mygrid1 % rv( var_assets ) = 3000

   m_job = 1
   job = 0

   call get_mygrid_origin(m_job, job, mygrid2)

 !  mygrid2 % rv( var_m_ui_ben ) = 20
   mygrid2 % rv( var_ui_ben ) = 20
   mygrid2 % rv( var_assets ) = 3000

   mygrid2 % rv( var_non_pec_norm ) = 1


   !get values
   asset_choice = asset_policy_func(mygrid1, asset_matrix_init )
   value1 = value_function( mygrid1, asset_choice, value_matrix_init )

   asset_choice = asset_policy_func(mygrid2, asset_matrix_init )
   value2 = value_function( mygrid2, asset_choice, value_matrix_init )

   val_dif = value2 - value1



   print *, "value1", value1
   print *, "value2", value2
   print *, "dif", val_dif, "logit of dif", logit_prob( val_dif )

   print *, " "
   print *, "perturbing"




 !  mygrid1 % rv( var_m_ui_ben ) = grid_mean( var_m_ui_ben )


   mygrid1 % rv( var_assets ) = grid_mean( var_assets )
   mygrid2 % rv( var_assets ) = grid_mean( var_assets )

  ! mygrid1 % rv( var_assets ) = 3000 + 100
  ! mygrid2 % rv( var_assets ) = 3000 + 100










   asset_choice = asset_policy_func(mygrid1, asset_matrix_init )
   value1 = value_function( mygrid1, asset_choice, value_matrix_init )

   asset_choice = asset_policy_func(mygrid2, asset_matrix_init )
   value2 = value_function( mygrid2, asset_choice, value_matrix_init )

   val_dif_perturb = value2 - value1

   print *, "value1", value1
   print *, "value2", value2
   print *, "dif", val_dif_perturb, "logit of dif", logit_prob( val_dif_perturb )
   print *, "dif in dif", val_dif_perturb - val_dif



end program

